#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 504
#define LARGE_STATE_COUNT 87
#define SYMBOL_COUNT 244
#define ALIAS_COUNT 1
#define TOKEN_COUNT 109
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 7
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 20

enum {
  anon_sym_DQUOTE = 1,
  aux_sym_legacy_quoted_command_token1 = 2,
  anon_sym_TILDE = 3,
  sym_grep_specifier_identifier = 4,
  aux_sym_grep_specifier_token1 = 5,
  anon_sym_PIPE = 6,
  anon_sym_PIPEH = 7,
  sym_pipe_second_command = 8,
  anon_sym_AT_AT_DOT = 9,
  anon_sym_AT_AT_EQ = 10,
  anon_sym_AT_AT_AT_EQ = 11,
  anon_sym_AT_AT = 12,
  anon_sym_AT_ATc_COLON = 13,
  anon_sym_AT_AT_ATc_COLON = 14,
  anon_sym_AT_ATC = 15,
  anon_sym_COLON = 16,
  anon_sym_AT_ATdbt = 17,
  anon_sym_AT_ATdbta = 18,
  anon_sym_AT_ATdbtb = 19,
  anon_sym_AT_ATdbts = 20,
  anon_sym_AT_ATt = 21,
  anon_sym_AT_ATb = 22,
  anon_sym_AT_ATi = 23,
  anon_sym_AT_ATii = 24,
  anon_sym_AT_ATiS = 25,
  anon_sym_AT_ATiSS = 26,
  anon_sym_AT_ATis = 27,
  anon_sym_AT_ATiz = 28,
  anon_sym_AT_ATf = 29,
  anon_sym_AT_ATF = 30,
  anon_sym_AT_ATom = 31,
  anon_sym_AT_ATdm = 32,
  anon_sym_AT_ATr = 33,
  anon_sym_AT_ATs_COLON = 34,
  anon_sym_AT = 35,
  anon_sym_AT_BANG = 36,
  anon_sym_AT_LPAREN = 37,
  anon_sym_RPAREN = 38,
  anon_sym_ATa_COLON = 39,
  anon_sym_ATb_COLON = 40,
  anon_sym_ATB_COLON = 41,
  anon_sym_ATe_COLON = 42,
  anon_sym_ATF_COLON = 43,
  anon_sym_ATi_COLON = 44,
  anon_sym_ATk_COLON = 45,
  anon_sym_ATo_COLON = 46,
  anon_sym_ATr_COLON = 47,
  anon_sym_ATf_COLON = 48,
  anon_sym_ATs_COLON = 49,
  anon_sym_ATv_COLON = 50,
  anon_sym_ATx_COLON = 51,
  anon_sym_0 = 52,
  aux_sym_number_command_token1 = 53,
  aux_sym__search_command_token1 = 54,
  anon_sym_DOT = 55,
  aux_sym__interpret_command_token1 = 56,
  aux_sym__interpret_command_token2 = 57,
  aux_sym__interpret_command_token3 = 58,
  anon_sym_DOT_BANG = 59,
  anon_sym_DOT_LPAREN = 60,
  anon_sym_PIPE_DOT = 61,
  anon_sym_DOT_SLASH = 62,
  anon_sym_pfo = 63,
  anon_sym_Cf = 64,
  sym_pf_dot_cmd_identifier = 65,
  sym_pf_dot_full_cmd_identifier = 66,
  aux_sym_pf_cmd_token1 = 67,
  anon_sym_EQ = 68,
  aux_sym__pf_dot_arg_identifier_token1 = 69,
  anon_sym_DOLLAR = 70,
  anon_sym_LPAREN = 71,
  aux_sym_pf_arg_identifier_token1 = 72,
  anon_sym_PERCENT = 73,
  anon_sym_env = 74,
  anon_sym_DOT_DOT_DOT = 75,
  sym_system_identifier = 76,
  sym_question_mark_identifier = 77,
  sym_pointer_identifier = 78,
  sym_macro_identifier = 79,
  anon_sym_SEMI = 80,
  anon_sym_GT = 81,
  anon_sym_GT_GT = 82,
  sym_html_redirect_operator = 83,
  sym_html_append_operator = 84,
  anon_sym_COMMA = 85,
  aux_sym_tmp_eval_arg_token1 = 86,
  sym__eq_sep_key_identifier = 87,
  sym__any_command = 88,
  aux_sym_arg_identifier_token1 = 89,
  aux_sym_double_quoted_arg_token1 = 90,
  aux_sym_double_quoted_arg_token2 = 91,
  aux_sym_double_quoted_arg_token3 = 92,
  anon_sym_SQUOTE = 93,
  aux_sym_single_quoted_arg_token1 = 94,
  aux_sym_single_quoted_arg_token2 = 95,
  anon_sym_DOLLAR_LPAREN = 96,
  anon_sym_BQUOTE = 97,
  aux_sym__dec_number_token1 = 98,
  aux_sym__dec_number_token2 = 99,
  sym__comment = 100,
  anon_sym_LF = 101,
  anon_sym_CR = 102,
  sym_cmd_identifier = 103,
  sym__help_command = 104,
  sym_file_descriptor = 105,
  sym__eq_sep_concat = 106,
  sym__concat = 107,
  sym__concat_pf_dot = 108,
  sym_commands = 109,
  sym__commands_singleline = 110,
  sym__command = 111,
  sym_legacy_quoted_command = 112,
  sym__simple_command = 113,
  sym__tmp_command = 114,
  sym__iter_command = 115,
  sym__pipe_command = 116,
  sym_grep_command = 117,
  sym_grep_specifier = 118,
  sym_html_disable_command = 119,
  sym_html_enable_command = 120,
  sym_pipe_command = 121,
  sym_iter_file_lines_command = 122,
  sym_iter_offsets_command = 123,
  sym_iter_offsetssizes_command = 124,
  sym_iter_hit_command = 125,
  sym_iter_interpret_command = 126,
  sym_iter_interpret_offsetssizes_command = 127,
  sym_iter_comment_command = 128,
  sym_iter_dbta_command = 129,
  sym_iter_dbtb_command = 130,
  sym_iter_dbts_command = 131,
  sym_iter_threads_command = 132,
  sym_iter_bbs_command = 133,
  sym_iter_instrs_command = 134,
  sym_iter_import_command = 135,
  sym_iter_sections_command = 136,
  sym_iter_segments_command = 137,
  sym_iter_symbol_command = 138,
  sym_iter_string_command = 139,
  sym_iter_flags_command = 140,
  sym_iter_function_command = 141,
  sym_iter_iomap_command = 142,
  sym_iter_dbgmap_command = 143,
  sym_iter_register_command = 144,
  sym_iter_step_command = 145,
  sym_tmp_seek_command = 146,
  sym_tmp_blksz_command = 147,
  sym_tmp_fromto_command = 148,
  sym_tmp_arch_command = 149,
  sym_tmp_bits_command = 150,
  sym_tmp_nthi_command = 151,
  sym_tmp_eval_command = 152,
  sym_tmp_fs_command = 153,
  sym_tmp_reli_command = 154,
  sym_tmp_kuery_command = 155,
  sym_tmp_fd_command = 156,
  sym_tmp_reg_command = 157,
  sym_tmp_file_command = 158,
  sym_tmp_string_command = 159,
  sym_tmp_value_command = 160,
  sym_tmp_hex_command = 161,
  sym_number_command = 162,
  sym_help_command = 163,
  sym_arged_command = 164,
  sym__simple_arged_command_question = 165,
  sym__simple_arged_command = 166,
  sym__search_command = 167,
  sym__math_arged_command = 168,
  sym__pointer_arged_command = 169,
  sym__macro_arged_command = 170,
  sym__system_command = 171,
  sym__interpret_command = 172,
  sym__interpret_search_identifier = 173,
  sym__pf_arged_command = 174,
  sym__pf_commands = 175,
  sym_Cf_cmd = 176,
  sym__Cf_args = 177,
  sym_pf_new_cmd = 178,
  sym_pf_dot_cmd = 179,
  sym_pf_cmd = 180,
  sym_pf_new_args = 181,
  sym_pf_dot_cmd_args = 182,
  sym__pf_dot_arg_identifier = 183,
  sym__pf_arg_parentheses = 184,
  sym_pf_arg_identifier = 185,
  sym__pf_arg = 186,
  sym__pf_dot_arg = 187,
  sym_pf_concatenation = 188,
  sym_pf_dot_concatenation = 189,
  sym_pf_arg = 190,
  sym_pf_dot_arg = 191,
  sym_pf_args = 192,
  sym_pf_dot_args = 193,
  sym__env_command = 194,
  sym__env_command_identifier = 195,
  sym__last_command = 196,
  sym_last_command_identifier = 197,
  sym_interpret_arg = 198,
  sym_repeat_command = 199,
  sym_eq_sep_args = 200,
  sym_macro_call_content = 201,
  sym_macro_call_full_content = 202,
  sym_macro_content = 203,
  sym_macro_args = 204,
  sym_redirect_command = 205,
  sym__redirect_operator = 206,
  sym_fdn_redirect_operator = 207,
  sym_fdn_append_operator = 208,
  sym__arg_with_paren = 209,
  sym__arg = 210,
  sym_arg = 211,
  sym_args = 212,
  sym_tmp_eval_args = 213,
  sym_tmp_eval_arg = 214,
  sym__eq_sep_key_single = 215,
  sym__eq_sep_key_concatenation = 216,
  sym__eq_sep_key = 217,
  sym__eq_sep_val_concatenation = 218,
  sym__eq_sep_val = 219,
  sym_arg_identifier = 220,
  sym_double_quoted_arg = 221,
  sym_single_quoted_arg = 222,
  sym_cmd_substitution_arg = 223,
  sym_concatenation = 224,
  sym__dec_number = 225,
  aux_sym_commands_repeat1 = 226,
  aux_sym_commands_repeat2 = 227,
  aux_sym__commands_singleline_repeat1 = 228,
  aux_sym__commands_singleline_repeat2 = 229,
  aux_sym_grep_specifier_repeat1 = 230,
  aux_sym_pf_concatenation_repeat1 = 231,
  aux_sym_pf_dot_concatenation_repeat1 = 232,
  aux_sym_pf_args_repeat1 = 233,
  aux_sym_pf_dot_args_repeat1 = 234,
  aux_sym_macro_content_repeat1 = 235,
  aux_sym_args_repeat1 = 236,
  aux_sym_tmp_eval_args_repeat1 = 237,
  aux_sym_tmp_eval_arg_repeat1 = 238,
  aux_sym__eq_sep_key_concatenation_repeat1 = 239,
  aux_sym__eq_sep_val_concatenation_repeat1 = 240,
  aux_sym_double_quoted_arg_repeat1 = 241,
  aux_sym_single_quoted_arg_repeat1 = 242,
  aux_sym_concatenation_repeat1 = 243,
  alias_sym_number = 244,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_legacy_quoted_command_token1] = "legacy_quoted_command_token1",
  [anon_sym_TILDE] = "~",
  [sym_grep_specifier_identifier] = "grep_specifier_identifier",
  [aux_sym_grep_specifier_token1] = "grep_specifier_identifier",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPEH] = "|H",
  [sym_pipe_second_command] = "pipe_second_command",
  [anon_sym_AT_AT_DOT] = "@@.",
  [anon_sym_AT_AT_EQ] = "@@=",
  [anon_sym_AT_AT_AT_EQ] = "@@@=",
  [anon_sym_AT_AT] = "@@",
  [anon_sym_AT_ATc_COLON] = "@@c:",
  [anon_sym_AT_AT_ATc_COLON] = "@@@c:",
  [anon_sym_AT_ATC] = "@@C",
  [anon_sym_COLON] = ":",
  [anon_sym_AT_ATdbt] = "@@dbt",
  [anon_sym_AT_ATdbta] = "@@dbta",
  [anon_sym_AT_ATdbtb] = "@@dbtb",
  [anon_sym_AT_ATdbts] = "@@dbts",
  [anon_sym_AT_ATt] = "@@t",
  [anon_sym_AT_ATb] = "@@b",
  [anon_sym_AT_ATi] = "@@i",
  [anon_sym_AT_ATii] = "@@ii",
  [anon_sym_AT_ATiS] = "@@iS",
  [anon_sym_AT_ATiSS] = "@@iSS",
  [anon_sym_AT_ATis] = "@@is",
  [anon_sym_AT_ATiz] = "@@iz",
  [anon_sym_AT_ATf] = "@@f",
  [anon_sym_AT_ATF] = "@@F",
  [anon_sym_AT_ATom] = "@@om",
  [anon_sym_AT_ATdm] = "@@dm",
  [anon_sym_AT_ATr] = "@@r",
  [anon_sym_AT_ATs_COLON] = "@@s:",
  [anon_sym_AT] = "@",
  [anon_sym_AT_BANG] = "@!",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_ATa_COLON] = "@a:",
  [anon_sym_ATb_COLON] = "@b:",
  [anon_sym_ATB_COLON] = "@B:",
  [anon_sym_ATe_COLON] = "@e:",
  [anon_sym_ATF_COLON] = "@F:",
  [anon_sym_ATi_COLON] = "@i:",
  [anon_sym_ATk_COLON] = "@k:",
  [anon_sym_ATo_COLON] = "@o:",
  [anon_sym_ATr_COLON] = "@r:",
  [anon_sym_ATf_COLON] = "@f:",
  [anon_sym_ATs_COLON] = "@s:",
  [anon_sym_ATv_COLON] = "@v:",
  [anon_sym_ATx_COLON] = "@x:",
  [anon_sym_0] = "0",
  [aux_sym_number_command_token1] = "number_command_token1",
  [aux_sym__search_command_token1] = "cmd_identifier",
  [anon_sym_DOT] = ".",
  [aux_sym__interpret_command_token1] = "cmd_identifier",
  [aux_sym__interpret_command_token2] = "_interpret_command_token2",
  [aux_sym__interpret_command_token3] = "cmd_identifier",
  [anon_sym_DOT_BANG] = "cmd_identifier",
  [anon_sym_DOT_LPAREN] = "cmd_identifier",
  [anon_sym_PIPE_DOT] = "|.",
  [anon_sym_DOT_SLASH] = "./",
  [anon_sym_pfo] = "cmd_identifier",
  [anon_sym_Cf] = "cmd_identifier",
  [sym_pf_dot_cmd_identifier] = "cmd_identifier",
  [sym_pf_dot_full_cmd_identifier] = "cmd_identifier",
  [aux_sym_pf_cmd_token1] = "cmd_identifier",
  [anon_sym_EQ] = "=",
  [aux_sym__pf_dot_arg_identifier_token1] = "_pf_dot_arg_identifier_token1",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_LPAREN] = "(",
  [aux_sym_pf_arg_identifier_token1] = "pf_arg_identifier_token1",
  [anon_sym_PERCENT] = "%",
  [anon_sym_env] = "env",
  [anon_sym_DOT_DOT_DOT] = "...",
  [sym_system_identifier] = "system_identifier",
  [sym_question_mark_identifier] = "cmd_identifier",
  [sym_pointer_identifier] = "cmd_identifier",
  [sym_macro_identifier] = "cmd_identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [sym_html_redirect_operator] = "html_redirect_operator",
  [sym_html_append_operator] = "html_append_operator",
  [anon_sym_COMMA] = ",",
  [aux_sym_tmp_eval_arg_token1] = "tmp_eval_arg_token1",
  [sym__eq_sep_key_identifier] = "arg_identifier",
  [sym__any_command] = "_any_command",
  [aux_sym_arg_identifier_token1] = "arg_identifier_token1",
  [aux_sym_double_quoted_arg_token1] = "double_quoted_arg_token1",
  [aux_sym_double_quoted_arg_token2] = "double_quoted_arg_token2",
  [aux_sym_double_quoted_arg_token3] = "double_quoted_arg_token3",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_single_quoted_arg_token1] = "single_quoted_arg_token1",
  [aux_sym_single_quoted_arg_token2] = "single_quoted_arg_token2",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__dec_number_token1] = "_dec_number_token1",
  [aux_sym__dec_number_token2] = "_dec_number_token2",
  [sym__comment] = "_comment",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [sym_cmd_identifier] = "cmd_identifier",
  [sym__help_command] = "cmd_identifier",
  [sym_file_descriptor] = "file_descriptor",
  [sym__eq_sep_concat] = "_eq_sep_concat",
  [sym__concat] = "_concat",
  [sym__concat_pf_dot] = "_concat_pf_dot",
  [sym_commands] = "commands",
  [sym__commands_singleline] = "_commands_singleline",
  [sym__command] = "_command",
  [sym_legacy_quoted_command] = "legacy_quoted_command",
  [sym__simple_command] = "_simple_command",
  [sym__tmp_command] = "_tmp_command",
  [sym__iter_command] = "_iter_command",
  [sym__pipe_command] = "_pipe_command",
  [sym_grep_command] = "grep_command",
  [sym_grep_specifier] = "grep_specifier",
  [sym_html_disable_command] = "html_disable_command",
  [sym_html_enable_command] = "html_enable_command",
  [sym_pipe_command] = "pipe_command",
  [sym_iter_file_lines_command] = "iter_file_lines_command",
  [sym_iter_offsets_command] = "iter_offsets_command",
  [sym_iter_offsetssizes_command] = "iter_offsetssizes_command",
  [sym_iter_hit_command] = "iter_hit_command",
  [sym_iter_interpret_command] = "iter_interpret_command",
  [sym_iter_interpret_offsetssizes_command] = "iter_interpret_offsetssizes_command",
  [sym_iter_comment_command] = "iter_comment_command",
  [sym_iter_dbta_command] = "iter_dbta_command",
  [sym_iter_dbtb_command] = "iter_dbtb_command",
  [sym_iter_dbts_command] = "iter_dbts_command",
  [sym_iter_threads_command] = "iter_threads_command",
  [sym_iter_bbs_command] = "iter_bbs_command",
  [sym_iter_instrs_command] = "iter_instrs_command",
  [sym_iter_import_command] = "iter_import_command",
  [sym_iter_sections_command] = "iter_sections_command",
  [sym_iter_segments_command] = "iter_segments_command",
  [sym_iter_symbol_command] = "iter_symbol_command",
  [sym_iter_string_command] = "iter_string_command",
  [sym_iter_flags_command] = "iter_flags_command",
  [sym_iter_function_command] = "iter_function_command",
  [sym_iter_iomap_command] = "iter_iomap_command",
  [sym_iter_dbgmap_command] = "iter_dbgmap_command",
  [sym_iter_register_command] = "iter_register_command",
  [sym_iter_step_command] = "iter_step_command",
  [sym_tmp_seek_command] = "tmp_seek_command",
  [sym_tmp_blksz_command] = "tmp_blksz_command",
  [sym_tmp_fromto_command] = "tmp_fromto_command",
  [sym_tmp_arch_command] = "tmp_arch_command",
  [sym_tmp_bits_command] = "tmp_bits_command",
  [sym_tmp_nthi_command] = "tmp_nthi_command",
  [sym_tmp_eval_command] = "tmp_eval_command",
  [sym_tmp_fs_command] = "tmp_fs_command",
  [sym_tmp_reli_command] = "tmp_reli_command",
  [sym_tmp_kuery_command] = "tmp_kuery_command",
  [sym_tmp_fd_command] = "tmp_fd_command",
  [sym_tmp_reg_command] = "tmp_reg_command",
  [sym_tmp_file_command] = "tmp_file_command",
  [sym_tmp_string_command] = "tmp_string_command",
  [sym_tmp_value_command] = "tmp_value_command",
  [sym_tmp_hex_command] = "tmp_hex_command",
  [sym_number_command] = "number_command",
  [sym_help_command] = "help_command",
  [sym_arged_command] = "arged_command",
  [sym__simple_arged_command_question] = "_simple_arged_command_question",
  [sym__simple_arged_command] = "_simple_arged_command",
  [sym__search_command] = "arged_command",
  [sym__math_arged_command] = "_math_arged_command",
  [sym__pointer_arged_command] = "_pointer_arged_command",
  [sym__macro_arged_command] = "_macro_arged_command",
  [sym__system_command] = "_system_command",
  [sym__interpret_command] = "_interpret_command",
  [sym__interpret_search_identifier] = "cmd_identifier",
  [sym__pf_arged_command] = "_pf_arged_command",
  [sym__pf_commands] = "_pf_commands",
  [sym_Cf_cmd] = "arged_command",
  [sym__Cf_args] = "args",
  [sym_pf_new_cmd] = "arged_command",
  [sym_pf_dot_cmd] = "arged_command",
  [sym_pf_cmd] = "arged_command",
  [sym_pf_new_args] = "pf_new_args",
  [sym_pf_dot_cmd_args] = "pf_dot_cmd_args",
  [sym__pf_dot_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg_parentheses] = "_pf_arg_parentheses",
  [sym_pf_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg] = "_pf_arg",
  [sym__pf_dot_arg] = "_pf_dot_arg",
  [sym_pf_concatenation] = "pf_concatenation",
  [sym_pf_dot_concatenation] = "pf_concatenation",
  [sym_pf_arg] = "pf_arg",
  [sym_pf_dot_arg] = "pf_arg",
  [sym_pf_args] = "pf_args",
  [sym_pf_dot_args] = "pf_args",
  [sym__env_command] = "_env_command",
  [sym__env_command_identifier] = "cmd_identifier",
  [sym__last_command] = "_last_command",
  [sym_last_command_identifier] = "cmd_identifier",
  [sym_interpret_arg] = "interpret_arg",
  [sym_repeat_command] = "repeat_command",
  [sym_eq_sep_args] = "args",
  [sym_macro_call_content] = "macro_call_content",
  [sym_macro_call_full_content] = "macro_call_full_content",
  [sym_macro_content] = "macro_content",
  [sym_macro_args] = "macro_args",
  [sym_redirect_command] = "redirect_command",
  [sym__redirect_operator] = "_redirect_operator",
  [sym_fdn_redirect_operator] = "fdn_redirect_operator",
  [sym_fdn_append_operator] = "fdn_append_operator",
  [sym__arg_with_paren] = "args",
  [sym__arg] = "_arg",
  [sym_arg] = "arg",
  [sym_args] = "args",
  [sym_tmp_eval_args] = "tmp_eval_args",
  [sym_tmp_eval_arg] = "tmp_eval_arg",
  [sym__eq_sep_key_single] = "_eq_sep_key_single",
  [sym__eq_sep_key_concatenation] = "concatenation",
  [sym__eq_sep_key] = "arg",
  [sym__eq_sep_val_concatenation] = "concatenation",
  [sym__eq_sep_val] = "arg",
  [sym_arg_identifier] = "arg_identifier",
  [sym_double_quoted_arg] = "double_quoted_arg",
  [sym_single_quoted_arg] = "single_quoted_arg",
  [sym_cmd_substitution_arg] = "cmd_substitution_arg",
  [sym_concatenation] = "concatenation",
  [sym__dec_number] = "_dec_number",
  [aux_sym_commands_repeat1] = "commands_repeat1",
  [aux_sym_commands_repeat2] = "commands_repeat2",
  [aux_sym__commands_singleline_repeat1] = "_commands_singleline_repeat1",
  [aux_sym__commands_singleline_repeat2] = "_commands_singleline_repeat2",
  [aux_sym_grep_specifier_repeat1] = "grep_specifier_repeat1",
  [aux_sym_pf_concatenation_repeat1] = "pf_concatenation_repeat1",
  [aux_sym_pf_dot_concatenation_repeat1] = "pf_dot_concatenation_repeat1",
  [aux_sym_pf_args_repeat1] = "pf_args_repeat1",
  [aux_sym_pf_dot_args_repeat1] = "pf_dot_args_repeat1",
  [aux_sym_macro_content_repeat1] = "macro_content_repeat1",
  [aux_sym_args_repeat1] = "args_repeat1",
  [aux_sym_tmp_eval_args_repeat1] = "tmp_eval_args_repeat1",
  [aux_sym_tmp_eval_arg_repeat1] = "tmp_eval_arg_repeat1",
  [aux_sym__eq_sep_key_concatenation_repeat1] = "_eq_sep_key_concatenation_repeat1",
  [aux_sym__eq_sep_val_concatenation_repeat1] = "_eq_sep_val_concatenation_repeat1",
  [aux_sym_double_quoted_arg_repeat1] = "double_quoted_arg_repeat1",
  [aux_sym_single_quoted_arg_repeat1] = "single_quoted_arg_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [alias_sym_number] = "number",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_legacy_quoted_command_token1] = aux_sym_legacy_quoted_command_token1,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_grep_specifier_identifier] = sym_grep_specifier_identifier,
  [aux_sym_grep_specifier_token1] = sym_grep_specifier_identifier,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PIPEH] = anon_sym_PIPEH,
  [sym_pipe_second_command] = sym_pipe_second_command,
  [anon_sym_AT_AT_DOT] = anon_sym_AT_AT_DOT,
  [anon_sym_AT_AT_EQ] = anon_sym_AT_AT_EQ,
  [anon_sym_AT_AT_AT_EQ] = anon_sym_AT_AT_AT_EQ,
  [anon_sym_AT_AT] = anon_sym_AT_AT,
  [anon_sym_AT_ATc_COLON] = anon_sym_AT_ATc_COLON,
  [anon_sym_AT_AT_ATc_COLON] = anon_sym_AT_AT_ATc_COLON,
  [anon_sym_AT_ATC] = anon_sym_AT_ATC,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT_ATdbt] = anon_sym_AT_ATdbt,
  [anon_sym_AT_ATdbta] = anon_sym_AT_ATdbta,
  [anon_sym_AT_ATdbtb] = anon_sym_AT_ATdbtb,
  [anon_sym_AT_ATdbts] = anon_sym_AT_ATdbts,
  [anon_sym_AT_ATt] = anon_sym_AT_ATt,
  [anon_sym_AT_ATb] = anon_sym_AT_ATb,
  [anon_sym_AT_ATi] = anon_sym_AT_ATi,
  [anon_sym_AT_ATii] = anon_sym_AT_ATii,
  [anon_sym_AT_ATiS] = anon_sym_AT_ATiS,
  [anon_sym_AT_ATiSS] = anon_sym_AT_ATiSS,
  [anon_sym_AT_ATis] = anon_sym_AT_ATis,
  [anon_sym_AT_ATiz] = anon_sym_AT_ATiz,
  [anon_sym_AT_ATf] = anon_sym_AT_ATf,
  [anon_sym_AT_ATF] = anon_sym_AT_ATF,
  [anon_sym_AT_ATom] = anon_sym_AT_ATom,
  [anon_sym_AT_ATdm] = anon_sym_AT_ATdm,
  [anon_sym_AT_ATr] = anon_sym_AT_ATr,
  [anon_sym_AT_ATs_COLON] = anon_sym_AT_ATs_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_BANG] = anon_sym_AT_BANG,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_ATa_COLON] = anon_sym_ATa_COLON,
  [anon_sym_ATb_COLON] = anon_sym_ATb_COLON,
  [anon_sym_ATB_COLON] = anon_sym_ATB_COLON,
  [anon_sym_ATe_COLON] = anon_sym_ATe_COLON,
  [anon_sym_ATF_COLON] = anon_sym_ATF_COLON,
  [anon_sym_ATi_COLON] = anon_sym_ATi_COLON,
  [anon_sym_ATk_COLON] = anon_sym_ATk_COLON,
  [anon_sym_ATo_COLON] = anon_sym_ATo_COLON,
  [anon_sym_ATr_COLON] = anon_sym_ATr_COLON,
  [anon_sym_ATf_COLON] = anon_sym_ATf_COLON,
  [anon_sym_ATs_COLON] = anon_sym_ATs_COLON,
  [anon_sym_ATv_COLON] = anon_sym_ATv_COLON,
  [anon_sym_ATx_COLON] = anon_sym_ATx_COLON,
  [anon_sym_0] = anon_sym_0,
  [aux_sym_number_command_token1] = aux_sym_number_command_token1,
  [aux_sym__search_command_token1] = sym_cmd_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym__interpret_command_token1] = sym_cmd_identifier,
  [aux_sym__interpret_command_token2] = aux_sym__interpret_command_token2,
  [aux_sym__interpret_command_token3] = sym_cmd_identifier,
  [anon_sym_DOT_BANG] = sym_cmd_identifier,
  [anon_sym_DOT_LPAREN] = sym_cmd_identifier,
  [anon_sym_PIPE_DOT] = anon_sym_PIPE_DOT,
  [anon_sym_DOT_SLASH] = anon_sym_DOT_SLASH,
  [anon_sym_pfo] = sym_cmd_identifier,
  [anon_sym_Cf] = sym_cmd_identifier,
  [sym_pf_dot_cmd_identifier] = sym_cmd_identifier,
  [sym_pf_dot_full_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_pf_cmd_token1] = sym_cmd_identifier,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym__pf_dot_arg_identifier_token1] = aux_sym__pf_dot_arg_identifier_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [aux_sym_pf_arg_identifier_token1] = aux_sym_pf_arg_identifier_token1,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_env] = anon_sym_env,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [sym_system_identifier] = sym_system_identifier,
  [sym_question_mark_identifier] = sym_cmd_identifier,
  [sym_pointer_identifier] = sym_cmd_identifier,
  [sym_macro_identifier] = sym_cmd_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [sym_html_redirect_operator] = sym_html_redirect_operator,
  [sym_html_append_operator] = sym_html_append_operator,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_tmp_eval_arg_token1] = aux_sym_tmp_eval_arg_token1,
  [sym__eq_sep_key_identifier] = sym_arg_identifier,
  [sym__any_command] = sym__any_command,
  [aux_sym_arg_identifier_token1] = aux_sym_arg_identifier_token1,
  [aux_sym_double_quoted_arg_token1] = aux_sym_double_quoted_arg_token1,
  [aux_sym_double_quoted_arg_token2] = aux_sym_double_quoted_arg_token2,
  [aux_sym_double_quoted_arg_token3] = aux_sym_double_quoted_arg_token3,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_single_quoted_arg_token1] = aux_sym_single_quoted_arg_token1,
  [aux_sym_single_quoted_arg_token2] = aux_sym_single_quoted_arg_token2,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__dec_number_token1] = aux_sym__dec_number_token1,
  [aux_sym__dec_number_token2] = aux_sym__dec_number_token2,
  [sym__comment] = sym__comment,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [sym_cmd_identifier] = sym_cmd_identifier,
  [sym__help_command] = sym_cmd_identifier,
  [sym_file_descriptor] = sym_file_descriptor,
  [sym__eq_sep_concat] = sym__eq_sep_concat,
  [sym__concat] = sym__concat,
  [sym__concat_pf_dot] = sym__concat_pf_dot,
  [sym_commands] = sym_commands,
  [sym__commands_singleline] = sym__commands_singleline,
  [sym__command] = sym__command,
  [sym_legacy_quoted_command] = sym_legacy_quoted_command,
  [sym__simple_command] = sym__simple_command,
  [sym__tmp_command] = sym__tmp_command,
  [sym__iter_command] = sym__iter_command,
  [sym__pipe_command] = sym__pipe_command,
  [sym_grep_command] = sym_grep_command,
  [sym_grep_specifier] = sym_grep_specifier,
  [sym_html_disable_command] = sym_html_disable_command,
  [sym_html_enable_command] = sym_html_enable_command,
  [sym_pipe_command] = sym_pipe_command,
  [sym_iter_file_lines_command] = sym_iter_file_lines_command,
  [sym_iter_offsets_command] = sym_iter_offsets_command,
  [sym_iter_offsetssizes_command] = sym_iter_offsetssizes_command,
  [sym_iter_hit_command] = sym_iter_hit_command,
  [sym_iter_interpret_command] = sym_iter_interpret_command,
  [sym_iter_interpret_offsetssizes_command] = sym_iter_interpret_offsetssizes_command,
  [sym_iter_comment_command] = sym_iter_comment_command,
  [sym_iter_dbta_command] = sym_iter_dbta_command,
  [sym_iter_dbtb_command] = sym_iter_dbtb_command,
  [sym_iter_dbts_command] = sym_iter_dbts_command,
  [sym_iter_threads_command] = sym_iter_threads_command,
  [sym_iter_bbs_command] = sym_iter_bbs_command,
  [sym_iter_instrs_command] = sym_iter_instrs_command,
  [sym_iter_import_command] = sym_iter_import_command,
  [sym_iter_sections_command] = sym_iter_sections_command,
  [sym_iter_segments_command] = sym_iter_segments_command,
  [sym_iter_symbol_command] = sym_iter_symbol_command,
  [sym_iter_string_command] = sym_iter_string_command,
  [sym_iter_flags_command] = sym_iter_flags_command,
  [sym_iter_function_command] = sym_iter_function_command,
  [sym_iter_iomap_command] = sym_iter_iomap_command,
  [sym_iter_dbgmap_command] = sym_iter_dbgmap_command,
  [sym_iter_register_command] = sym_iter_register_command,
  [sym_iter_step_command] = sym_iter_step_command,
  [sym_tmp_seek_command] = sym_tmp_seek_command,
  [sym_tmp_blksz_command] = sym_tmp_blksz_command,
  [sym_tmp_fromto_command] = sym_tmp_fromto_command,
  [sym_tmp_arch_command] = sym_tmp_arch_command,
  [sym_tmp_bits_command] = sym_tmp_bits_command,
  [sym_tmp_nthi_command] = sym_tmp_nthi_command,
  [sym_tmp_eval_command] = sym_tmp_eval_command,
  [sym_tmp_fs_command] = sym_tmp_fs_command,
  [sym_tmp_reli_command] = sym_tmp_reli_command,
  [sym_tmp_kuery_command] = sym_tmp_kuery_command,
  [sym_tmp_fd_command] = sym_tmp_fd_command,
  [sym_tmp_reg_command] = sym_tmp_reg_command,
  [sym_tmp_file_command] = sym_tmp_file_command,
  [sym_tmp_string_command] = sym_tmp_string_command,
  [sym_tmp_value_command] = sym_tmp_value_command,
  [sym_tmp_hex_command] = sym_tmp_hex_command,
  [sym_number_command] = sym_number_command,
  [sym_help_command] = sym_help_command,
  [sym_arged_command] = sym_arged_command,
  [sym__simple_arged_command_question] = sym__simple_arged_command_question,
  [sym__simple_arged_command] = sym__simple_arged_command,
  [sym__search_command] = sym_arged_command,
  [sym__math_arged_command] = sym__math_arged_command,
  [sym__pointer_arged_command] = sym__pointer_arged_command,
  [sym__macro_arged_command] = sym__macro_arged_command,
  [sym__system_command] = sym__system_command,
  [sym__interpret_command] = sym__interpret_command,
  [sym__interpret_search_identifier] = sym_cmd_identifier,
  [sym__pf_arged_command] = sym__pf_arged_command,
  [sym__pf_commands] = sym__pf_commands,
  [sym_Cf_cmd] = sym_arged_command,
  [sym__Cf_args] = sym_args,
  [sym_pf_new_cmd] = sym_arged_command,
  [sym_pf_dot_cmd] = sym_arged_command,
  [sym_pf_cmd] = sym_arged_command,
  [sym_pf_new_args] = sym_pf_new_args,
  [sym_pf_dot_cmd_args] = sym_pf_dot_cmd_args,
  [sym__pf_dot_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg_parentheses] = sym__pf_arg_parentheses,
  [sym_pf_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg] = sym__pf_arg,
  [sym__pf_dot_arg] = sym__pf_dot_arg,
  [sym_pf_concatenation] = sym_pf_concatenation,
  [sym_pf_dot_concatenation] = sym_pf_concatenation,
  [sym_pf_arg] = sym_pf_arg,
  [sym_pf_dot_arg] = sym_pf_arg,
  [sym_pf_args] = sym_pf_args,
  [sym_pf_dot_args] = sym_pf_args,
  [sym__env_command] = sym__env_command,
  [sym__env_command_identifier] = sym_cmd_identifier,
  [sym__last_command] = sym__last_command,
  [sym_last_command_identifier] = sym_cmd_identifier,
  [sym_interpret_arg] = sym_interpret_arg,
  [sym_repeat_command] = sym_repeat_command,
  [sym_eq_sep_args] = sym_args,
  [sym_macro_call_content] = sym_macro_call_content,
  [sym_macro_call_full_content] = sym_macro_call_full_content,
  [sym_macro_content] = sym_macro_content,
  [sym_macro_args] = sym_macro_args,
  [sym_redirect_command] = sym_redirect_command,
  [sym__redirect_operator] = sym__redirect_operator,
  [sym_fdn_redirect_operator] = sym_fdn_redirect_operator,
  [sym_fdn_append_operator] = sym_fdn_append_operator,
  [sym__arg_with_paren] = sym_args,
  [sym__arg] = sym__arg,
  [sym_arg] = sym_arg,
  [sym_args] = sym_args,
  [sym_tmp_eval_args] = sym_tmp_eval_args,
  [sym_tmp_eval_arg] = sym_tmp_eval_arg,
  [sym__eq_sep_key_single] = sym__eq_sep_key_single,
  [sym__eq_sep_key_concatenation] = sym_concatenation,
  [sym__eq_sep_key] = sym_arg,
  [sym__eq_sep_val_concatenation] = sym_concatenation,
  [sym__eq_sep_val] = sym_arg,
  [sym_arg_identifier] = sym_arg_identifier,
  [sym_double_quoted_arg] = sym_double_quoted_arg,
  [sym_single_quoted_arg] = sym_single_quoted_arg,
  [sym_cmd_substitution_arg] = sym_cmd_substitution_arg,
  [sym_concatenation] = sym_concatenation,
  [sym__dec_number] = sym__dec_number,
  [aux_sym_commands_repeat1] = aux_sym_commands_repeat1,
  [aux_sym_commands_repeat2] = aux_sym_commands_repeat2,
  [aux_sym__commands_singleline_repeat1] = aux_sym__commands_singleline_repeat1,
  [aux_sym__commands_singleline_repeat2] = aux_sym__commands_singleline_repeat2,
  [aux_sym_grep_specifier_repeat1] = aux_sym_grep_specifier_repeat1,
  [aux_sym_pf_concatenation_repeat1] = aux_sym_pf_concatenation_repeat1,
  [aux_sym_pf_dot_concatenation_repeat1] = aux_sym_pf_dot_concatenation_repeat1,
  [aux_sym_pf_args_repeat1] = aux_sym_pf_args_repeat1,
  [aux_sym_pf_dot_args_repeat1] = aux_sym_pf_dot_args_repeat1,
  [aux_sym_macro_content_repeat1] = aux_sym_macro_content_repeat1,
  [aux_sym_args_repeat1] = aux_sym_args_repeat1,
  [aux_sym_tmp_eval_args_repeat1] = aux_sym_tmp_eval_args_repeat1,
  [aux_sym_tmp_eval_arg_repeat1] = aux_sym_tmp_eval_arg_repeat1,
  [aux_sym__eq_sep_key_concatenation_repeat1] = aux_sym__eq_sep_key_concatenation_repeat1,
  [aux_sym__eq_sep_val_concatenation_repeat1] = aux_sym__eq_sep_val_concatenation_repeat1,
  [aux_sym_double_quoted_arg_repeat1] = aux_sym_double_quoted_arg_repeat1,
  [aux_sym_single_quoted_arg_repeat1] = aux_sym_single_quoted_arg_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [alias_sym_number] = alias_sym_number,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_legacy_quoted_command_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_grep_specifier_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_grep_specifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPEH] = {
    .visible = true,
    .named = false,
  },
  [sym_pipe_second_command] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT_AT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATC] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbtb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiSS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiz] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATa_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATb_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATB_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATe_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATF_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATi_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATk_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATo_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATr_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATf_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATv_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATx_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_number_command_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__search_command_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpret_command_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpret_command_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpret_command_token3] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_LPAREN] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pfo] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Cf] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_full_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pf_cmd_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__pf_dot_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pf_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_env] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_system_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_question_mark_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_html_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_html_append_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__eq_sep_key_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__any_command] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__dec_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__dec_number_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__comment] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [sym_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__help_command] = {
    .visible = true,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat_pf_dot] = {
    .visible = false,
    .named = true,
  },
  [sym_commands] = {
    .visible = true,
    .named = true,
  },
  [sym__commands_singleline] = {
    .visible = false,
    .named = true,
  },
  [sym__command] = {
    .visible = false,
    .named = true,
  },
  [sym_legacy_quoted_command] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_command] = {
    .visible = false,
    .named = true,
  },
  [sym__tmp_command] = {
    .visible = false,
    .named = true,
  },
  [sym__iter_command] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_command] = {
    .visible = false,
    .named = true,
  },
  [sym_grep_command] = {
    .visible = true,
    .named = true,
  },
  [sym_grep_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_html_disable_command] = {
    .visible = true,
    .named = true,
  },
  [sym_html_enable_command] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_file_lines_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsets_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsetssizes_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_hit_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_offsetssizes_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_comment_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbta_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbtb_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbts_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_threads_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_bbs_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_instrs_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_import_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_sections_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_segments_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_symbol_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_string_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_flags_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_function_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_iomap_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbgmap_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_register_command] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_step_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_seek_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_blksz_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fromto_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_arch_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_bits_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_nthi_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fs_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reli_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_kuery_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fd_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reg_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_file_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_string_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_value_command] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_hex_command] = {
    .visible = true,
    .named = true,
  },
  [sym_number_command] = {
    .visible = true,
    .named = true,
  },
  [sym_help_command] = {
    .visible = true,
    .named = true,
  },
  [sym_arged_command] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_arged_command_question] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_arged_command] = {
    .visible = false,
    .named = true,
  },
  [sym__search_command] = {
    .visible = true,
    .named = true,
  },
  [sym__math_arged_command] = {
    .visible = false,
    .named = true,
  },
  [sym__pointer_arged_command] = {
    .visible = false,
    .named = true,
  },
  [sym__macro_arged_command] = {
    .visible = false,
    .named = true,
  },
  [sym__system_command] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_command] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_search_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arged_command] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_commands] = {
    .visible = false,
    .named = true,
  },
  [sym_Cf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym__Cf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_args] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_dot_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg_parentheses] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_dot_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_args] = {
    .visible = true,
    .named = true,
  },
  [sym__env_command] = {
    .visible = false,
    .named = true,
  },
  [sym__env_command_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__last_command] = {
    .visible = false,
    .named = true,
  },
  [sym_last_command_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interpret_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_command] = {
    .visible = true,
    .named = true,
  },
  [sym_eq_sep_args] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call_full_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_args] = {
    .visible = true,
    .named = true,
  },
  [sym_redirect_command] = {
    .visible = true,
    .named = true,
  },
  [sym__redirect_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_fdn_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_fdn_append_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_with_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_arg] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key_single] = {
    .visible = false,
    .named = true,
  },
  [sym__eq_sep_key_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val] = {
    .visible = true,
    .named = true,
  },
  [sym_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_double_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_single_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_substitution_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__dec_number] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_commands_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_commands_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__commands_singleline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__commands_singleline_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grep_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_key_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_val_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_number] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_arg = 1,
  field_args = 2,
  field_command = 3,
  field_name = 4,
  field_redirect_operator = 5,
  field_specifier = 6,
  field_string = 7,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_arg] = "arg",
  [field_args] = "args",
  [field_command] = "command",
  [field_name] = "name",
  [field_redirect_operator] = "redirect_operator",
  [field_specifier] = "specifier",
  [field_string] = "string",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 2},
  [4] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 2},
  [7] = {.index = 4, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 1},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 13, .length = 1},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 3},
  [18] = {.index = 19, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_command, 0},
  [1] =
    {field_args, 0, .inherited = true},
    {field_command, 0, .inherited = true},
  [3] =
    {field_command, 0, .inherited = true},
  [4] =
    {field_args, 1},
    {field_command, 0},
  [6] =
    {field_args, 0},
    {field_command, 1},
  [8] =
    {field_arg, 0},
    {field_command, 1},
  [10] =
    {field_string, 1},
  [11] =
    {field_args, 2},
    {field_command, 0},
  [13] =
    {field_name, 0},
  [14] =
    {field_command, 0},
    {field_specifier, 2},
  [16] =
    {field_arg, 2},
    {field_command, 0},
    {field_redirect_operator, 1},
  [19] =
    {field_args, 3, .inherited = true},
    {field_command, 3, .inherited = true},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = sym_cmd_identifier,
  },
  [5] = {
    [0] = sym_arg_identifier,
  },
  [7] = {
    [0] = sym_cmd_identifier,
  },
  [9] = {
    [0] = alias_sym_number,
  },
  [11] = {
    [0] = sym_cmd_identifier,
  },
  [16] = {
    [0] = sym_arg_identifier,
    [2] = sym_arg_identifier,
  },
  [17] = {
    [0] = sym_pf_arg_identifier,
    [2] = sym_pf_arg_identifier,
  },
  [19] = {
    [1] = sym_pf_arg_identifier,
  },
};

static uint16_t ts_non_terminal_alias_map[] = {
  sym__dec_number, 2,
    sym__dec_number,
    alias_sym_number,
  0,
};

static inline bool sym_grep_specifier_identifier_character_set_1(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= '(' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : c <= '>')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '('
        ? c == '#'
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_3(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= '.' || (c < '`'
      ? (c < '='
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == '.'))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= '\'')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '#')))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_tmp_eval_arg_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '$' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < ','
        ? (c >= '(' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '\\'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '\\' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '='
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_4(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(231);
      if (lookahead == '%') ADVANCE(238);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == '(') ADVANCE(232);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == ',') ADVANCE(255);
      if (lookahead == '.') ADVANCE(207);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(200);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '=') ADVANCE(222);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '?') ADVANCE(242);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(257);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(0)
      if (lookahead != 0) ADVANCE(256);
      END_STATE();
    case 1:
      if (lookahead == '\t') SKIP(1)
      if (lookahead == ' ') ADVANCE(210);
      if (lookahead == '#') ADVANCE(290);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(16);
      if (lookahead == '%') ADVANCE(258);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(2)
      if (!sym__eq_sep_key_identifier_character_set_1(lookahead)) ADVANCE(262);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(271);
      if (lookahead == '$') ADVANCE(275);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(273);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|') ADVANCE(81);
      END_STATE();
    case 5:
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(229);
      if (lookahead == '(') ADVANCE(232);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(5)
      if (!aux_sym_pf_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(236);
      END_STATE();
    case 6:
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(230);
      if (lookahead == '.') ADVANCE(205);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6)
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(226);
      END_STATE();
    case 7:
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7)
      if (!aux_sym_tmp_eval_arg_token1_character_set_1(lookahead)) ADVANCE(256);
      END_STATE();
    case 8:
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == ')') ADVANCE(173);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '@') ADVANCE(167);
      if (lookahead == 'H') ADVANCE(109);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(114);
      END_STATE();
    case 9:
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '@') ADVANCE(167);
      if (lookahead == 'H') ADVANCE(109);
      if (lookahead == '`') ADVANCE(286);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(114);
      END_STATE();
    case 10:
      if (lookahead == '#') ADVANCE(279);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == '\\') ADVANCE(283);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(281);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(263);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(265);
      END_STATE();
    case 12:
      if (lookahead == '#') ADVANCE(289);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(270);
      if (lookahead == '{') ADVANCE(54);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(267);
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(234);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(236);
      END_STATE();
    case 15:
      if (lookahead == '$') ADVANCE(225);
      if (lookahead == '{') ADVANCE(57);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(226);
      END_STATE();
    case 16:
      if (lookahead == '(') ADVANCE(284);
      if (lookahead == '{') ADVANCE(56);
      if (lookahead != 0) ADVANCE(262);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(219);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(178);
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(182);
      END_STATE();
    case 20:
      if (lookahead == ':') ADVANCE(174);
      END_STATE();
    case 21:
      if (lookahead == ':') ADVANCE(176);
      END_STATE();
    case 22:
      if (lookahead == ':') ADVANCE(180);
      END_STATE();
    case 23:
      if (lookahead == ':') ADVANCE(192);
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(184);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(186);
      END_STATE();
    case 26:
      if (lookahead == ':') ADVANCE(188);
      END_STATE();
    case 27:
      if (lookahead == ':') ADVANCE(190);
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(194);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(196);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(198);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(123);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(164);
      END_STATE();
    case 33:
      if (lookahead == ':') ADVANCE(125);
      END_STATE();
    case 34:
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == 'c') ADVANCE(33);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(251);
      END_STATE();
    case 36:
      if (lookahead == 'b') ADVANCE(41);
      if (lookahead == 'm') ADVANCE(160);
      END_STATE();
    case 37:
      if (lookahead == 'f') ADVANCE(217);
      END_STATE();
    case 38:
      if (lookahead == 'f') ADVANCE(220);
      END_STATE();
    case 39:
      if (lookahead == 'm') ADVANCE(158);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(42);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 42:
      if (lookahead == 'v') ADVANCE(239);
      END_STATE();
    case 43:
      if (lookahead == '{') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(262);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(236);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(45);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(262);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '}') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(47);
      END_STATE();
    case 48:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(202);
      END_STATE();
    case 49:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(268);
      END_STATE();
    case 50:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(236);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(237);
      END_STATE();
    case 51:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(227);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(203);
      END_STATE();
    case 53:
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(81);
      END_STATE();
    case 54:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(44);
      END_STATE();
    case 55:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(45);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(47);
      END_STATE();
    case 58:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(267);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(236);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(226);
      END_STATE();
    case 61:
      if (lookahead != 0) ADVANCE(74);
      END_STATE();
    case 62:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '!') ADVANCE(241);
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '%') ADVANCE(238);
      if (lookahead == '(') ADVANCE(245);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == '*') ADVANCE(243);
      if (lookahead == '.') ADVANCE(206);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '0') ADVANCE(201);
      if (lookahead == ':') ADVANCE(129);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '=') ADVANCE(222);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '?') ADVANCE(242);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'C') ADVANCE(37);
      if (lookahead == 'H') ADVANCE(35);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'p') ADVANCE(38);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 63:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(228);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == '(') ADVANCE(232);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ',') ADVANCE(255);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(266);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(63)
      if (lookahead != 0) ADVANCE(267);
      END_STATE();
    case 64:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(228);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == '(') ADVANCE(232);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ',') ADVANCE(255);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(64)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(267);
      END_STATE();
    case 65:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '"') ADVANCE(72);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(16);
      if (lookahead == '%') ADVANCE(258);
      if (lookahead == '\'') ADVANCE(278);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(259);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(65)
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ',' &&
          lookahead != '=' &&
          lookahead != '\\') ADVANCE(262);
      END_STATE();
    case 66:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(85);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(80);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(81);
      END_STATE();
    case 67:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(229);
      if (lookahead == '(') ADVANCE(232);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '=') ADVANCE(223);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(235);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(67)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(236);
      END_STATE();
    case 68:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == '$') ADVANCE(229);
      if (lookahead == '(') ADVANCE(232);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(235);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(68)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(236);
      END_STATE();
    case 69:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '#') ADVANCE(290);
      if (lookahead == ')') ADVANCE(172);
      if (lookahead == ',') ADVANCE(255);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(247);
      if (lookahead == '@') ADVANCE(166);
      if (lookahead == 'H') ADVANCE(257);
      if (lookahead == '`') ADVANCE(285);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(69)
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != '\\') ADVANCE(256);
      END_STATE();
    case 70:
      if (eof) ADVANCE(71);
      if (lookahead == '\n') ADVANCE(292);
      if (lookahead == '\r') ADVANCE(293);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == ';') ADVANCE(246);
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '@') ADVANCE(167);
      if (lookahead == 'H') ADVANCE(109);
      if (lookahead == '|') ADVANCE(87);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(91);
      if (lookahead != 0) ADVANCE(114);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_command_token1);
      if (lookahead == '#') ADVANCE(289);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_command_token1);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(83);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(81);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(85);
      if (lookahead == 'H') ADVANCE(80);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == '~') ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(78);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(81);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(79);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(81);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '>') ADVANCE(251);
      if (lookahead == '\\') ADVANCE(83);
      if (!sym_grep_specifier_identifier_character_set_3(lookahead)) ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\\') ADVANCE(83);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == ')' ||
          lookahead == '@') ADVANCE(81);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(81);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(83);
      if (lookahead == '\r' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          lookahead == '|') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(81);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '\\') ADVANCE(83);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(81);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(84);
      if (lookahead == '(') ADVANCE(284);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '|') ADVANCE(81);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(84);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(81);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(214);
      if (lookahead == 'H') ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PIPEH);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == ')') ADVANCE(173);
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '@') ADVANCE(167);
      if (lookahead == 'H') ADVANCE(109);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '@') ADVANCE(167);
      if (lookahead == 'H') ADVANCE(109);
      if (lookahead == '`') ADVANCE(286);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == '#') ADVANCE(113);
      if (lookahead == '>') ADVANCE(248);
      if (lookahead == '@') ADVANCE(167);
      if (lookahead == 'H') ADVANCE(109);
      if (lookahead == '~') ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(179);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(185);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(187);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(195);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(124);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ':') ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == '=') ADVANCE(120);
      if (lookahead == 'c') ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == '>') ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == 'b') ADVANCE(112);
      if (lookahead == 'm') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == 'm') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == 't') ADVANCE(131);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead == ';' ||
          lookahead == '|') ADVANCE(290);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(113);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_pipe_second_command);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AT_AT_DOT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AT_AT_DOT);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AT_AT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AT_AT_EQ);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_AT_AT_AT_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AT_AT_AT_EQ);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AT_AT);
      if (lookahead == '.') ADVANCE(115);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '@') ADVANCE(34);
      if (lookahead == 'C') ADVANCE(127);
      if (lookahead == 'F') ADVANCE(156);
      if (lookahead == 'b') ADVANCE(140);
      if (lookahead == 'c') ADVANCE(31);
      if (lookahead == 'd') ADVANCE(36);
      if (lookahead == 'f') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(142);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(162);
      if (lookahead == 's') ADVANCE(32);
      if (lookahead == 't') ADVANCE(138);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AT_AT);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '@') ADVANCE(108);
      if (lookahead == 'C') ADVANCE(128);
      if (lookahead == 'F') ADVANCE(157);
      if (lookahead == 'b') ADVANCE(141);
      if (lookahead == 'c') ADVANCE(105);
      if (lookahead == 'd') ADVANCE(110);
      if (lookahead == 'f') ADVANCE(155);
      if (lookahead == 'i') ADVANCE(143);
      if (lookahead == 'o') ADVANCE(111);
      if (lookahead == 'r') ADVANCE(163);
      if (lookahead == 's') ADVANCE(106);
      if (lookahead == 't') ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AT_ATc_COLON);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_AT_ATc_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AT_AT_ATc_COLON);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AT_AT_ATc_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_AT_ATC);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_AT_ATC);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AT_ATdbt);
      if (lookahead == 'a') ADVANCE(132);
      if (lookahead == 'b') ADVANCE(134);
      if (lookahead == 's') ADVANCE(136);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AT_ATdbt);
      if (lookahead == 'a') ADVANCE(133);
      if (lookahead == 'b') ADVANCE(135);
      if (lookahead == 's') ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AT_ATdbta);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AT_ATdbta);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_AT_ATdbtb);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_AT_ATdbtb);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_AT_ATdbts);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AT_ATdbts);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_AT_ATt);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_AT_ATt);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_AT_ATb);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_AT_ATb);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AT_ATi);
      if (lookahead == 'S') ADVANCE(146);
      if (lookahead == 'i') ADVANCE(144);
      if (lookahead == 's') ADVANCE(150);
      if (lookahead == 'z') ADVANCE(152);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_AT_ATi);
      if (lookahead == 'S') ADVANCE(147);
      if (lookahead == 'i') ADVANCE(145);
      if (lookahead == 's') ADVANCE(151);
      if (lookahead == 'z') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_AT_ATii);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_AT_ATii);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AT_ATiS);
      if (lookahead == 'S') ADVANCE(148);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AT_ATiS);
      if (lookahead == 'S') ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AT_ATiSS);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_AT_ATiSS);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_AT_ATis);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_AT_ATis);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AT_ATiz);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_AT_ATiz);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_AT_ATf);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_AT_ATf);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_AT_ATF);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_AT_ATF);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_AT_ATom);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AT_ATom);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AT_ATdm);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_AT_ATdm);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AT_ATr);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AT_ATr);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_AT_ATs_COLON);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_AT_ATs_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '!') ADVANCE(168);
      if (lookahead == '(') ADVANCE(170);
      if (lookahead == '@') ADVANCE(121);
      if (lookahead == 'B') ADVANCE(18);
      if (lookahead == 'F') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'b') ADVANCE(21);
      if (lookahead == 'e') ADVANCE(22);
      if (lookahead == 'f') ADVANCE(23);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'k') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      if (lookahead == 'v') ADVANCE(29);
      if (lookahead == 'x') ADVANCE(30);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '!') ADVANCE(169);
      if (lookahead == '(') ADVANCE(171);
      if (lookahead == '@') ADVANCE(122);
      if (lookahead == 'B') ADVANCE(92);
      if (lookahead == 'F') ADVANCE(93);
      if (lookahead == 'a') ADVANCE(94);
      if (lookahead == 'b') ADVANCE(95);
      if (lookahead == 'e') ADVANCE(96);
      if (lookahead == 'f') ADVANCE(97);
      if (lookahead == 'i') ADVANCE(98);
      if (lookahead == 'k') ADVANCE(99);
      if (lookahead == 'o') ADVANCE(100);
      if (lookahead == 'r') ADVANCE(101);
      if (lookahead == 's') ADVANCE(102);
      if (lookahead == 'v') ADVANCE(103);
      if (lookahead == 'x') ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_AT_BANG);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_AT_BANG);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_ATa_COLON);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_ATa_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_ATb_COLON);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_ATb_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_ATB_COLON);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_ATB_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_ATe_COLON);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_ATe_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_ATF_COLON);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_ATF_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_ATi_COLON);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_ATi_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_ATk_COLON);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_ATk_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_ATo_COLON);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_ATo_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_ATr_COLON);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_ATr_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_ATf_COLON);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_ATf_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_ATs_COLON);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_ATs_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_ATv_COLON);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_ATv_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_ATx_COLON);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_ATx_COLON);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_0);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == 'b') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(288);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_number_command_token1);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_number_command_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym__search_command_token1);
      if (lookahead == '!' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('/' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == ' ') ADVANCE(211);
      if (lookahead == '!') ADVANCE(212);
      if (lookahead == '(') ADVANCE(213);
      if (lookahead == '.') ADVANCE(208);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(209);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '(') ADVANCE(213);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym__interpret_command_token1);
      if (lookahead == '.') ADVANCE(240);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(209);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(aux_sym__interpret_command_token1);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym__interpret_command_token2);
      if (lookahead == ' ') ADVANCE(210);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym__interpret_command_token3);
      if (lookahead == ' ') ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DOT_BANG);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_DOT_LPAREN);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_PIPE_DOT);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_DOT_SLASH);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_pfo);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_Cf);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_pf_dot_cmd_identifier);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_pf_dot_full_cmd_identifier);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(218);
      if (lookahead == 'o') ADVANCE(216);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == '*' ||
          lookahead == 'c' ||
          lookahead == 'j' ||
          lookahead == 'q' ||
          lookahead == 's') ADVANCE(221);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(219);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(236);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '{') ADVANCE(227);
      if (lookahead == '.' ||
          lookahead == '=') ADVANCE(226);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(226);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(224);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(226);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(15);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(226);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(15);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == '}') ADVANCE(226);
      if (aux_sym__pf_dot_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(227);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(270);
      if (lookahead == '(') ADVANCE(284);
      if (lookahead == '{') ADVANCE(54);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(267);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(234);
      if (lookahead == '(') ADVANCE(284);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(236);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(225);
      if (lookahead == '(') ADVANCE(284);
      if (lookahead == '{') ADVANCE(57);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(226);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(') ADVANCE(284);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(233);
      if (lookahead == '\\') ADVANCE(59);
      if (lookahead == '{') ADVANCE(237);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(236);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(233);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(236);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '>') ADVANCE(251);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_pf_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(236);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(59);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(236);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '}') ADVANCE(236);
      if (lookahead == '\t' ||
          lookahead == '"' ||
          lookahead == '#' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          ('|' <= lookahead && lookahead <= '~')) ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_env);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(209);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_system_identifier);
      if (('!' <= lookahead && lookahead <= '=')) ADVANCE(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_question_mark_identifier);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_pointer_identifier);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_macro_identifier);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_macro_identifier);
      if (lookahead == '*' ||
          lookahead == '-') ADVANCE(244);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(249);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(250);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_html_redirect_operator);
      if (lookahead == '>') ADVANCE(253);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_html_redirect_operator);
      if (lookahead == '>') ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_html_append_operator);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_html_append_operator);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      if (lookahead == '>') ADVANCE(251);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(258);
      if (lookahead == '5') ADVANCE(260);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(258);
      if (lookahead == '>') ADVANCE(251);
      if (!sym__eq_sep_key_identifier_character_set_3(lookahead)) ADVANCE(262);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(258);
      if (lookahead == 'C') ADVANCE(261);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(258);
      if (lookahead == 's') ADVANCE(262);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(258);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(262);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym__any_command);
      if (lookahead == '#') ADVANCE(264);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(263);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(265);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym__any_command);
      if (lookahead == ';' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(290);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(264);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym__any_command);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(265);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '>') ADVANCE(251);
      if (lookahead == '\\') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(267);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead == '}') ADVANCE(267);
      if (aux_sym_arg_identifier_token1_character_set_4(lookahead)) ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(269);
      if (lookahead == ',') ADVANCE(267);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '{') ADVANCE(268);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(267);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(269);
      if (lookahead == '\\') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(267);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(271);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(271);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(273);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(273);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      if (lookahead == '(') ADVANCE(284);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(274);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      if (lookahead == '\n' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '\\' ||
          lookahead == '`') ADVANCE(276);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(279);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(279);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(281);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(281);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      if (lookahead == '\n' ||
          lookahead == '\'' ||
          lookahead == '\\') ADVANCE(282);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '|') ADVANCE(114);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym__dec_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(287);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym__dec_number_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(288);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead == '"') ADVANCE(290);
      if (lookahead == '\\') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(289);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(290);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(289);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_CR);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 62, .external_lex_state = 2},
  [2] = {.lex_state = 62, .external_lex_state = 3},
  [3] = {.lex_state = 62, .external_lex_state = 3},
  [4] = {.lex_state = 62, .external_lex_state = 3},
  [5] = {.lex_state = 62, .external_lex_state = 3},
  [6] = {.lex_state = 62, .external_lex_state = 2},
  [7] = {.lex_state = 62, .external_lex_state = 2},
  [8] = {.lex_state = 62, .external_lex_state = 2},
  [9] = {.lex_state = 62, .external_lex_state = 2},
  [10] = {.lex_state = 62, .external_lex_state = 2},
  [11] = {.lex_state = 62, .external_lex_state = 2},
  [12] = {.lex_state = 62, .external_lex_state = 2},
  [13] = {.lex_state = 62, .external_lex_state = 2},
  [14] = {.lex_state = 62, .external_lex_state = 2},
  [15] = {.lex_state = 62, .external_lex_state = 2},
  [16] = {.lex_state = 62, .external_lex_state = 2},
  [17] = {.lex_state = 62, .external_lex_state = 2},
  [18] = {.lex_state = 62, .external_lex_state = 2},
  [19] = {.lex_state = 62, .external_lex_state = 2},
  [20] = {.lex_state = 62, .external_lex_state = 2},
  [21] = {.lex_state = 62, .external_lex_state = 2},
  [22] = {.lex_state = 62, .external_lex_state = 2},
  [23] = {.lex_state = 62, .external_lex_state = 2},
  [24] = {.lex_state = 62, .external_lex_state = 2},
  [25] = {.lex_state = 62, .external_lex_state = 2},
  [26] = {.lex_state = 62, .external_lex_state = 2},
  [27] = {.lex_state = 62, .external_lex_state = 2},
  [28] = {.lex_state = 62, .external_lex_state = 2},
  [29] = {.lex_state = 62, .external_lex_state = 2},
  [30] = {.lex_state = 62, .external_lex_state = 2},
  [31] = {.lex_state = 62, .external_lex_state = 2},
  [32] = {.lex_state = 62, .external_lex_state = 2},
  [33] = {.lex_state = 62, .external_lex_state = 2},
  [34] = {.lex_state = 62, .external_lex_state = 2},
  [35] = {.lex_state = 62, .external_lex_state = 2},
  [36] = {.lex_state = 62, .external_lex_state = 2},
  [37] = {.lex_state = 62, .external_lex_state = 2},
  [38] = {.lex_state = 62, .external_lex_state = 2},
  [39] = {.lex_state = 62, .external_lex_state = 2},
  [40] = {.lex_state = 62, .external_lex_state = 2},
  [41] = {.lex_state = 62, .external_lex_state = 2},
  [42] = {.lex_state = 62, .external_lex_state = 2},
  [43] = {.lex_state = 62, .external_lex_state = 3},
  [44] = {.lex_state = 63, .external_lex_state = 4},
  [45] = {.lex_state = 63, .external_lex_state = 4},
  [46] = {.lex_state = 63, .external_lex_state = 4},
  [47] = {.lex_state = 63, .external_lex_state = 4},
  [48] = {.lex_state = 63, .external_lex_state = 4},
  [49] = {.lex_state = 63, .external_lex_state = 4},
  [50] = {.lex_state = 63, .external_lex_state = 4},
  [51] = {.lex_state = 63, .external_lex_state = 4},
  [52] = {.lex_state = 63, .external_lex_state = 4},
  [53] = {.lex_state = 63, .external_lex_state = 4},
  [54] = {.lex_state = 63, .external_lex_state = 4},
  [55] = {.lex_state = 63, .external_lex_state = 4},
  [56] = {.lex_state = 63, .external_lex_state = 4},
  [57] = {.lex_state = 67, .external_lex_state = 5},
  [58] = {.lex_state = 63, .external_lex_state = 4},
  [59] = {.lex_state = 63, .external_lex_state = 4},
  [60] = {.lex_state = 63, .external_lex_state = 4},
  [61] = {.lex_state = 63, .external_lex_state = 4},
  [62] = {.lex_state = 63, .external_lex_state = 4},
  [63] = {.lex_state = 63, .external_lex_state = 4},
  [64] = {.lex_state = 63, .external_lex_state = 4},
  [65] = {.lex_state = 63, .external_lex_state = 4},
  [66] = {.lex_state = 63, .external_lex_state = 4},
  [67] = {.lex_state = 63, .external_lex_state = 4},
  [68] = {.lex_state = 63, .external_lex_state = 4},
  [69] = {.lex_state = 63, .external_lex_state = 4},
  [70] = {.lex_state = 65, .external_lex_state = 4},
  [71] = {.lex_state = 67, .external_lex_state = 5},
  [72] = {.lex_state = 68, .external_lex_state = 4},
  [73] = {.lex_state = 68, .external_lex_state = 4},
  [74] = {.lex_state = 63, .external_lex_state = 6},
  [75] = {.lex_state = 63, .external_lex_state = 6},
  [76] = {.lex_state = 63, .external_lex_state = 6},
  [77] = {.lex_state = 63, .external_lex_state = 6},
  [78] = {.lex_state = 63, .external_lex_state = 6},
  [79] = {.lex_state = 63, .external_lex_state = 6},
  [80] = {.lex_state = 63, .external_lex_state = 6},
  [81] = {.lex_state = 63, .external_lex_state = 6},
  [82] = {.lex_state = 63, .external_lex_state = 6},
  [83] = {.lex_state = 63, .external_lex_state = 6},
  [84] = {.lex_state = 63, .external_lex_state = 6},
  [85] = {.lex_state = 63, .external_lex_state = 6},
  [86] = {.lex_state = 63, .external_lex_state = 6},
  [87] = {.lex_state = 63, .external_lex_state = 4},
  [88] = {.lex_state = 67, .external_lex_state = 5},
  [89] = {.lex_state = 68, .external_lex_state = 4},
  [90] = {.lex_state = 67, .external_lex_state = 5},
  [91] = {.lex_state = 65, .external_lex_state = 4},
  [92] = {.lex_state = 67, .external_lex_state = 5},
  [93] = {.lex_state = 67, .external_lex_state = 5},
  [94] = {.lex_state = 67, .external_lex_state = 5},
  [95] = {.lex_state = 67, .external_lex_state = 5},
  [96] = {.lex_state = 68, .external_lex_state = 6},
  [97] = {.lex_state = 67, .external_lex_state = 5},
  [98] = {.lex_state = 68, .external_lex_state = 6},
  [99] = {.lex_state = 68, .external_lex_state = 6},
  [100] = {.lex_state = 67, .external_lex_state = 5},
  [101] = {.lex_state = 68, .external_lex_state = 6},
  [102] = {.lex_state = 68, .external_lex_state = 6},
  [103] = {.lex_state = 68, .external_lex_state = 6},
  [104] = {.lex_state = 68, .external_lex_state = 6},
  [105] = {.lex_state = 68, .external_lex_state = 6},
  [106] = {.lex_state = 65, .external_lex_state = 4},
  [107] = {.lex_state = 66, .external_lex_state = 4},
  [108] = {.lex_state = 66, .external_lex_state = 4},
  [109] = {.lex_state = 68, .external_lex_state = 4},
  [110] = {.lex_state = 62, .external_lex_state = 7},
  [111] = {.lex_state = 62, .external_lex_state = 7},
  [112] = {.lex_state = 0, .external_lex_state = 8},
  [113] = {.lex_state = 62, .external_lex_state = 7},
  [114] = {.lex_state = 62, .external_lex_state = 5},
  [115] = {.lex_state = 69, .external_lex_state = 4},
  [116] = {.lex_state = 0, .external_lex_state = 8},
  [117] = {.lex_state = 62, .external_lex_state = 5},
  [118] = {.lex_state = 62, .external_lex_state = 5},
  [119] = {.lex_state = 62, .external_lex_state = 5},
  [120] = {.lex_state = 0, .external_lex_state = 8},
  [121] = {.lex_state = 62, .external_lex_state = 5},
  [122] = {.lex_state = 0, .external_lex_state = 8},
  [123] = {.lex_state = 62, .external_lex_state = 5},
  [124] = {.lex_state = 69, .external_lex_state = 4},
  [125] = {.lex_state = 62, .external_lex_state = 5},
  [126] = {.lex_state = 0, .external_lex_state = 8},
  [127] = {.lex_state = 0, .external_lex_state = 8},
  [128] = {.lex_state = 0, .external_lex_state = 4},
  [129] = {.lex_state = 0, .external_lex_state = 8},
  [130] = {.lex_state = 62, .external_lex_state = 7},
  [131] = {.lex_state = 62, .external_lex_state = 7},
  [132] = {.lex_state = 0, .external_lex_state = 8},
  [133] = {.lex_state = 0, .external_lex_state = 8},
  [134] = {.lex_state = 0, .external_lex_state = 4},
  [135] = {.lex_state = 62, .external_lex_state = 7},
  [136] = {.lex_state = 62, .external_lex_state = 5},
  [137] = {.lex_state = 66, .external_lex_state = 4},
  [138] = {.lex_state = 0, .external_lex_state = 8},
  [139] = {.lex_state = 0, .external_lex_state = 8},
  [140] = {.lex_state = 0, .external_lex_state = 8},
  [141] = {.lex_state = 62, .external_lex_state = 7},
  [142] = {.lex_state = 62, .external_lex_state = 7},
  [143] = {.lex_state = 66, .external_lex_state = 4},
  [144] = {.lex_state = 66, .external_lex_state = 4},
  [145] = {.lex_state = 0, .external_lex_state = 8},
  [146] = {.lex_state = 62, .external_lex_state = 7},
  [147] = {.lex_state = 62, .external_lex_state = 5},
  [148] = {.lex_state = 62, .external_lex_state = 5},
  [149] = {.lex_state = 62, .external_lex_state = 5},
  [150] = {.lex_state = 62, .external_lex_state = 7},
  [151] = {.lex_state = 0, .external_lex_state = 4},
  [152] = {.lex_state = 0, .external_lex_state = 7},
  [153] = {.lex_state = 62, .external_lex_state = 5},
  [154] = {.lex_state = 0, .external_lex_state = 4},
  [155] = {.lex_state = 0, .external_lex_state = 7},
  [156] = {.lex_state = 0, .external_lex_state = 8},
  [157] = {.lex_state = 66, .external_lex_state = 4},
  [158] = {.lex_state = 62, .external_lex_state = 4},
  [159] = {.lex_state = 0, .external_lex_state = 7},
  [160] = {.lex_state = 0, .external_lex_state = 4},
  [161] = {.lex_state = 0, .external_lex_state = 4},
  [162] = {.lex_state = 0, .external_lex_state = 4},
  [163] = {.lex_state = 0, .external_lex_state = 7},
  [164] = {.lex_state = 0, .external_lex_state = 4},
  [165] = {.lex_state = 0, .external_lex_state = 4},
  [166] = {.lex_state = 62, .external_lex_state = 4},
  [167] = {.lex_state = 66, .external_lex_state = 4},
  [168] = {.lex_state = 62, .external_lex_state = 4},
  [169] = {.lex_state = 0, .external_lex_state = 4},
  [170] = {.lex_state = 62, .external_lex_state = 4},
  [171] = {.lex_state = 0, .external_lex_state = 4},
  [172] = {.lex_state = 62, .external_lex_state = 4},
  [173] = {.lex_state = 0, .external_lex_state = 4},
  [174] = {.lex_state = 66, .external_lex_state = 4},
  [175] = {.lex_state = 0, .external_lex_state = 5},
  [176] = {.lex_state = 0, .external_lex_state = 4},
  [177] = {.lex_state = 0, .external_lex_state = 4},
  [178] = {.lex_state = 0, .external_lex_state = 4},
  [179] = {.lex_state = 0, .external_lex_state = 4},
  [180] = {.lex_state = 0, .external_lex_state = 4},
  [181] = {.lex_state = 0, .external_lex_state = 4},
  [182] = {.lex_state = 0, .external_lex_state = 4},
  [183] = {.lex_state = 0, .external_lex_state = 4},
  [184] = {.lex_state = 0, .external_lex_state = 4},
  [185] = {.lex_state = 0, .external_lex_state = 4},
  [186] = {.lex_state = 0, .external_lex_state = 4},
  [187] = {.lex_state = 0, .external_lex_state = 4},
  [188] = {.lex_state = 0, .external_lex_state = 4},
  [189] = {.lex_state = 0, .external_lex_state = 4},
  [190] = {.lex_state = 0, .external_lex_state = 4},
  [191] = {.lex_state = 0, .external_lex_state = 4},
  [192] = {.lex_state = 0, .external_lex_state = 4},
  [193] = {.lex_state = 0, .external_lex_state = 4},
  [194] = {.lex_state = 0, .external_lex_state = 4},
  [195] = {.lex_state = 0, .external_lex_state = 4},
  [196] = {.lex_state = 0, .external_lex_state = 4},
  [197] = {.lex_state = 0, .external_lex_state = 4},
  [198] = {.lex_state = 0, .external_lex_state = 4},
  [199] = {.lex_state = 0, .external_lex_state = 4},
  [200] = {.lex_state = 0, .external_lex_state = 4},
  [201] = {.lex_state = 0, .external_lex_state = 4},
  [202] = {.lex_state = 0, .external_lex_state = 4},
  [203] = {.lex_state = 0, .external_lex_state = 4},
  [204] = {.lex_state = 0, .external_lex_state = 4},
  [205] = {.lex_state = 0, .external_lex_state = 4},
  [206] = {.lex_state = 0, .external_lex_state = 4},
  [207] = {.lex_state = 0, .external_lex_state = 4},
  [208] = {.lex_state = 0, .external_lex_state = 4},
  [209] = {.lex_state = 0, .external_lex_state = 4},
  [210] = {.lex_state = 0, .external_lex_state = 4},
  [211] = {.lex_state = 62, .external_lex_state = 4},
  [212] = {.lex_state = 0, .external_lex_state = 4},
  [213] = {.lex_state = 0, .external_lex_state = 4},
  [214] = {.lex_state = 0, .external_lex_state = 4},
  [215] = {.lex_state = 0, .external_lex_state = 4},
  [216] = {.lex_state = 0, .external_lex_state = 4},
  [217] = {.lex_state = 0, .external_lex_state = 4},
  [218] = {.lex_state = 0, .external_lex_state = 4},
  [219] = {.lex_state = 0, .external_lex_state = 4},
  [220] = {.lex_state = 0, .external_lex_state = 4},
  [221] = {.lex_state = 0, .external_lex_state = 4},
  [222] = {.lex_state = 0, .external_lex_state = 4},
  [223] = {.lex_state = 0, .external_lex_state = 4},
  [224] = {.lex_state = 0, .external_lex_state = 4},
  [225] = {.lex_state = 0, .external_lex_state = 4},
  [226] = {.lex_state = 0, .external_lex_state = 4},
  [227] = {.lex_state = 0, .external_lex_state = 4},
  [228] = {.lex_state = 0, .external_lex_state = 4},
  [229] = {.lex_state = 66, .external_lex_state = 4},
  [230] = {.lex_state = 0, .external_lex_state = 4},
  [231] = {.lex_state = 0, .external_lex_state = 4},
  [232] = {.lex_state = 0, .external_lex_state = 4},
  [233] = {.lex_state = 0, .external_lex_state = 4},
  [234] = {.lex_state = 0, .external_lex_state = 4},
  [235] = {.lex_state = 0, .external_lex_state = 4},
  [236] = {.lex_state = 0, .external_lex_state = 4},
  [237] = {.lex_state = 0, .external_lex_state = 4},
  [238] = {.lex_state = 0, .external_lex_state = 4},
  [239] = {.lex_state = 0, .external_lex_state = 4},
  [240] = {.lex_state = 0, .external_lex_state = 4},
  [241] = {.lex_state = 0, .external_lex_state = 4},
  [242] = {.lex_state = 0, .external_lex_state = 4},
  [243] = {.lex_state = 0, .external_lex_state = 4},
  [244] = {.lex_state = 0, .external_lex_state = 4},
  [245] = {.lex_state = 0, .external_lex_state = 4},
  [246] = {.lex_state = 0, .external_lex_state = 4},
  [247] = {.lex_state = 0, .external_lex_state = 4},
  [248] = {.lex_state = 0, .external_lex_state = 4},
  [249] = {.lex_state = 0, .external_lex_state = 4},
  [250] = {.lex_state = 0, .external_lex_state = 4},
  [251] = {.lex_state = 0, .external_lex_state = 4},
  [252] = {.lex_state = 0, .external_lex_state = 4},
  [253] = {.lex_state = 0, .external_lex_state = 4},
  [254] = {.lex_state = 0, .external_lex_state = 4},
  [255] = {.lex_state = 0, .external_lex_state = 4},
  [256] = {.lex_state = 0, .external_lex_state = 4},
  [257] = {.lex_state = 0, .external_lex_state = 4},
  [258] = {.lex_state = 0, .external_lex_state = 4},
  [259] = {.lex_state = 0, .external_lex_state = 4},
  [260] = {.lex_state = 0, .external_lex_state = 4},
  [261] = {.lex_state = 0, .external_lex_state = 4},
  [262] = {.lex_state = 70, .external_lex_state = 4},
  [263] = {.lex_state = 0, .external_lex_state = 4},
  [264] = {.lex_state = 0, .external_lex_state = 4},
  [265] = {.lex_state = 0, .external_lex_state = 4},
  [266] = {.lex_state = 0, .external_lex_state = 4},
  [267] = {.lex_state = 9, .external_lex_state = 4},
  [268] = {.lex_state = 8, .external_lex_state = 4},
  [269] = {.lex_state = 0, .external_lex_state = 5},
  [270] = {.lex_state = 62, .external_lex_state = 4},
  [271] = {.lex_state = 0, .external_lex_state = 4},
  [272] = {.lex_state = 0, .external_lex_state = 4},
  [273] = {.lex_state = 62, .external_lex_state = 2},
  [274] = {.lex_state = 62, .external_lex_state = 2},
  [275] = {.lex_state = 64},
  [276] = {.lex_state = 64},
  [277] = {.lex_state = 64},
  [278] = {.lex_state = 64},
  [279] = {.lex_state = 64},
  [280] = {.lex_state = 64},
  [281] = {.lex_state = 64},
  [282] = {.lex_state = 64},
  [283] = {.lex_state = 64},
  [284] = {.lex_state = 64},
  [285] = {.lex_state = 64},
  [286] = {.lex_state = 64},
  [287] = {.lex_state = 64},
  [288] = {.lex_state = 64},
  [289] = {.lex_state = 64},
  [290] = {.lex_state = 64},
  [291] = {.lex_state = 64},
  [292] = {.lex_state = 64},
  [293] = {.lex_state = 64},
  [294] = {.lex_state = 64},
  [295] = {.lex_state = 64},
  [296] = {.lex_state = 64},
  [297] = {.lex_state = 64},
  [298] = {.lex_state = 64},
  [299] = {.lex_state = 64},
  [300] = {.lex_state = 64},
  [301] = {.lex_state = 64},
  [302] = {.lex_state = 64},
  [303] = {.lex_state = 64},
  [304] = {.lex_state = 64},
  [305] = {.lex_state = 64},
  [306] = {.lex_state = 64},
  [307] = {.lex_state = 64},
  [308] = {.lex_state = 64},
  [309] = {.lex_state = 64},
  [310] = {.lex_state = 64},
  [311] = {.lex_state = 64},
  [312] = {.lex_state = 64},
  [313] = {.lex_state = 64},
  [314] = {.lex_state = 64},
  [315] = {.lex_state = 64},
  [316] = {.lex_state = 64},
  [317] = {.lex_state = 64},
  [318] = {.lex_state = 64, .external_lex_state = 9},
  [319] = {.lex_state = 64, .external_lex_state = 9},
  [320] = {.lex_state = 64, .external_lex_state = 9},
  [321] = {.lex_state = 64, .external_lex_state = 9},
  [322] = {.lex_state = 64, .external_lex_state = 9},
  [323] = {.lex_state = 64, .external_lex_state = 9},
  [324] = {.lex_state = 64},
  [325] = {.lex_state = 64, .external_lex_state = 9},
  [326] = {.lex_state = 64},
  [327] = {.lex_state = 64},
  [328] = {.lex_state = 64, .external_lex_state = 9},
  [329] = {.lex_state = 64, .external_lex_state = 9},
  [330] = {.lex_state = 64, .external_lex_state = 9},
  [331] = {.lex_state = 64, .external_lex_state = 9},
  [332] = {.lex_state = 64, .external_lex_state = 9},
  [333] = {.lex_state = 64, .external_lex_state = 9},
  [334] = {.lex_state = 64},
  [335] = {.lex_state = 64},
  [336] = {.lex_state = 5},
  [337] = {.lex_state = 5},
  [338] = {.lex_state = 5},
  [339] = {.lex_state = 64},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 5},
  [342] = {.lex_state = 5},
  [343] = {.lex_state = 5},
  [344] = {.lex_state = 5},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 5},
  [347] = {.lex_state = 2},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 6},
  [352] = {.lex_state = 5},
  [353] = {.lex_state = 5},
  [354] = {.lex_state = 2},
  [355] = {.lex_state = 6},
  [356] = {.lex_state = 5, .external_lex_state = 9},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 64},
  [360] = {.lex_state = 3},
  [361] = {.lex_state = 3},
  [362] = {.lex_state = 64},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 5, .external_lex_state = 9},
  [367] = {.lex_state = 64},
  [368] = {.lex_state = 64},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 5, .external_lex_state = 9},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 64},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 5, .external_lex_state = 9},
  [378] = {.lex_state = 5, .external_lex_state = 9},
  [379] = {.lex_state = 6},
  [380] = {.lex_state = 6},
  [381] = {.lex_state = 4},
  [382] = {.lex_state = 5, .external_lex_state = 9},
  [383] = {.lex_state = 4},
  [384] = {.lex_state = 5, .external_lex_state = 9},
  [385] = {.lex_state = 5, .external_lex_state = 9},
  [386] = {.lex_state = 4},
  [387] = {.lex_state = 5, .external_lex_state = 9},
  [388] = {.lex_state = 5, .external_lex_state = 9},
  [389] = {.lex_state = 5, .external_lex_state = 9},
  [390] = {.lex_state = 5, .external_lex_state = 9},
  [391] = {.lex_state = 3},
  [392] = {.lex_state = 5, .external_lex_state = 9},
  [393] = {.lex_state = 5, .external_lex_state = 9},
  [394] = {.lex_state = 5, .external_lex_state = 9},
  [395] = {.lex_state = 5, .external_lex_state = 9},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 5, .external_lex_state = 9},
  [398] = {.lex_state = 5, .external_lex_state = 9},
  [399] = {.lex_state = 5, .external_lex_state = 9},
  [400] = {.lex_state = 5},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 5},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 10},
  [409] = {.lex_state = 10},
  [410] = {.lex_state = 10},
  [411] = {.lex_state = 10},
  [412] = {.lex_state = 10},
  [413] = {.lex_state = 10},
  [414] = {.lex_state = 10},
  [415] = {.lex_state = 10},
  [416] = {.lex_state = 10},
  [417] = {.lex_state = 10},
  [418] = {.lex_state = 10},
  [419] = {.lex_state = 10},
  [420] = {.lex_state = 10},
  [421] = {.lex_state = 7},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 7},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0, .external_lex_state = 10},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0, .external_lex_state = 10},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0, .external_lex_state = 10},
  [443] = {.lex_state = 0, .external_lex_state = 10},
  [444] = {.lex_state = 11},
  [445] = {.lex_state = 0, .external_lex_state = 10},
  [446] = {.lex_state = 0, .external_lex_state = 10},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0, .external_lex_state = 10},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 62},
  [452] = {.lex_state = 62},
  [453] = {.lex_state = 0, .external_lex_state = 10},
  [454] = {.lex_state = 0, .external_lex_state = 10},
  [455] = {.lex_state = 0, .external_lex_state = 10},
  [456] = {.lex_state = 0, .external_lex_state = 10},
  [457] = {.lex_state = 0, .external_lex_state = 11},
  [458] = {.lex_state = 0, .external_lex_state = 10},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 0, .external_lex_state = 11},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 6},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 1},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 0, .external_lex_state = 9},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 0},
  [481] = {.lex_state = 0, .external_lex_state = 9},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 0, .external_lex_state = 12},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 0},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 0},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 12},
  [498] = {.lex_state = 0, .external_lex_state = 12},
  [499] = {.lex_state = 0},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 1},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0, .external_lex_state = 12},
};

enum {
  ts_external_token_cmd_identifier = 0,
  ts_external_token__help_command = 1,
  ts_external_token_file_descriptor = 2,
  ts_external_token__eq_sep_concat = 3,
  ts_external_token__concat = 4,
  ts_external_token__concat_pf_dot = 5,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_cmd_identifier] = sym_cmd_identifier,
  [ts_external_token__help_command] = sym__help_command,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__eq_sep_concat] = sym__eq_sep_concat,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__concat_pf_dot] = sym__concat_pf_dot,
};

static bool ts_external_scanner_states[13][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_cmd_identifier] = true,
    [ts_external_token__help_command] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__concat_pf_dot] = true,
  },
  [2] = {
    [ts_external_token_cmd_identifier] = true,
    [ts_external_token__help_command] = true,
  },
  [3] = {
    [ts_external_token_cmd_identifier] = true,
    [ts_external_token__help_command] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [4] = {
    [ts_external_token_file_descriptor] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat_pf_dot] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [7] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token__concat] = true,
  },
  [10] = {
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token__eq_sep_concat] = true,
  },
  [12] = {
    [ts_external_token__concat_pf_dot] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PIPEH] = ACTIONS(1),
    [anon_sym_AT_AT_DOT] = ACTIONS(1),
    [anon_sym_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT] = ACTIONS(1),
    [anon_sym_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_ATC] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT_ATdbt] = ACTIONS(1),
    [anon_sym_AT_ATdbta] = ACTIONS(1),
    [anon_sym_AT_ATdbtb] = ACTIONS(1),
    [anon_sym_AT_ATdbts] = ACTIONS(1),
    [anon_sym_AT_ATt] = ACTIONS(1),
    [anon_sym_AT_ATb] = ACTIONS(1),
    [anon_sym_AT_ATi] = ACTIONS(1),
    [anon_sym_AT_ATii] = ACTIONS(1),
    [anon_sym_AT_ATiS] = ACTIONS(1),
    [anon_sym_AT_ATiSS] = ACTIONS(1),
    [anon_sym_AT_ATis] = ACTIONS(1),
    [anon_sym_AT_ATiz] = ACTIONS(1),
    [anon_sym_AT_ATf] = ACTIONS(1),
    [anon_sym_AT_ATF] = ACTIONS(1),
    [anon_sym_AT_ATom] = ACTIONS(1),
    [anon_sym_AT_ATdm] = ACTIONS(1),
    [anon_sym_AT_ATr] = ACTIONS(1),
    [anon_sym_AT_ATs_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_BANG] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_ATa_COLON] = ACTIONS(1),
    [anon_sym_ATb_COLON] = ACTIONS(1),
    [anon_sym_ATB_COLON] = ACTIONS(1),
    [anon_sym_ATe_COLON] = ACTIONS(1),
    [anon_sym_ATF_COLON] = ACTIONS(1),
    [anon_sym_ATi_COLON] = ACTIONS(1),
    [anon_sym_ATk_COLON] = ACTIONS(1),
    [anon_sym_ATo_COLON] = ACTIONS(1),
    [anon_sym_ATr_COLON] = ACTIONS(1),
    [anon_sym_ATf_COLON] = ACTIONS(1),
    [anon_sym_ATs_COLON] = ACTIONS(1),
    [anon_sym_ATv_COLON] = ACTIONS(1),
    [anon_sym_ATx_COLON] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [aux_sym__search_command_token1] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_LPAREN] = ACTIONS(1),
    [anon_sym_PIPE_DOT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [sym_question_mark_identifier] = ACTIONS(1),
    [sym_pointer_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [sym_html_redirect_operator] = ACTIONS(1),
    [sym_html_append_operator] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_tmp_eval_arg_token1] = ACTIONS(1),
    [aux_sym_double_quoted_arg_token3] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_CR] = ACTIONS(1),
    [sym_cmd_identifier] = ACTIONS(1),
    [sym__help_command] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__eq_sep_concat] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym__concat_pf_dot] = ACTIONS(1),
  },
  [1] = {
    [sym_commands] = STATE(495),
    [sym__command] = STATE(407),
    [sym_legacy_quoted_command] = STATE(160),
    [sym__simple_command] = STATE(160),
    [sym__tmp_command] = STATE(160),
    [sym__iter_command] = STATE(160),
    [sym__pipe_command] = STATE(160),
    [sym_grep_command] = STATE(160),
    [sym_html_disable_command] = STATE(160),
    [sym_html_enable_command] = STATE(160),
    [sym_pipe_command] = STATE(160),
    [sym_iter_file_lines_command] = STATE(160),
    [sym_iter_offsets_command] = STATE(160),
    [sym_iter_offsetssizes_command] = STATE(160),
    [sym_iter_hit_command] = STATE(160),
    [sym_iter_interpret_command] = STATE(160),
    [sym_iter_interpret_offsetssizes_command] = STATE(160),
    [sym_iter_comment_command] = STATE(160),
    [sym_iter_dbta_command] = STATE(160),
    [sym_iter_dbtb_command] = STATE(160),
    [sym_iter_dbts_command] = STATE(160),
    [sym_iter_threads_command] = STATE(160),
    [sym_iter_bbs_command] = STATE(160),
    [sym_iter_instrs_command] = STATE(160),
    [sym_iter_import_command] = STATE(160),
    [sym_iter_sections_command] = STATE(160),
    [sym_iter_segments_command] = STATE(160),
    [sym_iter_symbol_command] = STATE(160),
    [sym_iter_string_command] = STATE(160),
    [sym_iter_flags_command] = STATE(160),
    [sym_iter_function_command] = STATE(160),
    [sym_iter_iomap_command] = STATE(160),
    [sym_iter_dbgmap_command] = STATE(160),
    [sym_iter_register_command] = STATE(160),
    [sym_iter_step_command] = STATE(160),
    [sym_tmp_seek_command] = STATE(160),
    [sym_tmp_blksz_command] = STATE(160),
    [sym_tmp_fromto_command] = STATE(160),
    [sym_tmp_arch_command] = STATE(160),
    [sym_tmp_bits_command] = STATE(160),
    [sym_tmp_nthi_command] = STATE(160),
    [sym_tmp_eval_command] = STATE(160),
    [sym_tmp_fs_command] = STATE(160),
    [sym_tmp_reli_command] = STATE(160),
    [sym_tmp_kuery_command] = STATE(160),
    [sym_tmp_fd_command] = STATE(160),
    [sym_tmp_reg_command] = STATE(160),
    [sym_tmp_file_command] = STATE(160),
    [sym_tmp_string_command] = STATE(160),
    [sym_tmp_value_command] = STATE(160),
    [sym_tmp_hex_command] = STATE(160),
    [sym_number_command] = STATE(160),
    [sym_help_command] = STATE(160),
    [sym_arged_command] = STATE(160),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(160),
    [sym_Cf_cmd] = STATE(160),
    [sym_pf_new_cmd] = STATE(160),
    [sym_pf_dot_cmd] = STATE(160),
    [sym_pf_cmd] = STATE(160),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(160),
    [sym_redirect_command] = STATE(407),
    [sym__dec_number] = STATE(2),
    [aux_sym_commands_repeat1] = STATE(6),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(47),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(47),
    [anon_sym_CR] = ACTIONS(47),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [2] = {
    [sym_legacy_quoted_command] = STATE(188),
    [sym__simple_command] = STATE(188),
    [sym__tmp_command] = STATE(188),
    [sym__iter_command] = STATE(188),
    [sym__pipe_command] = STATE(188),
    [sym_grep_command] = STATE(188),
    [sym_html_disable_command] = STATE(188),
    [sym_html_enable_command] = STATE(188),
    [sym_pipe_command] = STATE(188),
    [sym_iter_file_lines_command] = STATE(188),
    [sym_iter_offsets_command] = STATE(188),
    [sym_iter_offsetssizes_command] = STATE(188),
    [sym_iter_hit_command] = STATE(188),
    [sym_iter_interpret_command] = STATE(188),
    [sym_iter_interpret_offsetssizes_command] = STATE(188),
    [sym_iter_comment_command] = STATE(188),
    [sym_iter_dbta_command] = STATE(188),
    [sym_iter_dbtb_command] = STATE(188),
    [sym_iter_dbts_command] = STATE(188),
    [sym_iter_threads_command] = STATE(188),
    [sym_iter_bbs_command] = STATE(188),
    [sym_iter_instrs_command] = STATE(188),
    [sym_iter_import_command] = STATE(188),
    [sym_iter_sections_command] = STATE(188),
    [sym_iter_segments_command] = STATE(188),
    [sym_iter_symbol_command] = STATE(188),
    [sym_iter_string_command] = STATE(188),
    [sym_iter_flags_command] = STATE(188),
    [sym_iter_function_command] = STATE(188),
    [sym_iter_iomap_command] = STATE(188),
    [sym_iter_dbgmap_command] = STATE(188),
    [sym_iter_register_command] = STATE(188),
    [sym_iter_step_command] = STATE(188),
    [sym_tmp_seek_command] = STATE(188),
    [sym_tmp_blksz_command] = STATE(188),
    [sym_tmp_fromto_command] = STATE(188),
    [sym_tmp_arch_command] = STATE(188),
    [sym_tmp_bits_command] = STATE(188),
    [sym_tmp_nthi_command] = STATE(188),
    [sym_tmp_eval_command] = STATE(188),
    [sym_tmp_fs_command] = STATE(188),
    [sym_tmp_reli_command] = STATE(188),
    [sym_tmp_kuery_command] = STATE(188),
    [sym_tmp_fd_command] = STATE(188),
    [sym_tmp_reg_command] = STATE(188),
    [sym_tmp_file_command] = STATE(188),
    [sym_tmp_string_command] = STATE(188),
    [sym_tmp_value_command] = STATE(188),
    [sym_tmp_hex_command] = STATE(188),
    [sym_number_command] = STATE(188),
    [sym_help_command] = STATE(188),
    [sym_arged_command] = STATE(188),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(188),
    [sym_Cf_cmd] = STATE(188),
    [sym_pf_new_cmd] = STATE(188),
    [sym_pf_dot_cmd] = STATE(188),
    [sym_pf_cmd] = STATE(188),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(188),
    [sym__dec_number] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(57),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_PIPEH] = ACTIONS(57),
    [anon_sym_AT_AT_DOT] = ACTIONS(57),
    [anon_sym_AT_AT_EQ] = ACTIONS(57),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(57),
    [anon_sym_AT_AT] = ACTIONS(59),
    [anon_sym_AT_ATc_COLON] = ACTIONS(57),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(57),
    [anon_sym_AT_ATC] = ACTIONS(57),
    [anon_sym_AT_ATdbt] = ACTIONS(59),
    [anon_sym_AT_ATdbta] = ACTIONS(57),
    [anon_sym_AT_ATdbtb] = ACTIONS(57),
    [anon_sym_AT_ATdbts] = ACTIONS(57),
    [anon_sym_AT_ATt] = ACTIONS(57),
    [anon_sym_AT_ATb] = ACTIONS(57),
    [anon_sym_AT_ATi] = ACTIONS(59),
    [anon_sym_AT_ATii] = ACTIONS(57),
    [anon_sym_AT_ATiS] = ACTIONS(59),
    [anon_sym_AT_ATiSS] = ACTIONS(57),
    [anon_sym_AT_ATis] = ACTIONS(57),
    [anon_sym_AT_ATiz] = ACTIONS(57),
    [anon_sym_AT_ATf] = ACTIONS(57),
    [anon_sym_AT_ATF] = ACTIONS(57),
    [anon_sym_AT_ATom] = ACTIONS(57),
    [anon_sym_AT_ATdm] = ACTIONS(57),
    [anon_sym_AT_ATr] = ACTIONS(57),
    [anon_sym_AT_ATs_COLON] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [anon_sym_AT_BANG] = ACTIONS(57),
    [anon_sym_AT_LPAREN] = ACTIONS(57),
    [anon_sym_RPAREN] = ACTIONS(57),
    [anon_sym_ATa_COLON] = ACTIONS(57),
    [anon_sym_ATb_COLON] = ACTIONS(57),
    [anon_sym_ATB_COLON] = ACTIONS(57),
    [anon_sym_ATe_COLON] = ACTIONS(57),
    [anon_sym_ATF_COLON] = ACTIONS(57),
    [anon_sym_ATi_COLON] = ACTIONS(57),
    [anon_sym_ATk_COLON] = ACTIONS(57),
    [anon_sym_ATo_COLON] = ACTIONS(57),
    [anon_sym_ATr_COLON] = ACTIONS(57),
    [anon_sym_ATf_COLON] = ACTIONS(57),
    [anon_sym_ATs_COLON] = ACTIONS(57),
    [anon_sym_ATv_COLON] = ACTIONS(57),
    [anon_sym_ATx_COLON] = ACTIONS(57),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_PIPE_DOT] = ACTIONS(57),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(57),
    [sym_html_redirect_operator] = ACTIONS(59),
    [sym_html_append_operator] = ACTIONS(57),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(57),
    [anon_sym_CR] = ACTIONS(57),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
    [sym_file_descriptor] = ACTIONS(57),
  },
  [3] = {
    [sym_legacy_quoted_command] = STATE(218),
    [sym__simple_command] = STATE(218),
    [sym__tmp_command] = STATE(218),
    [sym__iter_command] = STATE(218),
    [sym__pipe_command] = STATE(218),
    [sym_grep_command] = STATE(218),
    [sym_html_disable_command] = STATE(218),
    [sym_html_enable_command] = STATE(218),
    [sym_pipe_command] = STATE(218),
    [sym_iter_file_lines_command] = STATE(218),
    [sym_iter_offsets_command] = STATE(218),
    [sym_iter_offsetssizes_command] = STATE(218),
    [sym_iter_hit_command] = STATE(218),
    [sym_iter_interpret_command] = STATE(218),
    [sym_iter_interpret_offsetssizes_command] = STATE(218),
    [sym_iter_comment_command] = STATE(218),
    [sym_iter_dbta_command] = STATE(218),
    [sym_iter_dbtb_command] = STATE(218),
    [sym_iter_dbts_command] = STATE(218),
    [sym_iter_threads_command] = STATE(218),
    [sym_iter_bbs_command] = STATE(218),
    [sym_iter_instrs_command] = STATE(218),
    [sym_iter_import_command] = STATE(218),
    [sym_iter_sections_command] = STATE(218),
    [sym_iter_segments_command] = STATE(218),
    [sym_iter_symbol_command] = STATE(218),
    [sym_iter_string_command] = STATE(218),
    [sym_iter_flags_command] = STATE(218),
    [sym_iter_function_command] = STATE(218),
    [sym_iter_iomap_command] = STATE(218),
    [sym_iter_dbgmap_command] = STATE(218),
    [sym_iter_register_command] = STATE(218),
    [sym_iter_step_command] = STATE(218),
    [sym_tmp_seek_command] = STATE(218),
    [sym_tmp_blksz_command] = STATE(218),
    [sym_tmp_fromto_command] = STATE(218),
    [sym_tmp_arch_command] = STATE(218),
    [sym_tmp_bits_command] = STATE(218),
    [sym_tmp_nthi_command] = STATE(218),
    [sym_tmp_eval_command] = STATE(218),
    [sym_tmp_fs_command] = STATE(218),
    [sym_tmp_reli_command] = STATE(218),
    [sym_tmp_kuery_command] = STATE(218),
    [sym_tmp_fd_command] = STATE(218),
    [sym_tmp_reg_command] = STATE(218),
    [sym_tmp_file_command] = STATE(218),
    [sym_tmp_string_command] = STATE(218),
    [sym_tmp_value_command] = STATE(218),
    [sym_tmp_hex_command] = STATE(218),
    [sym_number_command] = STATE(218),
    [sym_help_command] = STATE(218),
    [sym_arged_command] = STATE(218),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(218),
    [sym_Cf_cmd] = STATE(218),
    [sym_pf_new_cmd] = STATE(218),
    [sym_pf_dot_cmd] = STATE(218),
    [sym_pf_cmd] = STATE(218),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(218),
    [sym__dec_number] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_PIPE] = ACTIONS(63),
    [anon_sym_PIPEH] = ACTIONS(61),
    [anon_sym_AT_AT_DOT] = ACTIONS(61),
    [anon_sym_AT_AT_EQ] = ACTIONS(61),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(61),
    [anon_sym_AT_AT] = ACTIONS(63),
    [anon_sym_AT_ATc_COLON] = ACTIONS(61),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(61),
    [anon_sym_AT_ATC] = ACTIONS(61),
    [anon_sym_AT_ATdbt] = ACTIONS(63),
    [anon_sym_AT_ATdbta] = ACTIONS(61),
    [anon_sym_AT_ATdbtb] = ACTIONS(61),
    [anon_sym_AT_ATdbts] = ACTIONS(61),
    [anon_sym_AT_ATt] = ACTIONS(61),
    [anon_sym_AT_ATb] = ACTIONS(61),
    [anon_sym_AT_ATi] = ACTIONS(63),
    [anon_sym_AT_ATii] = ACTIONS(61),
    [anon_sym_AT_ATiS] = ACTIONS(63),
    [anon_sym_AT_ATiSS] = ACTIONS(61),
    [anon_sym_AT_ATis] = ACTIONS(61),
    [anon_sym_AT_ATiz] = ACTIONS(61),
    [anon_sym_AT_ATf] = ACTIONS(61),
    [anon_sym_AT_ATF] = ACTIONS(61),
    [anon_sym_AT_ATom] = ACTIONS(61),
    [anon_sym_AT_ATdm] = ACTIONS(61),
    [anon_sym_AT_ATr] = ACTIONS(61),
    [anon_sym_AT_ATs_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_AT_BANG] = ACTIONS(61),
    [anon_sym_AT_LPAREN] = ACTIONS(61),
    [anon_sym_RPAREN] = ACTIONS(61),
    [anon_sym_ATa_COLON] = ACTIONS(61),
    [anon_sym_ATb_COLON] = ACTIONS(61),
    [anon_sym_ATB_COLON] = ACTIONS(61),
    [anon_sym_ATe_COLON] = ACTIONS(61),
    [anon_sym_ATF_COLON] = ACTIONS(61),
    [anon_sym_ATi_COLON] = ACTIONS(61),
    [anon_sym_ATk_COLON] = ACTIONS(61),
    [anon_sym_ATo_COLON] = ACTIONS(61),
    [anon_sym_ATr_COLON] = ACTIONS(61),
    [anon_sym_ATf_COLON] = ACTIONS(61),
    [anon_sym_ATs_COLON] = ACTIONS(61),
    [anon_sym_ATv_COLON] = ACTIONS(61),
    [anon_sym_ATx_COLON] = ACTIONS(61),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_PIPE_DOT] = ACTIONS(61),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(63),
    [anon_sym_GT_GT] = ACTIONS(61),
    [sym_html_redirect_operator] = ACTIONS(63),
    [sym_html_append_operator] = ACTIONS(61),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(61),
    [anon_sym_CR] = ACTIONS(61),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
    [sym_file_descriptor] = ACTIONS(61),
  },
  [4] = {
    [sym_legacy_quoted_command] = STATE(218),
    [sym__simple_command] = STATE(218),
    [sym__tmp_command] = STATE(218),
    [sym__iter_command] = STATE(218),
    [sym__pipe_command] = STATE(218),
    [sym_grep_command] = STATE(218),
    [sym_html_disable_command] = STATE(218),
    [sym_html_enable_command] = STATE(218),
    [sym_pipe_command] = STATE(218),
    [sym_iter_file_lines_command] = STATE(218),
    [sym_iter_offsets_command] = STATE(218),
    [sym_iter_offsetssizes_command] = STATE(218),
    [sym_iter_hit_command] = STATE(218),
    [sym_iter_interpret_command] = STATE(218),
    [sym_iter_interpret_offsetssizes_command] = STATE(218),
    [sym_iter_comment_command] = STATE(218),
    [sym_iter_dbta_command] = STATE(218),
    [sym_iter_dbtb_command] = STATE(218),
    [sym_iter_dbts_command] = STATE(218),
    [sym_iter_threads_command] = STATE(218),
    [sym_iter_bbs_command] = STATE(218),
    [sym_iter_instrs_command] = STATE(218),
    [sym_iter_import_command] = STATE(218),
    [sym_iter_sections_command] = STATE(218),
    [sym_iter_segments_command] = STATE(218),
    [sym_iter_symbol_command] = STATE(218),
    [sym_iter_string_command] = STATE(218),
    [sym_iter_flags_command] = STATE(218),
    [sym_iter_function_command] = STATE(218),
    [sym_iter_iomap_command] = STATE(218),
    [sym_iter_dbgmap_command] = STATE(218),
    [sym_iter_register_command] = STATE(218),
    [sym_iter_step_command] = STATE(218),
    [sym_tmp_seek_command] = STATE(218),
    [sym_tmp_blksz_command] = STATE(218),
    [sym_tmp_fromto_command] = STATE(218),
    [sym_tmp_arch_command] = STATE(218),
    [sym_tmp_bits_command] = STATE(218),
    [sym_tmp_nthi_command] = STATE(218),
    [sym_tmp_eval_command] = STATE(218),
    [sym_tmp_fs_command] = STATE(218),
    [sym_tmp_reli_command] = STATE(218),
    [sym_tmp_kuery_command] = STATE(218),
    [sym_tmp_fd_command] = STATE(218),
    [sym_tmp_reg_command] = STATE(218),
    [sym_tmp_file_command] = STATE(218),
    [sym_tmp_string_command] = STATE(218),
    [sym_tmp_value_command] = STATE(218),
    [sym_tmp_hex_command] = STATE(218),
    [sym_number_command] = STATE(218),
    [sym_help_command] = STATE(218),
    [sym_arged_command] = STATE(218),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(218),
    [sym_Cf_cmd] = STATE(218),
    [sym_pf_new_cmd] = STATE(218),
    [sym_pf_dot_cmd] = STATE(218),
    [sym_pf_cmd] = STATE(218),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(218),
    [sym__dec_number] = STATE(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(61),
    [anon_sym_PIPE] = ACTIONS(63),
    [anon_sym_PIPEH] = ACTIONS(61),
    [anon_sym_AT_AT_DOT] = ACTIONS(61),
    [anon_sym_AT_AT_EQ] = ACTIONS(61),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(61),
    [anon_sym_AT_AT] = ACTIONS(63),
    [anon_sym_AT_ATc_COLON] = ACTIONS(61),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(61),
    [anon_sym_AT_ATC] = ACTIONS(61),
    [anon_sym_AT_ATdbt] = ACTIONS(63),
    [anon_sym_AT_ATdbta] = ACTIONS(61),
    [anon_sym_AT_ATdbtb] = ACTIONS(61),
    [anon_sym_AT_ATdbts] = ACTIONS(61),
    [anon_sym_AT_ATt] = ACTIONS(61),
    [anon_sym_AT_ATb] = ACTIONS(61),
    [anon_sym_AT_ATi] = ACTIONS(63),
    [anon_sym_AT_ATii] = ACTIONS(61),
    [anon_sym_AT_ATiS] = ACTIONS(63),
    [anon_sym_AT_ATiSS] = ACTIONS(61),
    [anon_sym_AT_ATis] = ACTIONS(61),
    [anon_sym_AT_ATiz] = ACTIONS(61),
    [anon_sym_AT_ATf] = ACTIONS(61),
    [anon_sym_AT_ATF] = ACTIONS(61),
    [anon_sym_AT_ATom] = ACTIONS(61),
    [anon_sym_AT_ATdm] = ACTIONS(61),
    [anon_sym_AT_ATr] = ACTIONS(61),
    [anon_sym_AT_ATs_COLON] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_AT_BANG] = ACTIONS(61),
    [anon_sym_AT_LPAREN] = ACTIONS(61),
    [anon_sym_ATa_COLON] = ACTIONS(61),
    [anon_sym_ATb_COLON] = ACTIONS(61),
    [anon_sym_ATB_COLON] = ACTIONS(61),
    [anon_sym_ATe_COLON] = ACTIONS(61),
    [anon_sym_ATF_COLON] = ACTIONS(61),
    [anon_sym_ATi_COLON] = ACTIONS(61),
    [anon_sym_ATk_COLON] = ACTIONS(61),
    [anon_sym_ATo_COLON] = ACTIONS(61),
    [anon_sym_ATr_COLON] = ACTIONS(61),
    [anon_sym_ATf_COLON] = ACTIONS(61),
    [anon_sym_ATs_COLON] = ACTIONS(61),
    [anon_sym_ATv_COLON] = ACTIONS(61),
    [anon_sym_ATx_COLON] = ACTIONS(61),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_PIPE_DOT] = ACTIONS(61),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(63),
    [anon_sym_GT_GT] = ACTIONS(61),
    [sym_html_redirect_operator] = ACTIONS(63),
    [sym_html_append_operator] = ACTIONS(61),
    [anon_sym_BQUOTE] = ACTIONS(61),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
    [sym_file_descriptor] = ACTIONS(61),
  },
  [5] = {
    [sym_legacy_quoted_command] = STATE(188),
    [sym__simple_command] = STATE(188),
    [sym__tmp_command] = STATE(188),
    [sym__iter_command] = STATE(188),
    [sym__pipe_command] = STATE(188),
    [sym_grep_command] = STATE(188),
    [sym_html_disable_command] = STATE(188),
    [sym_html_enable_command] = STATE(188),
    [sym_pipe_command] = STATE(188),
    [sym_iter_file_lines_command] = STATE(188),
    [sym_iter_offsets_command] = STATE(188),
    [sym_iter_offsetssizes_command] = STATE(188),
    [sym_iter_hit_command] = STATE(188),
    [sym_iter_interpret_command] = STATE(188),
    [sym_iter_interpret_offsetssizes_command] = STATE(188),
    [sym_iter_comment_command] = STATE(188),
    [sym_iter_dbta_command] = STATE(188),
    [sym_iter_dbtb_command] = STATE(188),
    [sym_iter_dbts_command] = STATE(188),
    [sym_iter_threads_command] = STATE(188),
    [sym_iter_bbs_command] = STATE(188),
    [sym_iter_instrs_command] = STATE(188),
    [sym_iter_import_command] = STATE(188),
    [sym_iter_sections_command] = STATE(188),
    [sym_iter_segments_command] = STATE(188),
    [sym_iter_symbol_command] = STATE(188),
    [sym_iter_string_command] = STATE(188),
    [sym_iter_flags_command] = STATE(188),
    [sym_iter_function_command] = STATE(188),
    [sym_iter_iomap_command] = STATE(188),
    [sym_iter_dbgmap_command] = STATE(188),
    [sym_iter_register_command] = STATE(188),
    [sym_iter_step_command] = STATE(188),
    [sym_tmp_seek_command] = STATE(188),
    [sym_tmp_blksz_command] = STATE(188),
    [sym_tmp_fromto_command] = STATE(188),
    [sym_tmp_arch_command] = STATE(188),
    [sym_tmp_bits_command] = STATE(188),
    [sym_tmp_nthi_command] = STATE(188),
    [sym_tmp_eval_command] = STATE(188),
    [sym_tmp_fs_command] = STATE(188),
    [sym_tmp_reli_command] = STATE(188),
    [sym_tmp_kuery_command] = STATE(188),
    [sym_tmp_fd_command] = STATE(188),
    [sym_tmp_reg_command] = STATE(188),
    [sym_tmp_file_command] = STATE(188),
    [sym_tmp_string_command] = STATE(188),
    [sym_tmp_value_command] = STATE(188),
    [sym_tmp_hex_command] = STATE(188),
    [sym_number_command] = STATE(188),
    [sym_help_command] = STATE(188),
    [sym_arged_command] = STATE(188),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(188),
    [sym_Cf_cmd] = STATE(188),
    [sym_pf_new_cmd] = STATE(188),
    [sym_pf_dot_cmd] = STATE(188),
    [sym_pf_cmd] = STATE(188),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(188),
    [sym__dec_number] = STATE(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_PIPE] = ACTIONS(59),
    [anon_sym_PIPEH] = ACTIONS(57),
    [anon_sym_AT_AT_DOT] = ACTIONS(57),
    [anon_sym_AT_AT_EQ] = ACTIONS(57),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(57),
    [anon_sym_AT_AT] = ACTIONS(59),
    [anon_sym_AT_ATc_COLON] = ACTIONS(57),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(57),
    [anon_sym_AT_ATC] = ACTIONS(57),
    [anon_sym_AT_ATdbt] = ACTIONS(59),
    [anon_sym_AT_ATdbta] = ACTIONS(57),
    [anon_sym_AT_ATdbtb] = ACTIONS(57),
    [anon_sym_AT_ATdbts] = ACTIONS(57),
    [anon_sym_AT_ATt] = ACTIONS(57),
    [anon_sym_AT_ATb] = ACTIONS(57),
    [anon_sym_AT_ATi] = ACTIONS(59),
    [anon_sym_AT_ATii] = ACTIONS(57),
    [anon_sym_AT_ATiS] = ACTIONS(59),
    [anon_sym_AT_ATiSS] = ACTIONS(57),
    [anon_sym_AT_ATis] = ACTIONS(57),
    [anon_sym_AT_ATiz] = ACTIONS(57),
    [anon_sym_AT_ATf] = ACTIONS(57),
    [anon_sym_AT_ATF] = ACTIONS(57),
    [anon_sym_AT_ATom] = ACTIONS(57),
    [anon_sym_AT_ATdm] = ACTIONS(57),
    [anon_sym_AT_ATr] = ACTIONS(57),
    [anon_sym_AT_ATs_COLON] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [anon_sym_AT_BANG] = ACTIONS(57),
    [anon_sym_AT_LPAREN] = ACTIONS(57),
    [anon_sym_ATa_COLON] = ACTIONS(57),
    [anon_sym_ATb_COLON] = ACTIONS(57),
    [anon_sym_ATB_COLON] = ACTIONS(57),
    [anon_sym_ATe_COLON] = ACTIONS(57),
    [anon_sym_ATF_COLON] = ACTIONS(57),
    [anon_sym_ATi_COLON] = ACTIONS(57),
    [anon_sym_ATk_COLON] = ACTIONS(57),
    [anon_sym_ATo_COLON] = ACTIONS(57),
    [anon_sym_ATr_COLON] = ACTIONS(57),
    [anon_sym_ATf_COLON] = ACTIONS(57),
    [anon_sym_ATs_COLON] = ACTIONS(57),
    [anon_sym_ATv_COLON] = ACTIONS(57),
    [anon_sym_ATx_COLON] = ACTIONS(57),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_PIPE_DOT] = ACTIONS(57),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(59),
    [anon_sym_GT_GT] = ACTIONS(57),
    [sym_html_redirect_operator] = ACTIONS(59),
    [sym_html_append_operator] = ACTIONS(57),
    [anon_sym_BQUOTE] = ACTIONS(57),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
    [sym_file_descriptor] = ACTIONS(57),
  },
  [6] = {
    [sym__command] = STATE(402),
    [sym_legacy_quoted_command] = STATE(160),
    [sym__simple_command] = STATE(160),
    [sym__tmp_command] = STATE(160),
    [sym__iter_command] = STATE(160),
    [sym__pipe_command] = STATE(160),
    [sym_grep_command] = STATE(160),
    [sym_html_disable_command] = STATE(160),
    [sym_html_enable_command] = STATE(160),
    [sym_pipe_command] = STATE(160),
    [sym_iter_file_lines_command] = STATE(160),
    [sym_iter_offsets_command] = STATE(160),
    [sym_iter_offsetssizes_command] = STATE(160),
    [sym_iter_hit_command] = STATE(160),
    [sym_iter_interpret_command] = STATE(160),
    [sym_iter_interpret_offsetssizes_command] = STATE(160),
    [sym_iter_comment_command] = STATE(160),
    [sym_iter_dbta_command] = STATE(160),
    [sym_iter_dbtb_command] = STATE(160),
    [sym_iter_dbts_command] = STATE(160),
    [sym_iter_threads_command] = STATE(160),
    [sym_iter_bbs_command] = STATE(160),
    [sym_iter_instrs_command] = STATE(160),
    [sym_iter_import_command] = STATE(160),
    [sym_iter_sections_command] = STATE(160),
    [sym_iter_segments_command] = STATE(160),
    [sym_iter_symbol_command] = STATE(160),
    [sym_iter_string_command] = STATE(160),
    [sym_iter_flags_command] = STATE(160),
    [sym_iter_function_command] = STATE(160),
    [sym_iter_iomap_command] = STATE(160),
    [sym_iter_dbgmap_command] = STATE(160),
    [sym_iter_register_command] = STATE(160),
    [sym_iter_step_command] = STATE(160),
    [sym_tmp_seek_command] = STATE(160),
    [sym_tmp_blksz_command] = STATE(160),
    [sym_tmp_fromto_command] = STATE(160),
    [sym_tmp_arch_command] = STATE(160),
    [sym_tmp_bits_command] = STATE(160),
    [sym_tmp_nthi_command] = STATE(160),
    [sym_tmp_eval_command] = STATE(160),
    [sym_tmp_fs_command] = STATE(160),
    [sym_tmp_reli_command] = STATE(160),
    [sym_tmp_kuery_command] = STATE(160),
    [sym_tmp_fd_command] = STATE(160),
    [sym_tmp_reg_command] = STATE(160),
    [sym_tmp_file_command] = STATE(160),
    [sym_tmp_string_command] = STATE(160),
    [sym_tmp_value_command] = STATE(160),
    [sym_tmp_hex_command] = STATE(160),
    [sym_number_command] = STATE(160),
    [sym_help_command] = STATE(160),
    [sym_arged_command] = STATE(160),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(160),
    [sym_Cf_cmd] = STATE(160),
    [sym_pf_new_cmd] = STATE(160),
    [sym_pf_dot_cmd] = STATE(160),
    [sym_pf_cmd] = STATE(160),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(160),
    [sym_redirect_command] = STATE(402),
    [sym__dec_number] = STATE(2),
    [aux_sym_commands_repeat1] = STATE(273),
    [ts_builtin_sym_end] = ACTIONS(91),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(93),
    [anon_sym_CR] = ACTIONS(93),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [7] = {
    [sym__command] = STATE(422),
    [sym_legacy_quoted_command] = STATE(160),
    [sym__simple_command] = STATE(160),
    [sym__tmp_command] = STATE(160),
    [sym__iter_command] = STATE(160),
    [sym__pipe_command] = STATE(160),
    [sym_grep_command] = STATE(160),
    [sym_html_disable_command] = STATE(160),
    [sym_html_enable_command] = STATE(160),
    [sym_pipe_command] = STATE(160),
    [sym_iter_file_lines_command] = STATE(160),
    [sym_iter_offsets_command] = STATE(160),
    [sym_iter_offsetssizes_command] = STATE(160),
    [sym_iter_hit_command] = STATE(160),
    [sym_iter_interpret_command] = STATE(160),
    [sym_iter_interpret_offsetssizes_command] = STATE(160),
    [sym_iter_comment_command] = STATE(160),
    [sym_iter_dbta_command] = STATE(160),
    [sym_iter_dbtb_command] = STATE(160),
    [sym_iter_dbts_command] = STATE(160),
    [sym_iter_threads_command] = STATE(160),
    [sym_iter_bbs_command] = STATE(160),
    [sym_iter_instrs_command] = STATE(160),
    [sym_iter_import_command] = STATE(160),
    [sym_iter_sections_command] = STATE(160),
    [sym_iter_segments_command] = STATE(160),
    [sym_iter_symbol_command] = STATE(160),
    [sym_iter_string_command] = STATE(160),
    [sym_iter_flags_command] = STATE(160),
    [sym_iter_function_command] = STATE(160),
    [sym_iter_iomap_command] = STATE(160),
    [sym_iter_dbgmap_command] = STATE(160),
    [sym_iter_register_command] = STATE(160),
    [sym_iter_step_command] = STATE(160),
    [sym_tmp_seek_command] = STATE(160),
    [sym_tmp_blksz_command] = STATE(160),
    [sym_tmp_fromto_command] = STATE(160),
    [sym_tmp_arch_command] = STATE(160),
    [sym_tmp_bits_command] = STATE(160),
    [sym_tmp_nthi_command] = STATE(160),
    [sym_tmp_eval_command] = STATE(160),
    [sym_tmp_fs_command] = STATE(160),
    [sym_tmp_reli_command] = STATE(160),
    [sym_tmp_kuery_command] = STATE(160),
    [sym_tmp_fd_command] = STATE(160),
    [sym_tmp_reg_command] = STATE(160),
    [sym_tmp_file_command] = STATE(160),
    [sym_tmp_string_command] = STATE(160),
    [sym_tmp_value_command] = STATE(160),
    [sym_tmp_hex_command] = STATE(160),
    [sym_number_command] = STATE(160),
    [sym_help_command] = STATE(160),
    [sym_arged_command] = STATE(160),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(160),
    [sym_Cf_cmd] = STATE(160),
    [sym_pf_new_cmd] = STATE(160),
    [sym_pf_dot_cmd] = STATE(160),
    [sym_pf_cmd] = STATE(160),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(160),
    [sym_redirect_command] = STATE(422),
    [sym__dec_number] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(95),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(95),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(95),
    [anon_sym_CR] = ACTIONS(95),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [8] = {
    [sym__commands_singleline] = STATE(487),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [9] = {
    [sym__commands_singleline] = STATE(465),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [10] = {
    [sym__commands_singleline] = STATE(479),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [11] = {
    [sym__commands_singleline] = STATE(470),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [12] = {
    [sym__commands_singleline] = STATE(476),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [13] = {
    [sym__commands_singleline] = STATE(469),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [14] = {
    [sym__commands_singleline] = STATE(466),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [15] = {
    [sym__commands_singleline] = STATE(468),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [16] = {
    [sym__commands_singleline] = STATE(462),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [17] = {
    [sym__commands_singleline] = STATE(459),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [18] = {
    [sym__commands_singleline] = STATE(474),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [19] = {
    [sym__commands_singleline] = STATE(467),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [20] = {
    [sym__commands_singleline] = STATE(488),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [21] = {
    [sym__commands_singleline] = STATE(484),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [22] = {
    [sym__commands_singleline] = STATE(496),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [23] = {
    [sym__commands_singleline] = STATE(482),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [24] = {
    [sym__commands_singleline] = STATE(478),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [25] = {
    [sym__commands_singleline] = STATE(485),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [26] = {
    [sym__commands_singleline] = STATE(502),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [27] = {
    [sym__commands_singleline] = STATE(500),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [28] = {
    [sym__commands_singleline] = STATE(464),
    [sym__command] = STATE(441),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(441),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(97),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [29] = {
    [sym__commands_singleline] = STATE(463),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [30] = {
    [sym__commands_singleline] = STATE(471),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [31] = {
    [sym__commands_singleline] = STATE(461),
    [sym__command] = STATE(426),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(426),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(35),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(99),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [32] = {
    [sym__command] = STATE(428),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(428),
    [sym__dec_number] = STATE(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [33] = {
    [sym__command] = STATE(424),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(424),
    [sym__dec_number] = STATE(2),
    [aux_sym__commands_singleline_repeat1] = STATE(274),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(103),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [34] = {
    [sym__command] = STATE(428),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(428),
    [sym__dec_number] = STATE(2),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [anon_sym_SEMI] = ACTIONS(101),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [35] = {
    [sym__command] = STATE(423),
    [sym_legacy_quoted_command] = STATE(265),
    [sym__simple_command] = STATE(265),
    [sym__tmp_command] = STATE(265),
    [sym__iter_command] = STATE(265),
    [sym__pipe_command] = STATE(265),
    [sym_grep_command] = STATE(265),
    [sym_html_disable_command] = STATE(265),
    [sym_html_enable_command] = STATE(265),
    [sym_pipe_command] = STATE(265),
    [sym_iter_file_lines_command] = STATE(265),
    [sym_iter_offsets_command] = STATE(265),
    [sym_iter_offsetssizes_command] = STATE(265),
    [sym_iter_hit_command] = STATE(265),
    [sym_iter_interpret_command] = STATE(265),
    [sym_iter_interpret_offsetssizes_command] = STATE(265),
    [sym_iter_comment_command] = STATE(265),
    [sym_iter_dbta_command] = STATE(265),
    [sym_iter_dbtb_command] = STATE(265),
    [sym_iter_dbts_command] = STATE(265),
    [sym_iter_threads_command] = STATE(265),
    [sym_iter_bbs_command] = STATE(265),
    [sym_iter_instrs_command] = STATE(265),
    [sym_iter_import_command] = STATE(265),
    [sym_iter_sections_command] = STATE(265),
    [sym_iter_segments_command] = STATE(265),
    [sym_iter_symbol_command] = STATE(265),
    [sym_iter_string_command] = STATE(265),
    [sym_iter_flags_command] = STATE(265),
    [sym_iter_function_command] = STATE(265),
    [sym_iter_iomap_command] = STATE(265),
    [sym_iter_dbgmap_command] = STATE(265),
    [sym_iter_register_command] = STATE(265),
    [sym_iter_step_command] = STATE(265),
    [sym_tmp_seek_command] = STATE(265),
    [sym_tmp_blksz_command] = STATE(265),
    [sym_tmp_fromto_command] = STATE(265),
    [sym_tmp_arch_command] = STATE(265),
    [sym_tmp_bits_command] = STATE(265),
    [sym_tmp_nthi_command] = STATE(265),
    [sym_tmp_eval_command] = STATE(265),
    [sym_tmp_fs_command] = STATE(265),
    [sym_tmp_reli_command] = STATE(265),
    [sym_tmp_kuery_command] = STATE(265),
    [sym_tmp_fd_command] = STATE(265),
    [sym_tmp_reg_command] = STATE(265),
    [sym_tmp_file_command] = STATE(265),
    [sym_tmp_string_command] = STATE(265),
    [sym_tmp_value_command] = STATE(265),
    [sym_tmp_hex_command] = STATE(265),
    [sym_number_command] = STATE(265),
    [sym_help_command] = STATE(265),
    [sym_arged_command] = STATE(265),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(265),
    [sym_Cf_cmd] = STATE(265),
    [sym_pf_new_cmd] = STATE(265),
    [sym_pf_dot_cmd] = STATE(265),
    [sym_pf_cmd] = STATE(265),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(265),
    [sym_redirect_command] = STATE(423),
    [sym__dec_number] = STATE(5),
    [aux_sym__commands_singleline_repeat1] = STATE(274),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(103),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [36] = {
    [sym__command] = STATE(449),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(449),
    [sym__dec_number] = STATE(2),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [37] = {
    [sym__command] = STATE(437),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(437),
    [sym__dec_number] = STATE(2),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [38] = {
    [sym__command] = STATE(432),
    [sym_legacy_quoted_command] = STATE(266),
    [sym__simple_command] = STATE(266),
    [sym__tmp_command] = STATE(266),
    [sym__iter_command] = STATE(266),
    [sym__pipe_command] = STATE(266),
    [sym_grep_command] = STATE(266),
    [sym_html_disable_command] = STATE(266),
    [sym_html_enable_command] = STATE(266),
    [sym_pipe_command] = STATE(266),
    [sym_iter_file_lines_command] = STATE(266),
    [sym_iter_offsets_command] = STATE(266),
    [sym_iter_offsetssizes_command] = STATE(266),
    [sym_iter_hit_command] = STATE(266),
    [sym_iter_interpret_command] = STATE(266),
    [sym_iter_interpret_offsetssizes_command] = STATE(266),
    [sym_iter_comment_command] = STATE(266),
    [sym_iter_dbta_command] = STATE(266),
    [sym_iter_dbtb_command] = STATE(266),
    [sym_iter_dbts_command] = STATE(266),
    [sym_iter_threads_command] = STATE(266),
    [sym_iter_bbs_command] = STATE(266),
    [sym_iter_instrs_command] = STATE(266),
    [sym_iter_import_command] = STATE(266),
    [sym_iter_sections_command] = STATE(266),
    [sym_iter_segments_command] = STATE(266),
    [sym_iter_symbol_command] = STATE(266),
    [sym_iter_string_command] = STATE(266),
    [sym_iter_flags_command] = STATE(266),
    [sym_iter_function_command] = STATE(266),
    [sym_iter_iomap_command] = STATE(266),
    [sym_iter_dbgmap_command] = STATE(266),
    [sym_iter_register_command] = STATE(266),
    [sym_iter_step_command] = STATE(266),
    [sym_tmp_seek_command] = STATE(266),
    [sym_tmp_blksz_command] = STATE(266),
    [sym_tmp_fromto_command] = STATE(266),
    [sym_tmp_arch_command] = STATE(266),
    [sym_tmp_bits_command] = STATE(266),
    [sym_tmp_nthi_command] = STATE(266),
    [sym_tmp_eval_command] = STATE(266),
    [sym_tmp_fs_command] = STATE(266),
    [sym_tmp_reli_command] = STATE(266),
    [sym_tmp_kuery_command] = STATE(266),
    [sym_tmp_fd_command] = STATE(266),
    [sym_tmp_reg_command] = STATE(266),
    [sym_tmp_file_command] = STATE(266),
    [sym_tmp_string_command] = STATE(266),
    [sym_tmp_value_command] = STATE(266),
    [sym_tmp_hex_command] = STATE(266),
    [sym_number_command] = STATE(266),
    [sym_help_command] = STATE(266),
    [sym_arged_command] = STATE(266),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(266),
    [sym_Cf_cmd] = STATE(266),
    [sym_pf_new_cmd] = STATE(266),
    [sym_pf_dot_cmd] = STATE(266),
    [sym_pf_cmd] = STATE(266),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(266),
    [sym_redirect_command] = STATE(432),
    [sym__dec_number] = STATE(2),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [39] = {
    [sym_legacy_quoted_command] = STATE(271),
    [sym__simple_command] = STATE(271),
    [sym__tmp_command] = STATE(271),
    [sym__iter_command] = STATE(271),
    [sym__pipe_command] = STATE(271),
    [sym_grep_command] = STATE(271),
    [sym_html_disable_command] = STATE(271),
    [sym_html_enable_command] = STATE(271),
    [sym_pipe_command] = STATE(271),
    [sym_iter_file_lines_command] = STATE(271),
    [sym_iter_offsets_command] = STATE(271),
    [sym_iter_offsetssizes_command] = STATE(271),
    [sym_iter_hit_command] = STATE(271),
    [sym_iter_interpret_command] = STATE(271),
    [sym_iter_interpret_offsetssizes_command] = STATE(271),
    [sym_iter_comment_command] = STATE(271),
    [sym_iter_dbta_command] = STATE(271),
    [sym_iter_dbtb_command] = STATE(271),
    [sym_iter_dbts_command] = STATE(271),
    [sym_iter_threads_command] = STATE(271),
    [sym_iter_bbs_command] = STATE(271),
    [sym_iter_instrs_command] = STATE(271),
    [sym_iter_import_command] = STATE(271),
    [sym_iter_sections_command] = STATE(271),
    [sym_iter_segments_command] = STATE(271),
    [sym_iter_symbol_command] = STATE(271),
    [sym_iter_string_command] = STATE(271),
    [sym_iter_flags_command] = STATE(271),
    [sym_iter_function_command] = STATE(271),
    [sym_iter_iomap_command] = STATE(271),
    [sym_iter_dbgmap_command] = STATE(271),
    [sym_iter_register_command] = STATE(271),
    [sym_iter_step_command] = STATE(271),
    [sym_tmp_seek_command] = STATE(271),
    [sym_tmp_blksz_command] = STATE(271),
    [sym_tmp_fromto_command] = STATE(271),
    [sym_tmp_arch_command] = STATE(271),
    [sym_tmp_bits_command] = STATE(271),
    [sym_tmp_nthi_command] = STATE(271),
    [sym_tmp_eval_command] = STATE(271),
    [sym_tmp_fs_command] = STATE(271),
    [sym_tmp_reli_command] = STATE(271),
    [sym_tmp_kuery_command] = STATE(271),
    [sym_tmp_fd_command] = STATE(271),
    [sym_tmp_reg_command] = STATE(271),
    [sym_tmp_file_command] = STATE(271),
    [sym_tmp_string_command] = STATE(271),
    [sym_tmp_value_command] = STATE(271),
    [sym_tmp_hex_command] = STATE(271),
    [sym_number_command] = STATE(271),
    [sym_help_command] = STATE(271),
    [sym_arged_command] = STATE(271),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(271),
    [sym_Cf_cmd] = STATE(271),
    [sym_pf_new_cmd] = STATE(271),
    [sym_pf_dot_cmd] = STATE(271),
    [sym_pf_cmd] = STATE(271),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(271),
    [sym__dec_number] = STATE(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [40] = {
    [sym_legacy_quoted_command] = STATE(272),
    [sym__simple_command] = STATE(272),
    [sym__tmp_command] = STATE(272),
    [sym__iter_command] = STATE(272),
    [sym__pipe_command] = STATE(272),
    [sym_grep_command] = STATE(272),
    [sym_html_disable_command] = STATE(272),
    [sym_html_enable_command] = STATE(272),
    [sym_pipe_command] = STATE(272),
    [sym_iter_file_lines_command] = STATE(272),
    [sym_iter_offsets_command] = STATE(272),
    [sym_iter_offsetssizes_command] = STATE(272),
    [sym_iter_hit_command] = STATE(272),
    [sym_iter_interpret_command] = STATE(272),
    [sym_iter_interpret_offsetssizes_command] = STATE(272),
    [sym_iter_comment_command] = STATE(272),
    [sym_iter_dbta_command] = STATE(272),
    [sym_iter_dbtb_command] = STATE(272),
    [sym_iter_dbts_command] = STATE(272),
    [sym_iter_threads_command] = STATE(272),
    [sym_iter_bbs_command] = STATE(272),
    [sym_iter_instrs_command] = STATE(272),
    [sym_iter_import_command] = STATE(272),
    [sym_iter_sections_command] = STATE(272),
    [sym_iter_segments_command] = STATE(272),
    [sym_iter_symbol_command] = STATE(272),
    [sym_iter_string_command] = STATE(272),
    [sym_iter_flags_command] = STATE(272),
    [sym_iter_function_command] = STATE(272),
    [sym_iter_iomap_command] = STATE(272),
    [sym_iter_dbgmap_command] = STATE(272),
    [sym_iter_register_command] = STATE(272),
    [sym_iter_step_command] = STATE(272),
    [sym_tmp_seek_command] = STATE(272),
    [sym_tmp_blksz_command] = STATE(272),
    [sym_tmp_fromto_command] = STATE(272),
    [sym_tmp_arch_command] = STATE(272),
    [sym_tmp_bits_command] = STATE(272),
    [sym_tmp_nthi_command] = STATE(272),
    [sym_tmp_eval_command] = STATE(272),
    [sym_tmp_fs_command] = STATE(272),
    [sym_tmp_reli_command] = STATE(272),
    [sym_tmp_kuery_command] = STATE(272),
    [sym_tmp_fd_command] = STATE(272),
    [sym_tmp_reg_command] = STATE(272),
    [sym_tmp_file_command] = STATE(272),
    [sym_tmp_string_command] = STATE(272),
    [sym_tmp_value_command] = STATE(272),
    [sym_tmp_hex_command] = STATE(272),
    [sym_number_command] = STATE(272),
    [sym_help_command] = STATE(272),
    [sym_arged_command] = STATE(272),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(281),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(272),
    [sym_Cf_cmd] = STATE(272),
    [sym_pf_new_cmd] = STATE(272),
    [sym_pf_dot_cmd] = STATE(272),
    [sym_pf_cmd] = STATE(272),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(91),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(272),
    [sym__dec_number] = STATE(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(65),
    [aux_sym__interpret_command_token1] = ACTIONS(67),
    [aux_sym__interpret_command_token3] = ACTIONS(69),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(71),
    [anon_sym_Cf] = ACTIONS(73),
    [sym_pf_dot_cmd_identifier] = ACTIONS(75),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(77),
    [aux_sym_pf_cmd_token1] = ACTIONS(79),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(81),
    [sym_question_mark_identifier] = ACTIONS(83),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(85),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(87),
    [sym__help_command] = ACTIONS(89),
  },
  [41] = {
    [sym_legacy_quoted_command] = STATE(263),
    [sym__simple_command] = STATE(263),
    [sym__tmp_command] = STATE(263),
    [sym__iter_command] = STATE(263),
    [sym__pipe_command] = STATE(263),
    [sym_grep_command] = STATE(263),
    [sym_html_disable_command] = STATE(263),
    [sym_html_enable_command] = STATE(263),
    [sym_pipe_command] = STATE(263),
    [sym_iter_file_lines_command] = STATE(263),
    [sym_iter_offsets_command] = STATE(263),
    [sym_iter_offsetssizes_command] = STATE(263),
    [sym_iter_hit_command] = STATE(263),
    [sym_iter_interpret_command] = STATE(263),
    [sym_iter_interpret_offsetssizes_command] = STATE(263),
    [sym_iter_comment_command] = STATE(263),
    [sym_iter_dbta_command] = STATE(263),
    [sym_iter_dbtb_command] = STATE(263),
    [sym_iter_dbts_command] = STATE(263),
    [sym_iter_threads_command] = STATE(263),
    [sym_iter_bbs_command] = STATE(263),
    [sym_iter_instrs_command] = STATE(263),
    [sym_iter_import_command] = STATE(263),
    [sym_iter_sections_command] = STATE(263),
    [sym_iter_segments_command] = STATE(263),
    [sym_iter_symbol_command] = STATE(263),
    [sym_iter_string_command] = STATE(263),
    [sym_iter_flags_command] = STATE(263),
    [sym_iter_function_command] = STATE(263),
    [sym_iter_iomap_command] = STATE(263),
    [sym_iter_dbgmap_command] = STATE(263),
    [sym_iter_register_command] = STATE(263),
    [sym_iter_step_command] = STATE(263),
    [sym_tmp_seek_command] = STATE(263),
    [sym_tmp_blksz_command] = STATE(263),
    [sym_tmp_fromto_command] = STATE(263),
    [sym_tmp_arch_command] = STATE(263),
    [sym_tmp_bits_command] = STATE(263),
    [sym_tmp_nthi_command] = STATE(263),
    [sym_tmp_eval_command] = STATE(263),
    [sym_tmp_fs_command] = STATE(263),
    [sym_tmp_reli_command] = STATE(263),
    [sym_tmp_kuery_command] = STATE(263),
    [sym_tmp_fd_command] = STATE(263),
    [sym_tmp_reg_command] = STATE(263),
    [sym_tmp_file_command] = STATE(263),
    [sym_tmp_string_command] = STATE(263),
    [sym_tmp_value_command] = STATE(263),
    [sym_tmp_hex_command] = STATE(263),
    [sym_number_command] = STATE(263),
    [sym_help_command] = STATE(263),
    [sym_arged_command] = STATE(263),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(263),
    [sym_Cf_cmd] = STATE(263),
    [sym_pf_new_cmd] = STATE(263),
    [sym_pf_dot_cmd] = STATE(263),
    [sym_pf_cmd] = STATE(263),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(263),
    [sym__dec_number] = STATE(2),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [42] = {
    [sym_legacy_quoted_command] = STATE(264),
    [sym__simple_command] = STATE(264),
    [sym__tmp_command] = STATE(264),
    [sym__iter_command] = STATE(264),
    [sym__pipe_command] = STATE(264),
    [sym_grep_command] = STATE(264),
    [sym_html_disable_command] = STATE(264),
    [sym_html_enable_command] = STATE(264),
    [sym_pipe_command] = STATE(264),
    [sym_iter_file_lines_command] = STATE(264),
    [sym_iter_offsets_command] = STATE(264),
    [sym_iter_offsetssizes_command] = STATE(264),
    [sym_iter_hit_command] = STATE(264),
    [sym_iter_interpret_command] = STATE(264),
    [sym_iter_interpret_offsetssizes_command] = STATE(264),
    [sym_iter_comment_command] = STATE(264),
    [sym_iter_dbta_command] = STATE(264),
    [sym_iter_dbtb_command] = STATE(264),
    [sym_iter_dbts_command] = STATE(264),
    [sym_iter_threads_command] = STATE(264),
    [sym_iter_bbs_command] = STATE(264),
    [sym_iter_instrs_command] = STATE(264),
    [sym_iter_import_command] = STATE(264),
    [sym_iter_sections_command] = STATE(264),
    [sym_iter_segments_command] = STATE(264),
    [sym_iter_symbol_command] = STATE(264),
    [sym_iter_string_command] = STATE(264),
    [sym_iter_flags_command] = STATE(264),
    [sym_iter_function_command] = STATE(264),
    [sym_iter_iomap_command] = STATE(264),
    [sym_iter_dbgmap_command] = STATE(264),
    [sym_iter_register_command] = STATE(264),
    [sym_iter_step_command] = STATE(264),
    [sym_tmp_seek_command] = STATE(264),
    [sym_tmp_blksz_command] = STATE(264),
    [sym_tmp_fromto_command] = STATE(264),
    [sym_tmp_arch_command] = STATE(264),
    [sym_tmp_bits_command] = STATE(264),
    [sym_tmp_nthi_command] = STATE(264),
    [sym_tmp_eval_command] = STATE(264),
    [sym_tmp_fs_command] = STATE(264),
    [sym_tmp_reli_command] = STATE(264),
    [sym_tmp_kuery_command] = STATE(264),
    [sym_tmp_fd_command] = STATE(264),
    [sym_tmp_reg_command] = STATE(264),
    [sym_tmp_file_command] = STATE(264),
    [sym_tmp_string_command] = STATE(264),
    [sym_tmp_value_command] = STATE(264),
    [sym_tmp_hex_command] = STATE(264),
    [sym_number_command] = STATE(264),
    [sym_help_command] = STATE(264),
    [sym_arged_command] = STATE(264),
    [sym__simple_arged_command_question] = STATE(184),
    [sym__simple_arged_command] = STATE(185),
    [sym__math_arged_command] = STATE(186),
    [sym__pointer_arged_command] = STATE(193),
    [sym__macro_arged_command] = STATE(197),
    [sym__system_command] = STATE(199),
    [sym__interpret_command] = STATE(210),
    [sym__interpret_search_identifier] = STATE(288),
    [sym__pf_arged_command] = STATE(212),
    [sym__pf_commands] = STATE(264),
    [sym_Cf_cmd] = STATE(264),
    [sym_pf_new_cmd] = STATE(264),
    [sym_pf_dot_cmd] = STATE(264),
    [sym_pf_cmd] = STATE(264),
    [sym__env_command] = STATE(213),
    [sym__env_command_identifier] = STATE(70),
    [sym__last_command] = STATE(214),
    [sym_last_command_identifier] = STATE(215),
    [sym_repeat_command] = STATE(264),
    [sym__dec_number] = STATE(2),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_0] = ACTIONS(9),
    [aux_sym_number_command_token1] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [aux_sym__interpret_command_token1] = ACTIONS(15),
    [aux_sym__interpret_command_token3] = ACTIONS(17),
    [anon_sym_DOT_BANG] = ACTIONS(19),
    [anon_sym_DOT_LPAREN] = ACTIONS(21),
    [anon_sym_DOT_SLASH] = ACTIONS(23),
    [anon_sym_pfo] = ACTIONS(25),
    [anon_sym_Cf] = ACTIONS(27),
    [sym_pf_dot_cmd_identifier] = ACTIONS(29),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(31),
    [aux_sym_pf_cmd_token1] = ACTIONS(33),
    [anon_sym_PERCENT] = ACTIONS(35),
    [anon_sym_env] = ACTIONS(35),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(37),
    [sym_system_identifier] = ACTIONS(39),
    [sym_question_mark_identifier] = ACTIONS(41),
    [sym_pointer_identifier] = ACTIONS(43),
    [sym_macro_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(49),
    [aux_sym__dec_number_token2] = ACTIONS(51),
    [sym__comment] = ACTIONS(3),
    [sym_cmd_identifier] = ACTIONS(53),
    [sym__help_command] = ACTIONS(55),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(105),
    [anon_sym_TILDE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(107),
    [anon_sym_PIPEH] = ACTIONS(105),
    [anon_sym_AT_AT_DOT] = ACTIONS(105),
    [anon_sym_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(105),
    [anon_sym_AT_AT] = ACTIONS(107),
    [anon_sym_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(105),
    [anon_sym_AT_ATC] = ACTIONS(105),
    [anon_sym_AT_ATdbt] = ACTIONS(107),
    [anon_sym_AT_ATdbta] = ACTIONS(105),
    [anon_sym_AT_ATdbtb] = ACTIONS(105),
    [anon_sym_AT_ATdbts] = ACTIONS(105),
    [anon_sym_AT_ATt] = ACTIONS(105),
    [anon_sym_AT_ATb] = ACTIONS(105),
    [anon_sym_AT_ATi] = ACTIONS(107),
    [anon_sym_AT_ATii] = ACTIONS(105),
    [anon_sym_AT_ATiS] = ACTIONS(107),
    [anon_sym_AT_ATiSS] = ACTIONS(105),
    [anon_sym_AT_ATis] = ACTIONS(105),
    [anon_sym_AT_ATiz] = ACTIONS(105),
    [anon_sym_AT_ATf] = ACTIONS(105),
    [anon_sym_AT_ATF] = ACTIONS(105),
    [anon_sym_AT_ATom] = ACTIONS(105),
    [anon_sym_AT_ATdm] = ACTIONS(105),
    [anon_sym_AT_ATr] = ACTIONS(105),
    [anon_sym_AT_ATs_COLON] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [anon_sym_AT_BANG] = ACTIONS(105),
    [anon_sym_AT_LPAREN] = ACTIONS(105),
    [anon_sym_RPAREN] = ACTIONS(105),
    [anon_sym_ATa_COLON] = ACTIONS(105),
    [anon_sym_ATb_COLON] = ACTIONS(105),
    [anon_sym_ATB_COLON] = ACTIONS(105),
    [anon_sym_ATe_COLON] = ACTIONS(105),
    [anon_sym_ATF_COLON] = ACTIONS(105),
    [anon_sym_ATi_COLON] = ACTIONS(105),
    [anon_sym_ATk_COLON] = ACTIONS(105),
    [anon_sym_ATo_COLON] = ACTIONS(105),
    [anon_sym_ATr_COLON] = ACTIONS(105),
    [anon_sym_ATf_COLON] = ACTIONS(105),
    [anon_sym_ATs_COLON] = ACTIONS(105),
    [anon_sym_ATv_COLON] = ACTIONS(105),
    [anon_sym_ATx_COLON] = ACTIONS(105),
    [anon_sym_0] = ACTIONS(107),
    [aux_sym_number_command_token1] = ACTIONS(105),
    [anon_sym_DOT] = ACTIONS(107),
    [aux_sym__interpret_command_token1] = ACTIONS(107),
    [aux_sym__interpret_command_token3] = ACTIONS(105),
    [anon_sym_DOT_BANG] = ACTIONS(105),
    [anon_sym_DOT_LPAREN] = ACTIONS(105),
    [anon_sym_PIPE_DOT] = ACTIONS(105),
    [anon_sym_DOT_SLASH] = ACTIONS(105),
    [anon_sym_pfo] = ACTIONS(105),
    [anon_sym_Cf] = ACTIONS(105),
    [sym_pf_dot_cmd_identifier] = ACTIONS(105),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(105),
    [aux_sym_pf_cmd_token1] = ACTIONS(107),
    [anon_sym_PERCENT] = ACTIONS(105),
    [anon_sym_env] = ACTIONS(105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(107),
    [sym_system_identifier] = ACTIONS(105),
    [sym_question_mark_identifier] = ACTIONS(105),
    [sym_pointer_identifier] = ACTIONS(105),
    [sym_macro_identifier] = ACTIONS(105),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_GT_GT] = ACTIONS(105),
    [sym_html_redirect_operator] = ACTIONS(107),
    [sym_html_append_operator] = ACTIONS(105),
    [anon_sym_BQUOTE] = ACTIONS(105),
    [aux_sym__dec_number_token1] = ACTIONS(105),
    [aux_sym__dec_number_token2] = ACTIONS(107),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(105),
    [anon_sym_CR] = ACTIONS(105),
    [sym_cmd_identifier] = ACTIONS(105),
    [sym__help_command] = ACTIONS(105),
    [sym_file_descriptor] = ACTIONS(105),
  },
  [44] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(216),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(109),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_PIPEH] = ACTIONS(109),
    [anon_sym_AT_AT_DOT] = ACTIONS(109),
    [anon_sym_AT_AT_EQ] = ACTIONS(109),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(109),
    [anon_sym_AT_AT] = ACTIONS(113),
    [anon_sym_AT_ATc_COLON] = ACTIONS(109),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(109),
    [anon_sym_AT_ATC] = ACTIONS(109),
    [anon_sym_AT_ATdbt] = ACTIONS(113),
    [anon_sym_AT_ATdbta] = ACTIONS(109),
    [anon_sym_AT_ATdbtb] = ACTIONS(109),
    [anon_sym_AT_ATdbts] = ACTIONS(109),
    [anon_sym_AT_ATt] = ACTIONS(109),
    [anon_sym_AT_ATb] = ACTIONS(109),
    [anon_sym_AT_ATi] = ACTIONS(113),
    [anon_sym_AT_ATii] = ACTIONS(109),
    [anon_sym_AT_ATiS] = ACTIONS(113),
    [anon_sym_AT_ATiSS] = ACTIONS(109),
    [anon_sym_AT_ATis] = ACTIONS(109),
    [anon_sym_AT_ATiz] = ACTIONS(109),
    [anon_sym_AT_ATf] = ACTIONS(109),
    [anon_sym_AT_ATF] = ACTIONS(109),
    [anon_sym_AT_ATom] = ACTIONS(109),
    [anon_sym_AT_ATdm] = ACTIONS(109),
    [anon_sym_AT_ATr] = ACTIONS(109),
    [anon_sym_AT_ATs_COLON] = ACTIONS(109),
    [anon_sym_AT] = ACTIONS(113),
    [anon_sym_AT_BANG] = ACTIONS(109),
    [anon_sym_AT_LPAREN] = ACTIONS(109),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_ATa_COLON] = ACTIONS(109),
    [anon_sym_ATb_COLON] = ACTIONS(109),
    [anon_sym_ATB_COLON] = ACTIONS(109),
    [anon_sym_ATe_COLON] = ACTIONS(109),
    [anon_sym_ATF_COLON] = ACTIONS(109),
    [anon_sym_ATi_COLON] = ACTIONS(109),
    [anon_sym_ATk_COLON] = ACTIONS(109),
    [anon_sym_ATo_COLON] = ACTIONS(109),
    [anon_sym_ATr_COLON] = ACTIONS(109),
    [anon_sym_ATf_COLON] = ACTIONS(109),
    [anon_sym_ATs_COLON] = ACTIONS(109),
    [anon_sym_ATv_COLON] = ACTIONS(109),
    [anon_sym_ATx_COLON] = ACTIONS(109),
    [anon_sym_PIPE_DOT] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(109),
    [sym_html_redirect_operator] = ACTIONS(113),
    [sym_html_append_operator] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(109),
    [anon_sym_CR] = ACTIONS(109),
    [sym_file_descriptor] = ACTIONS(109),
  },
  [45] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(217),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(129),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(127),
    [anon_sym_CR] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [46] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(183),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(131),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(133),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(131),
    [anon_sym_CR] = ACTIONS(131),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [47] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(182),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(137),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(137),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(137),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(137),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(137),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(137),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(135),
    [anon_sym_CR] = ACTIONS(135),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [48] = {
    [sym_macro_content] = STATE(134),
    [sym_macro_args] = STATE(256),
    [sym__arg_with_paren] = STATE(319),
    [sym__arg] = STATE(319),
    [sym_arg] = STATE(275),
    [sym_arg_identifier] = STATE(319),
    [sym_double_quoted_arg] = STATE(319),
    [sym_single_quoted_arg] = STATE(319),
    [sym_cmd_substitution_arg] = STATE(319),
    [sym_concatenation] = STATE(339),
    [ts_builtin_sym_end] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(143),
    [anon_sym_PIPEH] = ACTIONS(139),
    [anon_sym_AT_AT_DOT] = ACTIONS(139),
    [anon_sym_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT] = ACTIONS(143),
    [anon_sym_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_ATC] = ACTIONS(139),
    [anon_sym_AT_ATdbt] = ACTIONS(143),
    [anon_sym_AT_ATdbta] = ACTIONS(139),
    [anon_sym_AT_ATdbtb] = ACTIONS(139),
    [anon_sym_AT_ATdbts] = ACTIONS(139),
    [anon_sym_AT_ATt] = ACTIONS(139),
    [anon_sym_AT_ATb] = ACTIONS(139),
    [anon_sym_AT_ATi] = ACTIONS(143),
    [anon_sym_AT_ATii] = ACTIONS(139),
    [anon_sym_AT_ATiS] = ACTIONS(143),
    [anon_sym_AT_ATiSS] = ACTIONS(139),
    [anon_sym_AT_ATis] = ACTIONS(139),
    [anon_sym_AT_ATiz] = ACTIONS(139),
    [anon_sym_AT_ATf] = ACTIONS(139),
    [anon_sym_AT_ATF] = ACTIONS(139),
    [anon_sym_AT_ATom] = ACTIONS(139),
    [anon_sym_AT_ATdm] = ACTIONS(139),
    [anon_sym_AT_ATr] = ACTIONS(139),
    [anon_sym_AT_ATs_COLON] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_AT_BANG] = ACTIONS(139),
    [anon_sym_AT_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_ATa_COLON] = ACTIONS(139),
    [anon_sym_ATb_COLON] = ACTIONS(139),
    [anon_sym_ATB_COLON] = ACTIONS(139),
    [anon_sym_ATe_COLON] = ACTIONS(139),
    [anon_sym_ATF_COLON] = ACTIONS(139),
    [anon_sym_ATi_COLON] = ACTIONS(139),
    [anon_sym_ATk_COLON] = ACTIONS(139),
    [anon_sym_ATo_COLON] = ACTIONS(139),
    [anon_sym_ATr_COLON] = ACTIONS(139),
    [anon_sym_ATf_COLON] = ACTIONS(139),
    [anon_sym_ATs_COLON] = ACTIONS(139),
    [anon_sym_ATv_COLON] = ACTIONS(139),
    [anon_sym_ATx_COLON] = ACTIONS(139),
    [anon_sym_PIPE_DOT] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(145),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_GT_GT] = ACTIONS(139),
    [sym_html_redirect_operator] = ACTIONS(143),
    [sym_html_append_operator] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(149),
    [aux_sym_arg_identifier_token1] = ACTIONS(145),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(139),
    [anon_sym_CR] = ACTIONS(139),
    [sym_file_descriptor] = ACTIONS(139),
  },
  [49] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(255),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PIPEH] = ACTIONS(157),
    [anon_sym_AT_AT_DOT] = ACTIONS(157),
    [anon_sym_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT] = ACTIONS(159),
    [anon_sym_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_ATC] = ACTIONS(157),
    [anon_sym_AT_ATdbt] = ACTIONS(159),
    [anon_sym_AT_ATdbta] = ACTIONS(157),
    [anon_sym_AT_ATdbtb] = ACTIONS(157),
    [anon_sym_AT_ATdbts] = ACTIONS(157),
    [anon_sym_AT_ATt] = ACTIONS(157),
    [anon_sym_AT_ATb] = ACTIONS(157),
    [anon_sym_AT_ATi] = ACTIONS(159),
    [anon_sym_AT_ATii] = ACTIONS(157),
    [anon_sym_AT_ATiS] = ACTIONS(159),
    [anon_sym_AT_ATiSS] = ACTIONS(157),
    [anon_sym_AT_ATis] = ACTIONS(157),
    [anon_sym_AT_ATiz] = ACTIONS(157),
    [anon_sym_AT_ATf] = ACTIONS(157),
    [anon_sym_AT_ATF] = ACTIONS(157),
    [anon_sym_AT_ATom] = ACTIONS(157),
    [anon_sym_AT_ATdm] = ACTIONS(157),
    [anon_sym_AT_ATr] = ACTIONS(157),
    [anon_sym_AT_ATs_COLON] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(159),
    [anon_sym_AT_BANG] = ACTIONS(157),
    [anon_sym_AT_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_ATa_COLON] = ACTIONS(157),
    [anon_sym_ATb_COLON] = ACTIONS(157),
    [anon_sym_ATB_COLON] = ACTIONS(157),
    [anon_sym_ATe_COLON] = ACTIONS(157),
    [anon_sym_ATF_COLON] = ACTIONS(157),
    [anon_sym_ATi_COLON] = ACTIONS(157),
    [anon_sym_ATk_COLON] = ACTIONS(157),
    [anon_sym_ATo_COLON] = ACTIONS(157),
    [anon_sym_ATr_COLON] = ACTIONS(157),
    [anon_sym_ATf_COLON] = ACTIONS(157),
    [anon_sym_ATs_COLON] = ACTIONS(157),
    [anon_sym_ATv_COLON] = ACTIONS(157),
    [anon_sym_ATx_COLON] = ACTIONS(157),
    [anon_sym_PIPE_DOT] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(159),
    [anon_sym_GT_GT] = ACTIONS(157),
    [sym_html_redirect_operator] = ACTIONS(159),
    [sym_html_append_operator] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(157),
    [anon_sym_CR] = ACTIONS(157),
    [sym_file_descriptor] = ACTIONS(157),
  },
  [50] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(253),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(129),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(127),
    [anon_sym_CR] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [51] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(254),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(161),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(163),
    [anon_sym_PIPEH] = ACTIONS(161),
    [anon_sym_AT_AT_DOT] = ACTIONS(161),
    [anon_sym_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT] = ACTIONS(163),
    [anon_sym_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_ATC] = ACTIONS(161),
    [anon_sym_AT_ATdbt] = ACTIONS(163),
    [anon_sym_AT_ATdbta] = ACTIONS(161),
    [anon_sym_AT_ATdbtb] = ACTIONS(161),
    [anon_sym_AT_ATdbts] = ACTIONS(161),
    [anon_sym_AT_ATt] = ACTIONS(161),
    [anon_sym_AT_ATb] = ACTIONS(161),
    [anon_sym_AT_ATi] = ACTIONS(163),
    [anon_sym_AT_ATii] = ACTIONS(161),
    [anon_sym_AT_ATiS] = ACTIONS(163),
    [anon_sym_AT_ATiSS] = ACTIONS(161),
    [anon_sym_AT_ATis] = ACTIONS(161),
    [anon_sym_AT_ATiz] = ACTIONS(161),
    [anon_sym_AT_ATf] = ACTIONS(161),
    [anon_sym_AT_ATF] = ACTIONS(161),
    [anon_sym_AT_ATom] = ACTIONS(161),
    [anon_sym_AT_ATdm] = ACTIONS(161),
    [anon_sym_AT_ATr] = ACTIONS(161),
    [anon_sym_AT_ATs_COLON] = ACTIONS(161),
    [anon_sym_AT] = ACTIONS(163),
    [anon_sym_AT_BANG] = ACTIONS(161),
    [anon_sym_AT_LPAREN] = ACTIONS(161),
    [anon_sym_RPAREN] = ACTIONS(161),
    [anon_sym_ATa_COLON] = ACTIONS(161),
    [anon_sym_ATb_COLON] = ACTIONS(161),
    [anon_sym_ATB_COLON] = ACTIONS(161),
    [anon_sym_ATe_COLON] = ACTIONS(161),
    [anon_sym_ATF_COLON] = ACTIONS(161),
    [anon_sym_ATi_COLON] = ACTIONS(161),
    [anon_sym_ATk_COLON] = ACTIONS(161),
    [anon_sym_ATo_COLON] = ACTIONS(161),
    [anon_sym_ATr_COLON] = ACTIONS(161),
    [anon_sym_ATf_COLON] = ACTIONS(161),
    [anon_sym_ATs_COLON] = ACTIONS(161),
    [anon_sym_ATv_COLON] = ACTIONS(161),
    [anon_sym_ATx_COLON] = ACTIONS(161),
    [anon_sym_PIPE_DOT] = ACTIONS(161),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(161),
    [sym_html_redirect_operator] = ACTIONS(163),
    [sym_html_append_operator] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(161),
    [anon_sym_CR] = ACTIONS(161),
    [sym_file_descriptor] = ACTIONS(161),
  },
  [52] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(237),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_PIPEH] = ACTIONS(165),
    [anon_sym_AT_AT_DOT] = ACTIONS(165),
    [anon_sym_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT] = ACTIONS(167),
    [anon_sym_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_ATC] = ACTIONS(165),
    [anon_sym_AT_ATdbt] = ACTIONS(167),
    [anon_sym_AT_ATdbta] = ACTIONS(165),
    [anon_sym_AT_ATdbtb] = ACTIONS(165),
    [anon_sym_AT_ATdbts] = ACTIONS(165),
    [anon_sym_AT_ATt] = ACTIONS(165),
    [anon_sym_AT_ATb] = ACTIONS(165),
    [anon_sym_AT_ATi] = ACTIONS(167),
    [anon_sym_AT_ATii] = ACTIONS(165),
    [anon_sym_AT_ATiS] = ACTIONS(167),
    [anon_sym_AT_ATiSS] = ACTIONS(165),
    [anon_sym_AT_ATis] = ACTIONS(165),
    [anon_sym_AT_ATiz] = ACTIONS(165),
    [anon_sym_AT_ATf] = ACTIONS(165),
    [anon_sym_AT_ATF] = ACTIONS(165),
    [anon_sym_AT_ATom] = ACTIONS(165),
    [anon_sym_AT_ATdm] = ACTIONS(165),
    [anon_sym_AT_ATr] = ACTIONS(165),
    [anon_sym_AT_ATs_COLON] = ACTIONS(165),
    [anon_sym_AT] = ACTIONS(167),
    [anon_sym_AT_BANG] = ACTIONS(165),
    [anon_sym_AT_LPAREN] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(165),
    [anon_sym_ATa_COLON] = ACTIONS(165),
    [anon_sym_ATb_COLON] = ACTIONS(165),
    [anon_sym_ATB_COLON] = ACTIONS(165),
    [anon_sym_ATe_COLON] = ACTIONS(165),
    [anon_sym_ATF_COLON] = ACTIONS(165),
    [anon_sym_ATi_COLON] = ACTIONS(165),
    [anon_sym_ATk_COLON] = ACTIONS(165),
    [anon_sym_ATo_COLON] = ACTIONS(165),
    [anon_sym_ATr_COLON] = ACTIONS(165),
    [anon_sym_ATf_COLON] = ACTIONS(165),
    [anon_sym_ATs_COLON] = ACTIONS(165),
    [anon_sym_ATv_COLON] = ACTIONS(165),
    [anon_sym_ATx_COLON] = ACTIONS(165),
    [anon_sym_PIPE_DOT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym_html_redirect_operator] = ACTIONS(167),
    [sym_html_append_operator] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(165),
    [anon_sym_CR] = ACTIONS(165),
    [sym_file_descriptor] = ACTIONS(165),
  },
  [53] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(54),
    [sym_args] = STATE(219),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_PIPEH] = ACTIONS(169),
    [anon_sym_AT_AT_DOT] = ACTIONS(169),
    [anon_sym_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT] = ACTIONS(171),
    [anon_sym_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_ATC] = ACTIONS(169),
    [anon_sym_AT_ATdbt] = ACTIONS(171),
    [anon_sym_AT_ATdbta] = ACTIONS(169),
    [anon_sym_AT_ATdbtb] = ACTIONS(169),
    [anon_sym_AT_ATdbts] = ACTIONS(169),
    [anon_sym_AT_ATt] = ACTIONS(169),
    [anon_sym_AT_ATb] = ACTIONS(169),
    [anon_sym_AT_ATi] = ACTIONS(171),
    [anon_sym_AT_ATii] = ACTIONS(169),
    [anon_sym_AT_ATiS] = ACTIONS(171),
    [anon_sym_AT_ATiSS] = ACTIONS(169),
    [anon_sym_AT_ATis] = ACTIONS(169),
    [anon_sym_AT_ATiz] = ACTIONS(169),
    [anon_sym_AT_ATf] = ACTIONS(169),
    [anon_sym_AT_ATF] = ACTIONS(169),
    [anon_sym_AT_ATom] = ACTIONS(169),
    [anon_sym_AT_ATdm] = ACTIONS(169),
    [anon_sym_AT_ATr] = ACTIONS(169),
    [anon_sym_AT_ATs_COLON] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_AT_BANG] = ACTIONS(169),
    [anon_sym_AT_LPAREN] = ACTIONS(169),
    [anon_sym_RPAREN] = ACTIONS(169),
    [anon_sym_ATa_COLON] = ACTIONS(169),
    [anon_sym_ATb_COLON] = ACTIONS(169),
    [anon_sym_ATB_COLON] = ACTIONS(169),
    [anon_sym_ATe_COLON] = ACTIONS(169),
    [anon_sym_ATF_COLON] = ACTIONS(169),
    [anon_sym_ATi_COLON] = ACTIONS(169),
    [anon_sym_ATk_COLON] = ACTIONS(169),
    [anon_sym_ATo_COLON] = ACTIONS(169),
    [anon_sym_ATr_COLON] = ACTIONS(169),
    [anon_sym_ATf_COLON] = ACTIONS(169),
    [anon_sym_ATs_COLON] = ACTIONS(169),
    [anon_sym_ATv_COLON] = ACTIONS(169),
    [anon_sym_ATx_COLON] = ACTIONS(169),
    [anon_sym_PIPE_DOT] = ACTIONS(169),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_GT_GT] = ACTIONS(169),
    [sym_html_redirect_operator] = ACTIONS(171),
    [sym_html_append_operator] = ACTIONS(169),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(169),
    [anon_sym_CR] = ACTIONS(169),
    [sym_file_descriptor] = ACTIONS(169),
  },
  [54] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(55),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(55),
    [ts_builtin_sym_end] = ACTIONS(173),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_PIPE] = ACTIONS(175),
    [anon_sym_PIPEH] = ACTIONS(173),
    [anon_sym_AT_AT_DOT] = ACTIONS(173),
    [anon_sym_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT] = ACTIONS(175),
    [anon_sym_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_ATC] = ACTIONS(173),
    [anon_sym_AT_ATdbt] = ACTIONS(175),
    [anon_sym_AT_ATdbta] = ACTIONS(173),
    [anon_sym_AT_ATdbtb] = ACTIONS(173),
    [anon_sym_AT_ATdbts] = ACTIONS(173),
    [anon_sym_AT_ATt] = ACTIONS(173),
    [anon_sym_AT_ATb] = ACTIONS(173),
    [anon_sym_AT_ATi] = ACTIONS(175),
    [anon_sym_AT_ATii] = ACTIONS(173),
    [anon_sym_AT_ATiS] = ACTIONS(175),
    [anon_sym_AT_ATiSS] = ACTIONS(173),
    [anon_sym_AT_ATis] = ACTIONS(173),
    [anon_sym_AT_ATiz] = ACTIONS(173),
    [anon_sym_AT_ATf] = ACTIONS(173),
    [anon_sym_AT_ATF] = ACTIONS(173),
    [anon_sym_AT_ATom] = ACTIONS(173),
    [anon_sym_AT_ATdm] = ACTIONS(173),
    [anon_sym_AT_ATr] = ACTIONS(173),
    [anon_sym_AT_ATs_COLON] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(175),
    [anon_sym_AT_BANG] = ACTIONS(173),
    [anon_sym_AT_LPAREN] = ACTIONS(173),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_ATa_COLON] = ACTIONS(173),
    [anon_sym_ATb_COLON] = ACTIONS(173),
    [anon_sym_ATB_COLON] = ACTIONS(173),
    [anon_sym_ATe_COLON] = ACTIONS(173),
    [anon_sym_ATF_COLON] = ACTIONS(173),
    [anon_sym_ATi_COLON] = ACTIONS(173),
    [anon_sym_ATk_COLON] = ACTIONS(173),
    [anon_sym_ATo_COLON] = ACTIONS(173),
    [anon_sym_ATr_COLON] = ACTIONS(173),
    [anon_sym_ATf_COLON] = ACTIONS(173),
    [anon_sym_ATs_COLON] = ACTIONS(173),
    [anon_sym_ATv_COLON] = ACTIONS(173),
    [anon_sym_ATx_COLON] = ACTIONS(173),
    [anon_sym_PIPE_DOT] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(173),
    [sym_html_redirect_operator] = ACTIONS(175),
    [sym_html_append_operator] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(173),
    [anon_sym_CR] = ACTIONS(173),
    [sym_file_descriptor] = ACTIONS(173),
  },
  [55] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(55),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(55),
    [ts_builtin_sym_end] = ACTIONS(177),
    [anon_sym_DQUOTE] = ACTIONS(179),
    [anon_sym_TILDE] = ACTIONS(177),
    [anon_sym_PIPE] = ACTIONS(182),
    [anon_sym_PIPEH] = ACTIONS(177),
    [anon_sym_AT_AT_DOT] = ACTIONS(177),
    [anon_sym_AT_AT_EQ] = ACTIONS(177),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(177),
    [anon_sym_AT_AT] = ACTIONS(182),
    [anon_sym_AT_ATc_COLON] = ACTIONS(177),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(177),
    [anon_sym_AT_ATC] = ACTIONS(177),
    [anon_sym_AT_ATdbt] = ACTIONS(182),
    [anon_sym_AT_ATdbta] = ACTIONS(177),
    [anon_sym_AT_ATdbtb] = ACTIONS(177),
    [anon_sym_AT_ATdbts] = ACTIONS(177),
    [anon_sym_AT_ATt] = ACTIONS(177),
    [anon_sym_AT_ATb] = ACTIONS(177),
    [anon_sym_AT_ATi] = ACTIONS(182),
    [anon_sym_AT_ATii] = ACTIONS(177),
    [anon_sym_AT_ATiS] = ACTIONS(182),
    [anon_sym_AT_ATiSS] = ACTIONS(177),
    [anon_sym_AT_ATis] = ACTIONS(177),
    [anon_sym_AT_ATiz] = ACTIONS(177),
    [anon_sym_AT_ATf] = ACTIONS(177),
    [anon_sym_AT_ATF] = ACTIONS(177),
    [anon_sym_AT_ATom] = ACTIONS(177),
    [anon_sym_AT_ATdm] = ACTIONS(177),
    [anon_sym_AT_ATr] = ACTIONS(177),
    [anon_sym_AT_ATs_COLON] = ACTIONS(177),
    [anon_sym_AT] = ACTIONS(182),
    [anon_sym_AT_BANG] = ACTIONS(177),
    [anon_sym_AT_LPAREN] = ACTIONS(177),
    [anon_sym_RPAREN] = ACTIONS(177),
    [anon_sym_ATa_COLON] = ACTIONS(177),
    [anon_sym_ATb_COLON] = ACTIONS(177),
    [anon_sym_ATB_COLON] = ACTIONS(177),
    [anon_sym_ATe_COLON] = ACTIONS(177),
    [anon_sym_ATF_COLON] = ACTIONS(177),
    [anon_sym_ATi_COLON] = ACTIONS(177),
    [anon_sym_ATk_COLON] = ACTIONS(177),
    [anon_sym_ATo_COLON] = ACTIONS(177),
    [anon_sym_ATr_COLON] = ACTIONS(177),
    [anon_sym_ATf_COLON] = ACTIONS(177),
    [anon_sym_ATs_COLON] = ACTIONS(177),
    [anon_sym_ATv_COLON] = ACTIONS(177),
    [anon_sym_ATx_COLON] = ACTIONS(177),
    [anon_sym_PIPE_DOT] = ACTIONS(177),
    [anon_sym_DOLLAR] = ACTIONS(184),
    [anon_sym_LPAREN] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(177),
    [anon_sym_GT] = ACTIONS(182),
    [anon_sym_GT_GT] = ACTIONS(177),
    [sym_html_redirect_operator] = ACTIONS(182),
    [sym_html_append_operator] = ACTIONS(177),
    [anon_sym_COMMA] = ACTIONS(190),
    [aux_sym_arg_identifier_token1] = ACTIONS(184),
    [anon_sym_SQUOTE] = ACTIONS(193),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(196),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(177),
    [anon_sym_CR] = ACTIONS(177),
    [sym_file_descriptor] = ACTIONS(177),
  },
  [56] = {
    [sym__Cf_args] = STATE(223),
    [sym__arg_with_paren] = STATE(387),
    [sym__arg] = STATE(387),
    [sym_arg] = STATE(338),
    [sym_arg_identifier] = STATE(387),
    [sym_double_quoted_arg] = STATE(387),
    [sym_single_quoted_arg] = STATE(387),
    [sym_cmd_substitution_arg] = STATE(387),
    [sym_concatenation] = STATE(405),
    [ts_builtin_sym_end] = ACTIONS(202),
    [anon_sym_DQUOTE] = ACTIONS(204),
    [anon_sym_TILDE] = ACTIONS(202),
    [anon_sym_PIPE] = ACTIONS(206),
    [anon_sym_PIPEH] = ACTIONS(202),
    [anon_sym_AT_AT_DOT] = ACTIONS(202),
    [anon_sym_AT_AT_EQ] = ACTIONS(202),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(202),
    [anon_sym_AT_AT] = ACTIONS(206),
    [anon_sym_AT_ATc_COLON] = ACTIONS(202),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(202),
    [anon_sym_AT_ATC] = ACTIONS(202),
    [anon_sym_AT_ATdbt] = ACTIONS(206),
    [anon_sym_AT_ATdbta] = ACTIONS(202),
    [anon_sym_AT_ATdbtb] = ACTIONS(202),
    [anon_sym_AT_ATdbts] = ACTIONS(202),
    [anon_sym_AT_ATt] = ACTIONS(202),
    [anon_sym_AT_ATb] = ACTIONS(202),
    [anon_sym_AT_ATi] = ACTIONS(206),
    [anon_sym_AT_ATii] = ACTIONS(202),
    [anon_sym_AT_ATiS] = ACTIONS(206),
    [anon_sym_AT_ATiSS] = ACTIONS(202),
    [anon_sym_AT_ATis] = ACTIONS(202),
    [anon_sym_AT_ATiz] = ACTIONS(202),
    [anon_sym_AT_ATf] = ACTIONS(202),
    [anon_sym_AT_ATF] = ACTIONS(202),
    [anon_sym_AT_ATom] = ACTIONS(202),
    [anon_sym_AT_ATdm] = ACTIONS(202),
    [anon_sym_AT_ATr] = ACTIONS(202),
    [anon_sym_AT_ATs_COLON] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(206),
    [anon_sym_AT_BANG] = ACTIONS(202),
    [anon_sym_AT_LPAREN] = ACTIONS(202),
    [anon_sym_RPAREN] = ACTIONS(202),
    [anon_sym_ATa_COLON] = ACTIONS(202),
    [anon_sym_ATb_COLON] = ACTIONS(202),
    [anon_sym_ATB_COLON] = ACTIONS(202),
    [anon_sym_ATe_COLON] = ACTIONS(202),
    [anon_sym_ATF_COLON] = ACTIONS(202),
    [anon_sym_ATi_COLON] = ACTIONS(202),
    [anon_sym_ATk_COLON] = ACTIONS(202),
    [anon_sym_ATo_COLON] = ACTIONS(202),
    [anon_sym_ATr_COLON] = ACTIONS(202),
    [anon_sym_ATf_COLON] = ACTIONS(202),
    [anon_sym_ATs_COLON] = ACTIONS(202),
    [anon_sym_ATv_COLON] = ACTIONS(202),
    [anon_sym_ATx_COLON] = ACTIONS(202),
    [anon_sym_PIPE_DOT] = ACTIONS(202),
    [anon_sym_DOLLAR] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(202),
    [anon_sym_GT] = ACTIONS(206),
    [anon_sym_GT_GT] = ACTIONS(202),
    [sym_html_redirect_operator] = ACTIONS(206),
    [sym_html_append_operator] = ACTIONS(202),
    [anon_sym_COMMA] = ACTIONS(212),
    [aux_sym_arg_identifier_token1] = ACTIONS(208),
    [anon_sym_SQUOTE] = ACTIONS(214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(216),
    [anon_sym_BQUOTE] = ACTIONS(218),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(202),
    [anon_sym_CR] = ACTIONS(202),
    [sym_file_descriptor] = ACTIONS(202),
  },
  [57] = {
    [sym__pf_arg_parentheses] = STATE(99),
    [sym_pf_arg_identifier] = STATE(99),
    [sym__pf_arg] = STATE(99),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(72),
    [sym_pf_args] = STATE(226),
    [sym_cmd_substitution_arg] = STATE(99),
    [aux_sym_pf_args_repeat1] = STATE(72),
    [aux_sym_pf_dot_args_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(220),
    [anon_sym_TILDE] = ACTIONS(220),
    [anon_sym_PIPE] = ACTIONS(222),
    [anon_sym_PIPEH] = ACTIONS(220),
    [anon_sym_AT_AT_DOT] = ACTIONS(220),
    [anon_sym_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT] = ACTIONS(222),
    [anon_sym_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_ATC] = ACTIONS(220),
    [anon_sym_AT_ATdbt] = ACTIONS(222),
    [anon_sym_AT_ATdbta] = ACTIONS(220),
    [anon_sym_AT_ATdbtb] = ACTIONS(220),
    [anon_sym_AT_ATdbts] = ACTIONS(220),
    [anon_sym_AT_ATt] = ACTIONS(220),
    [anon_sym_AT_ATb] = ACTIONS(220),
    [anon_sym_AT_ATi] = ACTIONS(222),
    [anon_sym_AT_ATii] = ACTIONS(220),
    [anon_sym_AT_ATiS] = ACTIONS(222),
    [anon_sym_AT_ATiSS] = ACTIONS(220),
    [anon_sym_AT_ATis] = ACTIONS(220),
    [anon_sym_AT_ATiz] = ACTIONS(220),
    [anon_sym_AT_ATf] = ACTIONS(220),
    [anon_sym_AT_ATF] = ACTIONS(220),
    [anon_sym_AT_ATom] = ACTIONS(220),
    [anon_sym_AT_ATdm] = ACTIONS(220),
    [anon_sym_AT_ATr] = ACTIONS(220),
    [anon_sym_AT_ATs_COLON] = ACTIONS(220),
    [anon_sym_AT] = ACTIONS(222),
    [anon_sym_AT_BANG] = ACTIONS(220),
    [anon_sym_AT_LPAREN] = ACTIONS(220),
    [anon_sym_RPAREN] = ACTIONS(220),
    [anon_sym_ATa_COLON] = ACTIONS(220),
    [anon_sym_ATb_COLON] = ACTIONS(220),
    [anon_sym_ATB_COLON] = ACTIONS(220),
    [anon_sym_ATe_COLON] = ACTIONS(220),
    [anon_sym_ATF_COLON] = ACTIONS(220),
    [anon_sym_ATi_COLON] = ACTIONS(220),
    [anon_sym_ATk_COLON] = ACTIONS(220),
    [anon_sym_ATo_COLON] = ACTIONS(220),
    [anon_sym_ATr_COLON] = ACTIONS(220),
    [anon_sym_ATf_COLON] = ACTIONS(220),
    [anon_sym_ATs_COLON] = ACTIONS(220),
    [anon_sym_ATv_COLON] = ACTIONS(220),
    [anon_sym_ATx_COLON] = ACTIONS(220),
    [anon_sym_PIPE_DOT] = ACTIONS(220),
    [anon_sym_EQ] = ACTIONS(222),
    [anon_sym_DOLLAR] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(226),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(220),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [sym_html_redirect_operator] = ACTIONS(222),
    [sym_html_append_operator] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(228),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(220),
    [anon_sym_CR] = ACTIONS(220),
    [sym_file_descriptor] = ACTIONS(220),
    [sym__concat_pf_dot] = ACTIONS(232),
  },
  [58] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(254),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(163),
    [anon_sym_PIPEH] = ACTIONS(161),
    [anon_sym_AT_AT_DOT] = ACTIONS(161),
    [anon_sym_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(161),
    [anon_sym_AT_AT] = ACTIONS(163),
    [anon_sym_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(161),
    [anon_sym_AT_ATC] = ACTIONS(161),
    [anon_sym_AT_ATdbt] = ACTIONS(163),
    [anon_sym_AT_ATdbta] = ACTIONS(161),
    [anon_sym_AT_ATdbtb] = ACTIONS(161),
    [anon_sym_AT_ATdbts] = ACTIONS(161),
    [anon_sym_AT_ATt] = ACTIONS(161),
    [anon_sym_AT_ATb] = ACTIONS(161),
    [anon_sym_AT_ATi] = ACTIONS(163),
    [anon_sym_AT_ATii] = ACTIONS(161),
    [anon_sym_AT_ATiS] = ACTIONS(163),
    [anon_sym_AT_ATiSS] = ACTIONS(161),
    [anon_sym_AT_ATis] = ACTIONS(161),
    [anon_sym_AT_ATiz] = ACTIONS(161),
    [anon_sym_AT_ATf] = ACTIONS(161),
    [anon_sym_AT_ATF] = ACTIONS(161),
    [anon_sym_AT_ATom] = ACTIONS(161),
    [anon_sym_AT_ATdm] = ACTIONS(161),
    [anon_sym_AT_ATr] = ACTIONS(161),
    [anon_sym_AT_ATs_COLON] = ACTIONS(161),
    [anon_sym_AT] = ACTIONS(163),
    [anon_sym_AT_BANG] = ACTIONS(161),
    [anon_sym_AT_LPAREN] = ACTIONS(161),
    [anon_sym_ATa_COLON] = ACTIONS(161),
    [anon_sym_ATb_COLON] = ACTIONS(161),
    [anon_sym_ATB_COLON] = ACTIONS(161),
    [anon_sym_ATe_COLON] = ACTIONS(161),
    [anon_sym_ATF_COLON] = ACTIONS(161),
    [anon_sym_ATi_COLON] = ACTIONS(161),
    [anon_sym_ATk_COLON] = ACTIONS(161),
    [anon_sym_ATo_COLON] = ACTIONS(161),
    [anon_sym_ATr_COLON] = ACTIONS(161),
    [anon_sym_ATf_COLON] = ACTIONS(161),
    [anon_sym_ATs_COLON] = ACTIONS(161),
    [anon_sym_ATv_COLON] = ACTIONS(161),
    [anon_sym_ATx_COLON] = ACTIONS(161),
    [anon_sym_PIPE_DOT] = ACTIONS(161),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(161),
    [sym_html_redirect_operator] = ACTIONS(163),
    [sym_html_append_operator] = ACTIONS(161),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(161),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(161),
  },
  [59] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(219),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(169),
    [anon_sym_PIPE] = ACTIONS(171),
    [anon_sym_PIPEH] = ACTIONS(169),
    [anon_sym_AT_AT_DOT] = ACTIONS(169),
    [anon_sym_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(169),
    [anon_sym_AT_AT] = ACTIONS(171),
    [anon_sym_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(169),
    [anon_sym_AT_ATC] = ACTIONS(169),
    [anon_sym_AT_ATdbt] = ACTIONS(171),
    [anon_sym_AT_ATdbta] = ACTIONS(169),
    [anon_sym_AT_ATdbtb] = ACTIONS(169),
    [anon_sym_AT_ATdbts] = ACTIONS(169),
    [anon_sym_AT_ATt] = ACTIONS(169),
    [anon_sym_AT_ATb] = ACTIONS(169),
    [anon_sym_AT_ATi] = ACTIONS(171),
    [anon_sym_AT_ATii] = ACTIONS(169),
    [anon_sym_AT_ATiS] = ACTIONS(171),
    [anon_sym_AT_ATiSS] = ACTIONS(169),
    [anon_sym_AT_ATis] = ACTIONS(169),
    [anon_sym_AT_ATiz] = ACTIONS(169),
    [anon_sym_AT_ATf] = ACTIONS(169),
    [anon_sym_AT_ATF] = ACTIONS(169),
    [anon_sym_AT_ATom] = ACTIONS(169),
    [anon_sym_AT_ATdm] = ACTIONS(169),
    [anon_sym_AT_ATr] = ACTIONS(169),
    [anon_sym_AT_ATs_COLON] = ACTIONS(169),
    [anon_sym_AT] = ACTIONS(171),
    [anon_sym_AT_BANG] = ACTIONS(169),
    [anon_sym_AT_LPAREN] = ACTIONS(169),
    [anon_sym_ATa_COLON] = ACTIONS(169),
    [anon_sym_ATb_COLON] = ACTIONS(169),
    [anon_sym_ATB_COLON] = ACTIONS(169),
    [anon_sym_ATe_COLON] = ACTIONS(169),
    [anon_sym_ATF_COLON] = ACTIONS(169),
    [anon_sym_ATi_COLON] = ACTIONS(169),
    [anon_sym_ATk_COLON] = ACTIONS(169),
    [anon_sym_ATo_COLON] = ACTIONS(169),
    [anon_sym_ATr_COLON] = ACTIONS(169),
    [anon_sym_ATf_COLON] = ACTIONS(169),
    [anon_sym_ATs_COLON] = ACTIONS(169),
    [anon_sym_ATv_COLON] = ACTIONS(169),
    [anon_sym_ATx_COLON] = ACTIONS(169),
    [anon_sym_PIPE_DOT] = ACTIONS(169),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(171),
    [anon_sym_GT_GT] = ACTIONS(169),
    [sym_html_redirect_operator] = ACTIONS(171),
    [sym_html_append_operator] = ACTIONS(169),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(169),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(169),
  },
  [60] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(253),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(129),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [61] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(217),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(129),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [62] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(216),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_PIPEH] = ACTIONS(109),
    [anon_sym_AT_AT_DOT] = ACTIONS(109),
    [anon_sym_AT_AT_EQ] = ACTIONS(109),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(109),
    [anon_sym_AT_AT] = ACTIONS(113),
    [anon_sym_AT_ATc_COLON] = ACTIONS(109),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(109),
    [anon_sym_AT_ATC] = ACTIONS(109),
    [anon_sym_AT_ATdbt] = ACTIONS(113),
    [anon_sym_AT_ATdbta] = ACTIONS(109),
    [anon_sym_AT_ATdbtb] = ACTIONS(109),
    [anon_sym_AT_ATdbts] = ACTIONS(109),
    [anon_sym_AT_ATt] = ACTIONS(109),
    [anon_sym_AT_ATb] = ACTIONS(109),
    [anon_sym_AT_ATi] = ACTIONS(113),
    [anon_sym_AT_ATii] = ACTIONS(109),
    [anon_sym_AT_ATiS] = ACTIONS(113),
    [anon_sym_AT_ATiSS] = ACTIONS(109),
    [anon_sym_AT_ATis] = ACTIONS(109),
    [anon_sym_AT_ATiz] = ACTIONS(109),
    [anon_sym_AT_ATf] = ACTIONS(109),
    [anon_sym_AT_ATF] = ACTIONS(109),
    [anon_sym_AT_ATom] = ACTIONS(109),
    [anon_sym_AT_ATdm] = ACTIONS(109),
    [anon_sym_AT_ATr] = ACTIONS(109),
    [anon_sym_AT_ATs_COLON] = ACTIONS(109),
    [anon_sym_AT] = ACTIONS(113),
    [anon_sym_AT_BANG] = ACTIONS(109),
    [anon_sym_AT_LPAREN] = ACTIONS(109),
    [anon_sym_ATa_COLON] = ACTIONS(109),
    [anon_sym_ATb_COLON] = ACTIONS(109),
    [anon_sym_ATB_COLON] = ACTIONS(109),
    [anon_sym_ATe_COLON] = ACTIONS(109),
    [anon_sym_ATF_COLON] = ACTIONS(109),
    [anon_sym_ATi_COLON] = ACTIONS(109),
    [anon_sym_ATk_COLON] = ACTIONS(109),
    [anon_sym_ATo_COLON] = ACTIONS(109),
    [anon_sym_ATr_COLON] = ACTIONS(109),
    [anon_sym_ATf_COLON] = ACTIONS(109),
    [anon_sym_ATs_COLON] = ACTIONS(109),
    [anon_sym_ATv_COLON] = ACTIONS(109),
    [anon_sym_ATx_COLON] = ACTIONS(109),
    [anon_sym_PIPE_DOT] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(109),
    [sym_html_redirect_operator] = ACTIONS(113),
    [sym_html_append_operator] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(109),
  },
  [63] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(237),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_PIPEH] = ACTIONS(165),
    [anon_sym_AT_AT_DOT] = ACTIONS(165),
    [anon_sym_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(165),
    [anon_sym_AT_AT] = ACTIONS(167),
    [anon_sym_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(165),
    [anon_sym_AT_ATC] = ACTIONS(165),
    [anon_sym_AT_ATdbt] = ACTIONS(167),
    [anon_sym_AT_ATdbta] = ACTIONS(165),
    [anon_sym_AT_ATdbtb] = ACTIONS(165),
    [anon_sym_AT_ATdbts] = ACTIONS(165),
    [anon_sym_AT_ATt] = ACTIONS(165),
    [anon_sym_AT_ATb] = ACTIONS(165),
    [anon_sym_AT_ATi] = ACTIONS(167),
    [anon_sym_AT_ATii] = ACTIONS(165),
    [anon_sym_AT_ATiS] = ACTIONS(167),
    [anon_sym_AT_ATiSS] = ACTIONS(165),
    [anon_sym_AT_ATis] = ACTIONS(165),
    [anon_sym_AT_ATiz] = ACTIONS(165),
    [anon_sym_AT_ATf] = ACTIONS(165),
    [anon_sym_AT_ATF] = ACTIONS(165),
    [anon_sym_AT_ATom] = ACTIONS(165),
    [anon_sym_AT_ATdm] = ACTIONS(165),
    [anon_sym_AT_ATr] = ACTIONS(165),
    [anon_sym_AT_ATs_COLON] = ACTIONS(165),
    [anon_sym_AT] = ACTIONS(167),
    [anon_sym_AT_BANG] = ACTIONS(165),
    [anon_sym_AT_LPAREN] = ACTIONS(165),
    [anon_sym_ATa_COLON] = ACTIONS(165),
    [anon_sym_ATb_COLON] = ACTIONS(165),
    [anon_sym_ATB_COLON] = ACTIONS(165),
    [anon_sym_ATe_COLON] = ACTIONS(165),
    [anon_sym_ATF_COLON] = ACTIONS(165),
    [anon_sym_ATi_COLON] = ACTIONS(165),
    [anon_sym_ATk_COLON] = ACTIONS(165),
    [anon_sym_ATo_COLON] = ACTIONS(165),
    [anon_sym_ATr_COLON] = ACTIONS(165),
    [anon_sym_ATf_COLON] = ACTIONS(165),
    [anon_sym_ATs_COLON] = ACTIONS(165),
    [anon_sym_ATv_COLON] = ACTIONS(165),
    [anon_sym_ATx_COLON] = ACTIONS(165),
    [anon_sym_PIPE_DOT] = ACTIONS(165),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(165),
    [sym_html_redirect_operator] = ACTIONS(167),
    [sym_html_append_operator] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(165),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(165),
  },
  [64] = {
    [sym_macro_content] = STATE(134),
    [sym_macro_args] = STATE(256),
    [sym__arg_with_paren] = STATE(319),
    [sym__arg] = STATE(319),
    [sym_arg] = STATE(275),
    [sym_arg_identifier] = STATE(319),
    [sym_double_quoted_arg] = STATE(319),
    [sym_single_quoted_arg] = STATE(319),
    [sym_cmd_substitution_arg] = STATE(319),
    [sym_concatenation] = STATE(339),
    [anon_sym_DQUOTE] = ACTIONS(141),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(143),
    [anon_sym_PIPEH] = ACTIONS(139),
    [anon_sym_AT_AT_DOT] = ACTIONS(139),
    [anon_sym_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT] = ACTIONS(143),
    [anon_sym_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_ATC] = ACTIONS(139),
    [anon_sym_AT_ATdbt] = ACTIONS(143),
    [anon_sym_AT_ATdbta] = ACTIONS(139),
    [anon_sym_AT_ATdbtb] = ACTIONS(139),
    [anon_sym_AT_ATdbts] = ACTIONS(139),
    [anon_sym_AT_ATt] = ACTIONS(139),
    [anon_sym_AT_ATb] = ACTIONS(139),
    [anon_sym_AT_ATi] = ACTIONS(143),
    [anon_sym_AT_ATii] = ACTIONS(139),
    [anon_sym_AT_ATiS] = ACTIONS(143),
    [anon_sym_AT_ATiSS] = ACTIONS(139),
    [anon_sym_AT_ATis] = ACTIONS(139),
    [anon_sym_AT_ATiz] = ACTIONS(139),
    [anon_sym_AT_ATf] = ACTIONS(139),
    [anon_sym_AT_ATF] = ACTIONS(139),
    [anon_sym_AT_ATom] = ACTIONS(139),
    [anon_sym_AT_ATdm] = ACTIONS(139),
    [anon_sym_AT_ATr] = ACTIONS(139),
    [anon_sym_AT_ATs_COLON] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_AT_BANG] = ACTIONS(139),
    [anon_sym_AT_LPAREN] = ACTIONS(139),
    [anon_sym_ATa_COLON] = ACTIONS(139),
    [anon_sym_ATb_COLON] = ACTIONS(139),
    [anon_sym_ATB_COLON] = ACTIONS(139),
    [anon_sym_ATe_COLON] = ACTIONS(139),
    [anon_sym_ATF_COLON] = ACTIONS(139),
    [anon_sym_ATi_COLON] = ACTIONS(139),
    [anon_sym_ATk_COLON] = ACTIONS(139),
    [anon_sym_ATo_COLON] = ACTIONS(139),
    [anon_sym_ATr_COLON] = ACTIONS(139),
    [anon_sym_ATf_COLON] = ACTIONS(139),
    [anon_sym_ATs_COLON] = ACTIONS(139),
    [anon_sym_ATv_COLON] = ACTIONS(139),
    [anon_sym_ATx_COLON] = ACTIONS(139),
    [anon_sym_PIPE_DOT] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(145),
    [anon_sym_LPAREN] = ACTIONS(147),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_GT] = ACTIONS(143),
    [anon_sym_GT_GT] = ACTIONS(139),
    [sym_html_redirect_operator] = ACTIONS(143),
    [sym_html_append_operator] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(149),
    [aux_sym_arg_identifier_token1] = ACTIONS(145),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(139),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(139),
  },
  [65] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(183),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(133),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [66] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(182),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(137),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(137),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(137),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(137),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(137),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(137),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [67] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(69),
    [sym_args] = STATE(255),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(69),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(159),
    [anon_sym_PIPEH] = ACTIONS(157),
    [anon_sym_AT_AT_DOT] = ACTIONS(157),
    [anon_sym_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(157),
    [anon_sym_AT_AT] = ACTIONS(159),
    [anon_sym_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(157),
    [anon_sym_AT_ATC] = ACTIONS(157),
    [anon_sym_AT_ATdbt] = ACTIONS(159),
    [anon_sym_AT_ATdbta] = ACTIONS(157),
    [anon_sym_AT_ATdbtb] = ACTIONS(157),
    [anon_sym_AT_ATdbts] = ACTIONS(157),
    [anon_sym_AT_ATt] = ACTIONS(157),
    [anon_sym_AT_ATb] = ACTIONS(157),
    [anon_sym_AT_ATi] = ACTIONS(159),
    [anon_sym_AT_ATii] = ACTIONS(157),
    [anon_sym_AT_ATiS] = ACTIONS(159),
    [anon_sym_AT_ATiSS] = ACTIONS(157),
    [anon_sym_AT_ATis] = ACTIONS(157),
    [anon_sym_AT_ATiz] = ACTIONS(157),
    [anon_sym_AT_ATf] = ACTIONS(157),
    [anon_sym_AT_ATF] = ACTIONS(157),
    [anon_sym_AT_ATom] = ACTIONS(157),
    [anon_sym_AT_ATdm] = ACTIONS(157),
    [anon_sym_AT_ATr] = ACTIONS(157),
    [anon_sym_AT_ATs_COLON] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(159),
    [anon_sym_AT_BANG] = ACTIONS(157),
    [anon_sym_AT_LPAREN] = ACTIONS(157),
    [anon_sym_ATa_COLON] = ACTIONS(157),
    [anon_sym_ATb_COLON] = ACTIONS(157),
    [anon_sym_ATB_COLON] = ACTIONS(157),
    [anon_sym_ATe_COLON] = ACTIONS(157),
    [anon_sym_ATF_COLON] = ACTIONS(157),
    [anon_sym_ATi_COLON] = ACTIONS(157),
    [anon_sym_ATk_COLON] = ACTIONS(157),
    [anon_sym_ATo_COLON] = ACTIONS(157),
    [anon_sym_ATr_COLON] = ACTIONS(157),
    [anon_sym_ATf_COLON] = ACTIONS(157),
    [anon_sym_ATs_COLON] = ACTIONS(157),
    [anon_sym_ATv_COLON] = ACTIONS(157),
    [anon_sym_ATx_COLON] = ACTIONS(157),
    [anon_sym_PIPE_DOT] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(159),
    [anon_sym_GT_GT] = ACTIONS(157),
    [sym_html_redirect_operator] = ACTIONS(159),
    [sym_html_append_operator] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(157),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(157),
  },
  [68] = {
    [sym__Cf_args] = STATE(223),
    [sym__arg_with_paren] = STATE(387),
    [sym__arg] = STATE(387),
    [sym_arg] = STATE(341),
    [sym_arg_identifier] = STATE(387),
    [sym_double_quoted_arg] = STATE(387),
    [sym_single_quoted_arg] = STATE(387),
    [sym_cmd_substitution_arg] = STATE(387),
    [sym_concatenation] = STATE(405),
    [anon_sym_DQUOTE] = ACTIONS(204),
    [anon_sym_TILDE] = ACTIONS(202),
    [anon_sym_PIPE] = ACTIONS(206),
    [anon_sym_PIPEH] = ACTIONS(202),
    [anon_sym_AT_AT_DOT] = ACTIONS(202),
    [anon_sym_AT_AT_EQ] = ACTIONS(202),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(202),
    [anon_sym_AT_AT] = ACTIONS(206),
    [anon_sym_AT_ATc_COLON] = ACTIONS(202),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(202),
    [anon_sym_AT_ATC] = ACTIONS(202),
    [anon_sym_AT_ATdbt] = ACTIONS(206),
    [anon_sym_AT_ATdbta] = ACTIONS(202),
    [anon_sym_AT_ATdbtb] = ACTIONS(202),
    [anon_sym_AT_ATdbts] = ACTIONS(202),
    [anon_sym_AT_ATt] = ACTIONS(202),
    [anon_sym_AT_ATb] = ACTIONS(202),
    [anon_sym_AT_ATi] = ACTIONS(206),
    [anon_sym_AT_ATii] = ACTIONS(202),
    [anon_sym_AT_ATiS] = ACTIONS(206),
    [anon_sym_AT_ATiSS] = ACTIONS(202),
    [anon_sym_AT_ATis] = ACTIONS(202),
    [anon_sym_AT_ATiz] = ACTIONS(202),
    [anon_sym_AT_ATf] = ACTIONS(202),
    [anon_sym_AT_ATF] = ACTIONS(202),
    [anon_sym_AT_ATom] = ACTIONS(202),
    [anon_sym_AT_ATdm] = ACTIONS(202),
    [anon_sym_AT_ATr] = ACTIONS(202),
    [anon_sym_AT_ATs_COLON] = ACTIONS(202),
    [anon_sym_AT] = ACTIONS(206),
    [anon_sym_AT_BANG] = ACTIONS(202),
    [anon_sym_AT_LPAREN] = ACTIONS(202),
    [anon_sym_ATa_COLON] = ACTIONS(202),
    [anon_sym_ATb_COLON] = ACTIONS(202),
    [anon_sym_ATB_COLON] = ACTIONS(202),
    [anon_sym_ATe_COLON] = ACTIONS(202),
    [anon_sym_ATF_COLON] = ACTIONS(202),
    [anon_sym_ATi_COLON] = ACTIONS(202),
    [anon_sym_ATk_COLON] = ACTIONS(202),
    [anon_sym_ATo_COLON] = ACTIONS(202),
    [anon_sym_ATr_COLON] = ACTIONS(202),
    [anon_sym_ATf_COLON] = ACTIONS(202),
    [anon_sym_ATs_COLON] = ACTIONS(202),
    [anon_sym_ATv_COLON] = ACTIONS(202),
    [anon_sym_ATx_COLON] = ACTIONS(202),
    [anon_sym_PIPE_DOT] = ACTIONS(202),
    [anon_sym_DOLLAR] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(202),
    [anon_sym_GT] = ACTIONS(206),
    [anon_sym_GT_GT] = ACTIONS(202),
    [sym_html_redirect_operator] = ACTIONS(206),
    [sym_html_append_operator] = ACTIONS(202),
    [anon_sym_COMMA] = ACTIONS(212),
    [aux_sym_arg_identifier_token1] = ACTIONS(208),
    [anon_sym_SQUOTE] = ACTIONS(214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(216),
    [anon_sym_BQUOTE] = ACTIONS(202),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(202),
  },
  [69] = {
    [sym__arg_with_paren] = STATE(74),
    [sym__arg] = STATE(74),
    [sym_arg] = STATE(55),
    [sym_arg_identifier] = STATE(74),
    [sym_double_quoted_arg] = STATE(74),
    [sym_single_quoted_arg] = STATE(74),
    [sym_cmd_substitution_arg] = STATE(74),
    [sym_concatenation] = STATE(87),
    [aux_sym_args_repeat1] = STATE(55),
    [anon_sym_DQUOTE] = ACTIONS(111),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_PIPE] = ACTIONS(175),
    [anon_sym_PIPEH] = ACTIONS(173),
    [anon_sym_AT_AT_DOT] = ACTIONS(173),
    [anon_sym_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(173),
    [anon_sym_AT_AT] = ACTIONS(175),
    [anon_sym_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(173),
    [anon_sym_AT_ATC] = ACTIONS(173),
    [anon_sym_AT_ATdbt] = ACTIONS(175),
    [anon_sym_AT_ATdbta] = ACTIONS(173),
    [anon_sym_AT_ATdbtb] = ACTIONS(173),
    [anon_sym_AT_ATdbts] = ACTIONS(173),
    [anon_sym_AT_ATt] = ACTIONS(173),
    [anon_sym_AT_ATb] = ACTIONS(173),
    [anon_sym_AT_ATi] = ACTIONS(175),
    [anon_sym_AT_ATii] = ACTIONS(173),
    [anon_sym_AT_ATiS] = ACTIONS(175),
    [anon_sym_AT_ATiSS] = ACTIONS(173),
    [anon_sym_AT_ATis] = ACTIONS(173),
    [anon_sym_AT_ATiz] = ACTIONS(173),
    [anon_sym_AT_ATf] = ACTIONS(173),
    [anon_sym_AT_ATF] = ACTIONS(173),
    [anon_sym_AT_ATom] = ACTIONS(173),
    [anon_sym_AT_ATdm] = ACTIONS(173),
    [anon_sym_AT_ATr] = ACTIONS(173),
    [anon_sym_AT_ATs_COLON] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(175),
    [anon_sym_AT_BANG] = ACTIONS(173),
    [anon_sym_AT_LPAREN] = ACTIONS(173),
    [anon_sym_ATa_COLON] = ACTIONS(173),
    [anon_sym_ATb_COLON] = ACTIONS(173),
    [anon_sym_ATB_COLON] = ACTIONS(173),
    [anon_sym_ATe_COLON] = ACTIONS(173),
    [anon_sym_ATF_COLON] = ACTIONS(173),
    [anon_sym_ATi_COLON] = ACTIONS(173),
    [anon_sym_ATk_COLON] = ACTIONS(173),
    [anon_sym_ATo_COLON] = ACTIONS(173),
    [anon_sym_ATr_COLON] = ACTIONS(173),
    [anon_sym_ATf_COLON] = ACTIONS(173),
    [anon_sym_ATs_COLON] = ACTIONS(173),
    [anon_sym_ATv_COLON] = ACTIONS(173),
    [anon_sym_ATx_COLON] = ACTIONS(173),
    [anon_sym_PIPE_DOT] = ACTIONS(173),
    [anon_sym_DOLLAR] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(117),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_GT] = ACTIONS(175),
    [anon_sym_GT_GT] = ACTIONS(173),
    [sym_html_redirect_operator] = ACTIONS(175),
    [sym_html_append_operator] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(119),
    [aux_sym_arg_identifier_token1] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(173),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(173),
  },
  [70] = {
    [sym_eq_sep_args] = STATE(189),
    [sym__eq_sep_key_single] = STATE(113),
    [sym__eq_sep_key_concatenation] = STATE(158),
    [sym__eq_sep_key] = STATE(166),
    [sym_double_quoted_arg] = STATE(113),
    [sym_single_quoted_arg] = STATE(113),
    [sym_cmd_substitution_arg] = STATE(113),
    [ts_builtin_sym_end] = ACTIONS(234),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_TILDE] = ACTIONS(234),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_PIPEH] = ACTIONS(234),
    [anon_sym_AT_AT_DOT] = ACTIONS(234),
    [anon_sym_AT_AT_EQ] = ACTIONS(234),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(234),
    [anon_sym_AT_AT] = ACTIONS(238),
    [anon_sym_AT_ATc_COLON] = ACTIONS(234),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(234),
    [anon_sym_AT_ATC] = ACTIONS(234),
    [anon_sym_AT_ATdbt] = ACTIONS(238),
    [anon_sym_AT_ATdbta] = ACTIONS(234),
    [anon_sym_AT_ATdbtb] = ACTIONS(234),
    [anon_sym_AT_ATdbts] = ACTIONS(234),
    [anon_sym_AT_ATt] = ACTIONS(234),
    [anon_sym_AT_ATb] = ACTIONS(234),
    [anon_sym_AT_ATi] = ACTIONS(238),
    [anon_sym_AT_ATii] = ACTIONS(234),
    [anon_sym_AT_ATiS] = ACTIONS(238),
    [anon_sym_AT_ATiSS] = ACTIONS(234),
    [anon_sym_AT_ATis] = ACTIONS(234),
    [anon_sym_AT_ATiz] = ACTIONS(234),
    [anon_sym_AT_ATf] = ACTIONS(234),
    [anon_sym_AT_ATF] = ACTIONS(234),
    [anon_sym_AT_ATom] = ACTIONS(234),
    [anon_sym_AT_ATdm] = ACTIONS(234),
    [anon_sym_AT_ATr] = ACTIONS(234),
    [anon_sym_AT_ATs_COLON] = ACTIONS(234),
    [anon_sym_AT] = ACTIONS(238),
    [anon_sym_AT_BANG] = ACTIONS(234),
    [anon_sym_AT_LPAREN] = ACTIONS(234),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_ATa_COLON] = ACTIONS(234),
    [anon_sym_ATb_COLON] = ACTIONS(234),
    [anon_sym_ATB_COLON] = ACTIONS(234),
    [anon_sym_ATe_COLON] = ACTIONS(234),
    [anon_sym_ATF_COLON] = ACTIONS(234),
    [anon_sym_ATi_COLON] = ACTIONS(234),
    [anon_sym_ATk_COLON] = ACTIONS(234),
    [anon_sym_ATo_COLON] = ACTIONS(234),
    [anon_sym_ATr_COLON] = ACTIONS(234),
    [anon_sym_ATf_COLON] = ACTIONS(234),
    [anon_sym_ATs_COLON] = ACTIONS(234),
    [anon_sym_ATv_COLON] = ACTIONS(234),
    [anon_sym_ATx_COLON] = ACTIONS(234),
    [anon_sym_PIPE_DOT] = ACTIONS(234),
    [anon_sym_SEMI] = ACTIONS(234),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_GT_GT] = ACTIONS(234),
    [sym_html_redirect_operator] = ACTIONS(238),
    [sym_html_append_operator] = ACTIONS(234),
    [sym__eq_sep_key_identifier] = ACTIONS(240),
    [anon_sym_SQUOTE] = ACTIONS(242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(244),
    [anon_sym_BQUOTE] = ACTIONS(246),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(234),
    [anon_sym_CR] = ACTIONS(234),
    [sym_file_descriptor] = ACTIONS(234),
  },
  [71] = {
    [sym__pf_arg_parentheses] = STATE(99),
    [sym_pf_arg_identifier] = STATE(99),
    [sym__pf_arg] = STATE(99),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(89),
    [sym_pf_args] = STATE(226),
    [sym_cmd_substitution_arg] = STATE(99),
    [aux_sym_pf_args_repeat1] = STATE(89),
    [aux_sym_pf_dot_args_repeat1] = STATE(114),
    [anon_sym_TILDE] = ACTIONS(220),
    [anon_sym_PIPE] = ACTIONS(222),
    [anon_sym_PIPEH] = ACTIONS(220),
    [anon_sym_AT_AT_DOT] = ACTIONS(220),
    [anon_sym_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(220),
    [anon_sym_AT_AT] = ACTIONS(222),
    [anon_sym_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(220),
    [anon_sym_AT_ATC] = ACTIONS(220),
    [anon_sym_AT_ATdbt] = ACTIONS(222),
    [anon_sym_AT_ATdbta] = ACTIONS(220),
    [anon_sym_AT_ATdbtb] = ACTIONS(220),
    [anon_sym_AT_ATdbts] = ACTIONS(220),
    [anon_sym_AT_ATt] = ACTIONS(220),
    [anon_sym_AT_ATb] = ACTIONS(220),
    [anon_sym_AT_ATi] = ACTIONS(222),
    [anon_sym_AT_ATii] = ACTIONS(220),
    [anon_sym_AT_ATiS] = ACTIONS(222),
    [anon_sym_AT_ATiSS] = ACTIONS(220),
    [anon_sym_AT_ATis] = ACTIONS(220),
    [anon_sym_AT_ATiz] = ACTIONS(220),
    [anon_sym_AT_ATf] = ACTIONS(220),
    [anon_sym_AT_ATF] = ACTIONS(220),
    [anon_sym_AT_ATom] = ACTIONS(220),
    [anon_sym_AT_ATdm] = ACTIONS(220),
    [anon_sym_AT_ATr] = ACTIONS(220),
    [anon_sym_AT_ATs_COLON] = ACTIONS(220),
    [anon_sym_AT] = ACTIONS(222),
    [anon_sym_AT_BANG] = ACTIONS(220),
    [anon_sym_AT_LPAREN] = ACTIONS(220),
    [anon_sym_ATa_COLON] = ACTIONS(220),
    [anon_sym_ATb_COLON] = ACTIONS(220),
    [anon_sym_ATB_COLON] = ACTIONS(220),
    [anon_sym_ATe_COLON] = ACTIONS(220),
    [anon_sym_ATF_COLON] = ACTIONS(220),
    [anon_sym_ATi_COLON] = ACTIONS(220),
    [anon_sym_ATk_COLON] = ACTIONS(220),
    [anon_sym_ATo_COLON] = ACTIONS(220),
    [anon_sym_ATr_COLON] = ACTIONS(220),
    [anon_sym_ATf_COLON] = ACTIONS(220),
    [anon_sym_ATs_COLON] = ACTIONS(220),
    [anon_sym_ATv_COLON] = ACTIONS(220),
    [anon_sym_ATx_COLON] = ACTIONS(220),
    [anon_sym_PIPE_DOT] = ACTIONS(220),
    [anon_sym_EQ] = ACTIONS(222),
    [anon_sym_DOLLAR] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(226),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(220),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [sym_html_redirect_operator] = ACTIONS(222),
    [sym_html_append_operator] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(228),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(220),
    [sym__concat_pf_dot] = ACTIONS(232),
  },
  [72] = {
    [sym__pf_arg_parentheses] = STATE(99),
    [sym_pf_arg_identifier] = STATE(99),
    [sym__pf_arg] = STATE(99),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(99),
    [aux_sym_pf_args_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(248),
    [anon_sym_PIPE] = ACTIONS(250),
    [anon_sym_PIPEH] = ACTIONS(248),
    [anon_sym_AT_AT_DOT] = ACTIONS(248),
    [anon_sym_AT_AT_EQ] = ACTIONS(248),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(248),
    [anon_sym_AT_AT] = ACTIONS(250),
    [anon_sym_AT_ATc_COLON] = ACTIONS(248),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(248),
    [anon_sym_AT_ATC] = ACTIONS(248),
    [anon_sym_AT_ATdbt] = ACTIONS(250),
    [anon_sym_AT_ATdbta] = ACTIONS(248),
    [anon_sym_AT_ATdbtb] = ACTIONS(248),
    [anon_sym_AT_ATdbts] = ACTIONS(248),
    [anon_sym_AT_ATt] = ACTIONS(248),
    [anon_sym_AT_ATb] = ACTIONS(248),
    [anon_sym_AT_ATi] = ACTIONS(250),
    [anon_sym_AT_ATii] = ACTIONS(248),
    [anon_sym_AT_ATiS] = ACTIONS(250),
    [anon_sym_AT_ATiSS] = ACTIONS(248),
    [anon_sym_AT_ATis] = ACTIONS(248),
    [anon_sym_AT_ATiz] = ACTIONS(248),
    [anon_sym_AT_ATf] = ACTIONS(248),
    [anon_sym_AT_ATF] = ACTIONS(248),
    [anon_sym_AT_ATom] = ACTIONS(248),
    [anon_sym_AT_ATdm] = ACTIONS(248),
    [anon_sym_AT_ATr] = ACTIONS(248),
    [anon_sym_AT_ATs_COLON] = ACTIONS(248),
    [anon_sym_AT] = ACTIONS(250),
    [anon_sym_AT_BANG] = ACTIONS(248),
    [anon_sym_AT_LPAREN] = ACTIONS(248),
    [anon_sym_RPAREN] = ACTIONS(248),
    [anon_sym_ATa_COLON] = ACTIONS(248),
    [anon_sym_ATb_COLON] = ACTIONS(248),
    [anon_sym_ATB_COLON] = ACTIONS(248),
    [anon_sym_ATe_COLON] = ACTIONS(248),
    [anon_sym_ATF_COLON] = ACTIONS(248),
    [anon_sym_ATi_COLON] = ACTIONS(248),
    [anon_sym_ATk_COLON] = ACTIONS(248),
    [anon_sym_ATo_COLON] = ACTIONS(248),
    [anon_sym_ATr_COLON] = ACTIONS(248),
    [anon_sym_ATf_COLON] = ACTIONS(248),
    [anon_sym_ATs_COLON] = ACTIONS(248),
    [anon_sym_ATv_COLON] = ACTIONS(248),
    [anon_sym_ATx_COLON] = ACTIONS(248),
    [anon_sym_PIPE_DOT] = ACTIONS(248),
    [anon_sym_DOLLAR] = ACTIONS(224),
    [anon_sym_LPAREN] = ACTIONS(226),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(224),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_GT_GT] = ACTIONS(248),
    [sym_html_redirect_operator] = ACTIONS(250),
    [sym_html_append_operator] = ACTIONS(248),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(228),
    [anon_sym_BQUOTE] = ACTIONS(230),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(248),
    [anon_sym_CR] = ACTIONS(248),
    [sym_file_descriptor] = ACTIONS(248),
  },
  [73] = {
    [sym__pf_arg_parentheses] = STATE(99),
    [sym_pf_arg_identifier] = STATE(99),
    [sym__pf_arg] = STATE(99),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(99),
    [aux_sym_pf_args_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(252),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PIPEH] = ACTIONS(252),
    [anon_sym_AT_AT_DOT] = ACTIONS(252),
    [anon_sym_AT_AT_EQ] = ACTIONS(252),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(252),
    [anon_sym_AT_AT] = ACTIONS(254),
    [anon_sym_AT_ATc_COLON] = ACTIONS(252),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(252),
    [anon_sym_AT_ATC] = ACTIONS(252),
    [anon_sym_AT_ATdbt] = ACTIONS(254),
    [anon_sym_AT_ATdbta] = ACTIONS(252),
    [anon_sym_AT_ATdbtb] = ACTIONS(252),
    [anon_sym_AT_ATdbts] = ACTIONS(252),
    [anon_sym_AT_ATt] = ACTIONS(252),
    [anon_sym_AT_ATb] = ACTIONS(252),
    [anon_sym_AT_ATi] = ACTIONS(254),
    [anon_sym_AT_ATii] = ACTIONS(252),
    [anon_sym_AT_ATiS] = ACTIONS(254),
    [anon_sym_AT_ATiSS] = ACTIONS(252),
    [anon_sym_AT_ATis] = ACTIONS(252),
    [anon_sym_AT_ATiz] = ACTIONS(252),
    [anon_sym_AT_ATf] = ACTIONS(252),
    [anon_sym_AT_ATF] = ACTIONS(252),
    [anon_sym_AT_ATom] = ACTIONS(252),
    [anon_sym_AT_ATdm] = ACTIONS(252),
    [anon_sym_AT_ATr] = ACTIONS(252),
    [anon_sym_AT_ATs_COLON] = ACTIONS(252),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_BANG] = ACTIONS(252),
    [anon_sym_AT_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_ATa_COLON] = ACTIONS(252),
    [anon_sym_ATb_COLON] = ACTIONS(252),
    [anon_sym_ATB_COLON] = ACTIONS(252),
    [anon_sym_ATe_COLON] = ACTIONS(252),
    [anon_sym_ATF_COLON] = ACTIONS(252),
    [anon_sym_ATi_COLON] = ACTIONS(252),
    [anon_sym_ATk_COLON] = ACTIONS(252),
    [anon_sym_ATo_COLON] = ACTIONS(252),
    [anon_sym_ATr_COLON] = ACTIONS(252),
    [anon_sym_ATf_COLON] = ACTIONS(252),
    [anon_sym_ATs_COLON] = ACTIONS(252),
    [anon_sym_ATv_COLON] = ACTIONS(252),
    [anon_sym_ATx_COLON] = ACTIONS(252),
    [anon_sym_PIPE_DOT] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_LPAREN] = ACTIONS(259),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(256),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [sym_html_redirect_operator] = ACTIONS(254),
    [sym_html_append_operator] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(262),
    [anon_sym_BQUOTE] = ACTIONS(265),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(252),
    [anon_sym_CR] = ACTIONS(252),
    [sym_file_descriptor] = ACTIONS(252),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(268),
    [anon_sym_DQUOTE] = ACTIONS(268),
    [anon_sym_TILDE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(270),
    [anon_sym_PIPEH] = ACTIONS(268),
    [anon_sym_AT_AT_DOT] = ACTIONS(268),
    [anon_sym_AT_AT_EQ] = ACTIONS(268),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(268),
    [anon_sym_AT_AT] = ACTIONS(270),
    [anon_sym_AT_ATc_COLON] = ACTIONS(268),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(268),
    [anon_sym_AT_ATC] = ACTIONS(268),
    [anon_sym_AT_ATdbt] = ACTIONS(270),
    [anon_sym_AT_ATdbta] = ACTIONS(268),
    [anon_sym_AT_ATdbtb] = ACTIONS(268),
    [anon_sym_AT_ATdbts] = ACTIONS(268),
    [anon_sym_AT_ATt] = ACTIONS(268),
    [anon_sym_AT_ATb] = ACTIONS(268),
    [anon_sym_AT_ATi] = ACTIONS(270),
    [anon_sym_AT_ATii] = ACTIONS(268),
    [anon_sym_AT_ATiS] = ACTIONS(270),
    [anon_sym_AT_ATiSS] = ACTIONS(268),
    [anon_sym_AT_ATis] = ACTIONS(268),
    [anon_sym_AT_ATiz] = ACTIONS(268),
    [anon_sym_AT_ATf] = ACTIONS(268),
    [anon_sym_AT_ATF] = ACTIONS(268),
    [anon_sym_AT_ATom] = ACTIONS(268),
    [anon_sym_AT_ATdm] = ACTIONS(268),
    [anon_sym_AT_ATr] = ACTIONS(268),
    [anon_sym_AT_ATs_COLON] = ACTIONS(268),
    [anon_sym_AT] = ACTIONS(270),
    [anon_sym_AT_BANG] = ACTIONS(268),
    [anon_sym_AT_LPAREN] = ACTIONS(268),
    [anon_sym_RPAREN] = ACTIONS(268),
    [anon_sym_ATa_COLON] = ACTIONS(268),
    [anon_sym_ATb_COLON] = ACTIONS(268),
    [anon_sym_ATB_COLON] = ACTIONS(268),
    [anon_sym_ATe_COLON] = ACTIONS(268),
    [anon_sym_ATF_COLON] = ACTIONS(268),
    [anon_sym_ATi_COLON] = ACTIONS(268),
    [anon_sym_ATk_COLON] = ACTIONS(268),
    [anon_sym_ATo_COLON] = ACTIONS(268),
    [anon_sym_ATr_COLON] = ACTIONS(268),
    [anon_sym_ATf_COLON] = ACTIONS(268),
    [anon_sym_ATs_COLON] = ACTIONS(268),
    [anon_sym_ATv_COLON] = ACTIONS(268),
    [anon_sym_ATx_COLON] = ACTIONS(268),
    [anon_sym_PIPE_DOT] = ACTIONS(268),
    [anon_sym_DOLLAR] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(268),
    [anon_sym_SEMI] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(268),
    [sym_html_redirect_operator] = ACTIONS(270),
    [sym_html_append_operator] = ACTIONS(268),
    [anon_sym_COMMA] = ACTIONS(268),
    [aux_sym_arg_identifier_token1] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(268),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(268),
    [anon_sym_CR] = ACTIONS(268),
    [sym_file_descriptor] = ACTIONS(268),
    [sym__concat] = ACTIONS(272),
  },
  [75] = {
    [aux_sym_concatenation_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(274),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_PIPEH] = ACTIONS(274),
    [anon_sym_AT_AT_DOT] = ACTIONS(274),
    [anon_sym_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT] = ACTIONS(276),
    [anon_sym_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_ATC] = ACTIONS(274),
    [anon_sym_AT_ATdbt] = ACTIONS(276),
    [anon_sym_AT_ATdbta] = ACTIONS(274),
    [anon_sym_AT_ATdbtb] = ACTIONS(274),
    [anon_sym_AT_ATdbts] = ACTIONS(274),
    [anon_sym_AT_ATt] = ACTIONS(274),
    [anon_sym_AT_ATb] = ACTIONS(274),
    [anon_sym_AT_ATi] = ACTIONS(276),
    [anon_sym_AT_ATii] = ACTIONS(274),
    [anon_sym_AT_ATiS] = ACTIONS(276),
    [anon_sym_AT_ATiSS] = ACTIONS(274),
    [anon_sym_AT_ATis] = ACTIONS(274),
    [anon_sym_AT_ATiz] = ACTIONS(274),
    [anon_sym_AT_ATf] = ACTIONS(274),
    [anon_sym_AT_ATF] = ACTIONS(274),
    [anon_sym_AT_ATom] = ACTIONS(274),
    [anon_sym_AT_ATdm] = ACTIONS(274),
    [anon_sym_AT_ATr] = ACTIONS(274),
    [anon_sym_AT_ATs_COLON] = ACTIONS(274),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_AT_BANG] = ACTIONS(274),
    [anon_sym_AT_LPAREN] = ACTIONS(274),
    [anon_sym_RPAREN] = ACTIONS(274),
    [anon_sym_ATa_COLON] = ACTIONS(274),
    [anon_sym_ATb_COLON] = ACTIONS(274),
    [anon_sym_ATB_COLON] = ACTIONS(274),
    [anon_sym_ATe_COLON] = ACTIONS(274),
    [anon_sym_ATF_COLON] = ACTIONS(274),
    [anon_sym_ATi_COLON] = ACTIONS(274),
    [anon_sym_ATk_COLON] = ACTIONS(274),
    [anon_sym_ATo_COLON] = ACTIONS(274),
    [anon_sym_ATr_COLON] = ACTIONS(274),
    [anon_sym_ATf_COLON] = ACTIONS(274),
    [anon_sym_ATs_COLON] = ACTIONS(274),
    [anon_sym_ATv_COLON] = ACTIONS(274),
    [anon_sym_ATx_COLON] = ACTIONS(274),
    [anon_sym_PIPE_DOT] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_GT_GT] = ACTIONS(274),
    [sym_html_redirect_operator] = ACTIONS(276),
    [sym_html_append_operator] = ACTIONS(274),
    [anon_sym_COMMA] = ACTIONS(274),
    [aux_sym_arg_identifier_token1] = ACTIONS(276),
    [anon_sym_SQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(274),
    [anon_sym_BQUOTE] = ACTIONS(274),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(274),
    [anon_sym_CR] = ACTIONS(274),
    [sym_file_descriptor] = ACTIONS(274),
    [sym__concat] = ACTIONS(278),
  },
  [76] = {
    [aux_sym_concatenation_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(281),
    [anon_sym_TILDE] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(283),
    [anon_sym_PIPEH] = ACTIONS(281),
    [anon_sym_AT_AT_DOT] = ACTIONS(281),
    [anon_sym_AT_AT_EQ] = ACTIONS(281),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(281),
    [anon_sym_AT_AT] = ACTIONS(283),
    [anon_sym_AT_ATc_COLON] = ACTIONS(281),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(281),
    [anon_sym_AT_ATC] = ACTIONS(281),
    [anon_sym_AT_ATdbt] = ACTIONS(283),
    [anon_sym_AT_ATdbta] = ACTIONS(281),
    [anon_sym_AT_ATdbtb] = ACTIONS(281),
    [anon_sym_AT_ATdbts] = ACTIONS(281),
    [anon_sym_AT_ATt] = ACTIONS(281),
    [anon_sym_AT_ATb] = ACTIONS(281),
    [anon_sym_AT_ATi] = ACTIONS(283),
    [anon_sym_AT_ATii] = ACTIONS(281),
    [anon_sym_AT_ATiS] = ACTIONS(283),
    [anon_sym_AT_ATiSS] = ACTIONS(281),
    [anon_sym_AT_ATis] = ACTIONS(281),
    [anon_sym_AT_ATiz] = ACTIONS(281),
    [anon_sym_AT_ATf] = ACTIONS(281),
    [anon_sym_AT_ATF] = ACTIONS(281),
    [anon_sym_AT_ATom] = ACTIONS(281),
    [anon_sym_AT_ATdm] = ACTIONS(281),
    [anon_sym_AT_ATr] = ACTIONS(281),
    [anon_sym_AT_ATs_COLON] = ACTIONS(281),
    [anon_sym_AT] = ACTIONS(283),
    [anon_sym_AT_BANG] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(281),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_ATa_COLON] = ACTIONS(281),
    [anon_sym_ATb_COLON] = ACTIONS(281),
    [anon_sym_ATB_COLON] = ACTIONS(281),
    [anon_sym_ATe_COLON] = ACTIONS(281),
    [anon_sym_ATF_COLON] = ACTIONS(281),
    [anon_sym_ATi_COLON] = ACTIONS(281),
    [anon_sym_ATk_COLON] = ACTIONS(281),
    [anon_sym_ATo_COLON] = ACTIONS(281),
    [anon_sym_ATr_COLON] = ACTIONS(281),
    [anon_sym_ATf_COLON] = ACTIONS(281),
    [anon_sym_ATs_COLON] = ACTIONS(281),
    [anon_sym_ATv_COLON] = ACTIONS(281),
    [anon_sym_ATx_COLON] = ACTIONS(281),
    [anon_sym_PIPE_DOT] = ACTIONS(281),
    [anon_sym_DOLLAR] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym_GT] = ACTIONS(283),
    [anon_sym_GT_GT] = ACTIONS(281),
    [sym_html_redirect_operator] = ACTIONS(283),
    [sym_html_append_operator] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(281),
    [aux_sym_arg_identifier_token1] = ACTIONS(283),
    [anon_sym_SQUOTE] = ACTIONS(281),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(281),
    [anon_sym_BQUOTE] = ACTIONS(281),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(281),
    [anon_sym_CR] = ACTIONS(281),
    [sym_file_descriptor] = ACTIONS(281),
    [sym__concat] = ACTIONS(272),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(285),
    [anon_sym_TILDE] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_PIPEH] = ACTIONS(285),
    [anon_sym_AT_AT_DOT] = ACTIONS(285),
    [anon_sym_AT_AT_EQ] = ACTIONS(285),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(285),
    [anon_sym_AT_AT] = ACTIONS(287),
    [anon_sym_AT_ATc_COLON] = ACTIONS(285),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(285),
    [anon_sym_AT_ATC] = ACTIONS(285),
    [anon_sym_AT_ATdbt] = ACTIONS(287),
    [anon_sym_AT_ATdbta] = ACTIONS(285),
    [anon_sym_AT_ATdbtb] = ACTIONS(285),
    [anon_sym_AT_ATdbts] = ACTIONS(285),
    [anon_sym_AT_ATt] = ACTIONS(285),
    [anon_sym_AT_ATb] = ACTIONS(285),
    [anon_sym_AT_ATi] = ACTIONS(287),
    [anon_sym_AT_ATii] = ACTIONS(285),
    [anon_sym_AT_ATiS] = ACTIONS(287),
    [anon_sym_AT_ATiSS] = ACTIONS(285),
    [anon_sym_AT_ATis] = ACTIONS(285),
    [anon_sym_AT_ATiz] = ACTIONS(285),
    [anon_sym_AT_ATf] = ACTIONS(285),
    [anon_sym_AT_ATF] = ACTIONS(285),
    [anon_sym_AT_ATom] = ACTIONS(285),
    [anon_sym_AT_ATdm] = ACTIONS(285),
    [anon_sym_AT_ATr] = ACTIONS(285),
    [anon_sym_AT_ATs_COLON] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(287),
    [anon_sym_AT_BANG] = ACTIONS(285),
    [anon_sym_AT_LPAREN] = ACTIONS(285),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_ATa_COLON] = ACTIONS(285),
    [anon_sym_ATb_COLON] = ACTIONS(285),
    [anon_sym_ATB_COLON] = ACTIONS(285),
    [anon_sym_ATe_COLON] = ACTIONS(285),
    [anon_sym_ATF_COLON] = ACTIONS(285),
    [anon_sym_ATi_COLON] = ACTIONS(285),
    [anon_sym_ATk_COLON] = ACTIONS(285),
    [anon_sym_ATo_COLON] = ACTIONS(285),
    [anon_sym_ATr_COLON] = ACTIONS(285),
    [anon_sym_ATf_COLON] = ACTIONS(285),
    [anon_sym_ATs_COLON] = ACTIONS(285),
    [anon_sym_ATv_COLON] = ACTIONS(285),
    [anon_sym_ATx_COLON] = ACTIONS(285),
    [anon_sym_PIPE_DOT] = ACTIONS(285),
    [anon_sym_DOLLAR] = ACTIONS(287),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(285),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [sym_html_redirect_operator] = ACTIONS(287),
    [sym_html_append_operator] = ACTIONS(285),
    [anon_sym_COMMA] = ACTIONS(285),
    [aux_sym_arg_identifier_token1] = ACTIONS(287),
    [anon_sym_SQUOTE] = ACTIONS(285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(285),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_CR] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [sym__concat] = ACTIONS(285),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(289),
    [anon_sym_TILDE] = ACTIONS(289),
    [anon_sym_PIPE] = ACTIONS(291),
    [anon_sym_PIPEH] = ACTIONS(289),
    [anon_sym_AT_AT_DOT] = ACTIONS(289),
    [anon_sym_AT_AT_EQ] = ACTIONS(289),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(289),
    [anon_sym_AT_AT] = ACTIONS(291),
    [anon_sym_AT_ATc_COLON] = ACTIONS(289),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(289),
    [anon_sym_AT_ATC] = ACTIONS(289),
    [anon_sym_AT_ATdbt] = ACTIONS(291),
    [anon_sym_AT_ATdbta] = ACTIONS(289),
    [anon_sym_AT_ATdbtb] = ACTIONS(289),
    [anon_sym_AT_ATdbts] = ACTIONS(289),
    [anon_sym_AT_ATt] = ACTIONS(289),
    [anon_sym_AT_ATb] = ACTIONS(289),
    [anon_sym_AT_ATi] = ACTIONS(291),
    [anon_sym_AT_ATii] = ACTIONS(289),
    [anon_sym_AT_ATiS] = ACTIONS(291),
    [anon_sym_AT_ATiSS] = ACTIONS(289),
    [anon_sym_AT_ATis] = ACTIONS(289),
    [anon_sym_AT_ATiz] = ACTIONS(289),
    [anon_sym_AT_ATf] = ACTIONS(289),
    [anon_sym_AT_ATF] = ACTIONS(289),
    [anon_sym_AT_ATom] = ACTIONS(289),
    [anon_sym_AT_ATdm] = ACTIONS(289),
    [anon_sym_AT_ATr] = ACTIONS(289),
    [anon_sym_AT_ATs_COLON] = ACTIONS(289),
    [anon_sym_AT] = ACTIONS(291),
    [anon_sym_AT_BANG] = ACTIONS(289),
    [anon_sym_AT_LPAREN] = ACTIONS(289),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_ATa_COLON] = ACTIONS(289),
    [anon_sym_ATb_COLON] = ACTIONS(289),
    [anon_sym_ATB_COLON] = ACTIONS(289),
    [anon_sym_ATe_COLON] = ACTIONS(289),
    [anon_sym_ATF_COLON] = ACTIONS(289),
    [anon_sym_ATi_COLON] = ACTIONS(289),
    [anon_sym_ATk_COLON] = ACTIONS(289),
    [anon_sym_ATo_COLON] = ACTIONS(289),
    [anon_sym_ATr_COLON] = ACTIONS(289),
    [anon_sym_ATf_COLON] = ACTIONS(289),
    [anon_sym_ATs_COLON] = ACTIONS(289),
    [anon_sym_ATv_COLON] = ACTIONS(289),
    [anon_sym_ATx_COLON] = ACTIONS(289),
    [anon_sym_PIPE_DOT] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(289),
    [anon_sym_SEMI] = ACTIONS(289),
    [anon_sym_GT] = ACTIONS(291),
    [anon_sym_GT_GT] = ACTIONS(289),
    [sym_html_redirect_operator] = ACTIONS(291),
    [sym_html_append_operator] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(289),
    [aux_sym_arg_identifier_token1] = ACTIONS(291),
    [anon_sym_SQUOTE] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(289),
    [anon_sym_BQUOTE] = ACTIONS(289),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(289),
    [anon_sym_CR] = ACTIONS(289),
    [sym_file_descriptor] = ACTIONS(289),
    [sym__concat] = ACTIONS(289),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(293),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PIPE] = ACTIONS(295),
    [anon_sym_PIPEH] = ACTIONS(293),
    [anon_sym_AT_AT_DOT] = ACTIONS(293),
    [anon_sym_AT_AT_EQ] = ACTIONS(293),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(293),
    [anon_sym_AT_AT] = ACTIONS(295),
    [anon_sym_AT_ATc_COLON] = ACTIONS(293),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(293),
    [anon_sym_AT_ATC] = ACTIONS(293),
    [anon_sym_AT_ATdbt] = ACTIONS(295),
    [anon_sym_AT_ATdbta] = ACTIONS(293),
    [anon_sym_AT_ATdbtb] = ACTIONS(293),
    [anon_sym_AT_ATdbts] = ACTIONS(293),
    [anon_sym_AT_ATt] = ACTIONS(293),
    [anon_sym_AT_ATb] = ACTIONS(293),
    [anon_sym_AT_ATi] = ACTIONS(295),
    [anon_sym_AT_ATii] = ACTIONS(293),
    [anon_sym_AT_ATiS] = ACTIONS(295),
    [anon_sym_AT_ATiSS] = ACTIONS(293),
    [anon_sym_AT_ATis] = ACTIONS(293),
    [anon_sym_AT_ATiz] = ACTIONS(293),
    [anon_sym_AT_ATf] = ACTIONS(293),
    [anon_sym_AT_ATF] = ACTIONS(293),
    [anon_sym_AT_ATom] = ACTIONS(293),
    [anon_sym_AT_ATdm] = ACTIONS(293),
    [anon_sym_AT_ATr] = ACTIONS(293),
    [anon_sym_AT_ATs_COLON] = ACTIONS(293),
    [anon_sym_AT] = ACTIONS(295),
    [anon_sym_AT_BANG] = ACTIONS(293),
    [anon_sym_AT_LPAREN] = ACTIONS(293),
    [anon_sym_RPAREN] = ACTIONS(293),
    [anon_sym_ATa_COLON] = ACTIONS(293),
    [anon_sym_ATb_COLON] = ACTIONS(293),
    [anon_sym_ATB_COLON] = ACTIONS(293),
    [anon_sym_ATe_COLON] = ACTIONS(293),
    [anon_sym_ATF_COLON] = ACTIONS(293),
    [anon_sym_ATi_COLON] = ACTIONS(293),
    [anon_sym_ATk_COLON] = ACTIONS(293),
    [anon_sym_ATo_COLON] = ACTIONS(293),
    [anon_sym_ATr_COLON] = ACTIONS(293),
    [anon_sym_ATf_COLON] = ACTIONS(293),
    [anon_sym_ATs_COLON] = ACTIONS(293),
    [anon_sym_ATv_COLON] = ACTIONS(293),
    [anon_sym_ATx_COLON] = ACTIONS(293),
    [anon_sym_PIPE_DOT] = ACTIONS(293),
    [anon_sym_DOLLAR] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(293),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym_GT] = ACTIONS(295),
    [anon_sym_GT_GT] = ACTIONS(293),
    [sym_html_redirect_operator] = ACTIONS(295),
    [sym_html_append_operator] = ACTIONS(293),
    [anon_sym_COMMA] = ACTIONS(293),
    [aux_sym_arg_identifier_token1] = ACTIONS(295),
    [anon_sym_SQUOTE] = ACTIONS(293),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_BQUOTE] = ACTIONS(293),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(293),
    [anon_sym_CR] = ACTIONS(293),
    [sym_file_descriptor] = ACTIONS(293),
    [sym__concat] = ACTIONS(293),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(297),
    [anon_sym_TILDE] = ACTIONS(297),
    [anon_sym_PIPE] = ACTIONS(299),
    [anon_sym_PIPEH] = ACTIONS(297),
    [anon_sym_AT_AT_DOT] = ACTIONS(297),
    [anon_sym_AT_AT_EQ] = ACTIONS(297),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(297),
    [anon_sym_AT_AT] = ACTIONS(299),
    [anon_sym_AT_ATc_COLON] = ACTIONS(297),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(297),
    [anon_sym_AT_ATC] = ACTIONS(297),
    [anon_sym_AT_ATdbt] = ACTIONS(299),
    [anon_sym_AT_ATdbta] = ACTIONS(297),
    [anon_sym_AT_ATdbtb] = ACTIONS(297),
    [anon_sym_AT_ATdbts] = ACTIONS(297),
    [anon_sym_AT_ATt] = ACTIONS(297),
    [anon_sym_AT_ATb] = ACTIONS(297),
    [anon_sym_AT_ATi] = ACTIONS(299),
    [anon_sym_AT_ATii] = ACTIONS(297),
    [anon_sym_AT_ATiS] = ACTIONS(299),
    [anon_sym_AT_ATiSS] = ACTIONS(297),
    [anon_sym_AT_ATis] = ACTIONS(297),
    [anon_sym_AT_ATiz] = ACTIONS(297),
    [anon_sym_AT_ATf] = ACTIONS(297),
    [anon_sym_AT_ATF] = ACTIONS(297),
    [anon_sym_AT_ATom] = ACTIONS(297),
    [anon_sym_AT_ATdm] = ACTIONS(297),
    [anon_sym_AT_ATr] = ACTIONS(297),
    [anon_sym_AT_ATs_COLON] = ACTIONS(297),
    [anon_sym_AT] = ACTIONS(299),
    [anon_sym_AT_BANG] = ACTIONS(297),
    [anon_sym_AT_LPAREN] = ACTIONS(297),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_ATa_COLON] = ACTIONS(297),
    [anon_sym_ATb_COLON] = ACTIONS(297),
    [anon_sym_ATB_COLON] = ACTIONS(297),
    [anon_sym_ATe_COLON] = ACTIONS(297),
    [anon_sym_ATF_COLON] = ACTIONS(297),
    [anon_sym_ATi_COLON] = ACTIONS(297),
    [anon_sym_ATk_COLON] = ACTIONS(297),
    [anon_sym_ATo_COLON] = ACTIONS(297),
    [anon_sym_ATr_COLON] = ACTIONS(297),
    [anon_sym_ATf_COLON] = ACTIONS(297),
    [anon_sym_ATs_COLON] = ACTIONS(297),
    [anon_sym_ATv_COLON] = ACTIONS(297),
    [anon_sym_ATx_COLON] = ACTIONS(297),
    [anon_sym_PIPE_DOT] = ACTIONS(297),
    [anon_sym_DOLLAR] = ACTIONS(299),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_SEMI] = ACTIONS(297),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(297),
    [sym_html_redirect_operator] = ACTIONS(299),
    [sym_html_append_operator] = ACTIONS(297),
    [anon_sym_COMMA] = ACTIONS(297),
    [aux_sym_arg_identifier_token1] = ACTIONS(299),
    [anon_sym_SQUOTE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(297),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(297),
    [anon_sym_CR] = ACTIONS(297),
    [sym_file_descriptor] = ACTIONS(297),
    [sym__concat] = ACTIONS(297),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_PIPEH] = ACTIONS(301),
    [anon_sym_AT_AT_DOT] = ACTIONS(301),
    [anon_sym_AT_AT_EQ] = ACTIONS(301),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(301),
    [anon_sym_AT_AT] = ACTIONS(303),
    [anon_sym_AT_ATc_COLON] = ACTIONS(301),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(301),
    [anon_sym_AT_ATC] = ACTIONS(301),
    [anon_sym_AT_ATdbt] = ACTIONS(303),
    [anon_sym_AT_ATdbta] = ACTIONS(301),
    [anon_sym_AT_ATdbtb] = ACTIONS(301),
    [anon_sym_AT_ATdbts] = ACTIONS(301),
    [anon_sym_AT_ATt] = ACTIONS(301),
    [anon_sym_AT_ATb] = ACTIONS(301),
    [anon_sym_AT_ATi] = ACTIONS(303),
    [anon_sym_AT_ATii] = ACTIONS(301),
    [anon_sym_AT_ATiS] = ACTIONS(303),
    [anon_sym_AT_ATiSS] = ACTIONS(301),
    [anon_sym_AT_ATis] = ACTIONS(301),
    [anon_sym_AT_ATiz] = ACTIONS(301),
    [anon_sym_AT_ATf] = ACTIONS(301),
    [anon_sym_AT_ATF] = ACTIONS(301),
    [anon_sym_AT_ATom] = ACTIONS(301),
    [anon_sym_AT_ATdm] = ACTIONS(301),
    [anon_sym_AT_ATr] = ACTIONS(301),
    [anon_sym_AT_ATs_COLON] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_AT_BANG] = ACTIONS(301),
    [anon_sym_AT_LPAREN] = ACTIONS(301),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_ATa_COLON] = ACTIONS(301),
    [anon_sym_ATb_COLON] = ACTIONS(301),
    [anon_sym_ATB_COLON] = ACTIONS(301),
    [anon_sym_ATe_COLON] = ACTIONS(301),
    [anon_sym_ATF_COLON] = ACTIONS(301),
    [anon_sym_ATi_COLON] = ACTIONS(301),
    [anon_sym_ATk_COLON] = ACTIONS(301),
    [anon_sym_ATo_COLON] = ACTIONS(301),
    [anon_sym_ATr_COLON] = ACTIONS(301),
    [anon_sym_ATf_COLON] = ACTIONS(301),
    [anon_sym_ATs_COLON] = ACTIONS(301),
    [anon_sym_ATv_COLON] = ACTIONS(301),
    [anon_sym_ATx_COLON] = ACTIONS(301),
    [anon_sym_PIPE_DOT] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(301),
    [sym_html_redirect_operator] = ACTIONS(303),
    [sym_html_append_operator] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [aux_sym_arg_identifier_token1] = ACTIONS(303),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(301),
    [anon_sym_CR] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(301),
    [sym__concat] = ACTIONS(301),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(305),
    [anon_sym_DQUOTE] = ACTIONS(305),
    [anon_sym_TILDE] = ACTIONS(305),
    [anon_sym_PIPE] = ACTIONS(307),
    [anon_sym_PIPEH] = ACTIONS(305),
    [anon_sym_AT_AT_DOT] = ACTIONS(305),
    [anon_sym_AT_AT_EQ] = ACTIONS(305),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(305),
    [anon_sym_AT_AT] = ACTIONS(307),
    [anon_sym_AT_ATc_COLON] = ACTIONS(305),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(305),
    [anon_sym_AT_ATC] = ACTIONS(305),
    [anon_sym_AT_ATdbt] = ACTIONS(307),
    [anon_sym_AT_ATdbta] = ACTIONS(305),
    [anon_sym_AT_ATdbtb] = ACTIONS(305),
    [anon_sym_AT_ATdbts] = ACTIONS(305),
    [anon_sym_AT_ATt] = ACTIONS(305),
    [anon_sym_AT_ATb] = ACTIONS(305),
    [anon_sym_AT_ATi] = ACTIONS(307),
    [anon_sym_AT_ATii] = ACTIONS(305),
    [anon_sym_AT_ATiS] = ACTIONS(307),
    [anon_sym_AT_ATiSS] = ACTIONS(305),
    [anon_sym_AT_ATis] = ACTIONS(305),
    [anon_sym_AT_ATiz] = ACTIONS(305),
    [anon_sym_AT_ATf] = ACTIONS(305),
    [anon_sym_AT_ATF] = ACTIONS(305),
    [anon_sym_AT_ATom] = ACTIONS(305),
    [anon_sym_AT_ATdm] = ACTIONS(305),
    [anon_sym_AT_ATr] = ACTIONS(305),
    [anon_sym_AT_ATs_COLON] = ACTIONS(305),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_AT_BANG] = ACTIONS(305),
    [anon_sym_AT_LPAREN] = ACTIONS(305),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_ATa_COLON] = ACTIONS(305),
    [anon_sym_ATb_COLON] = ACTIONS(305),
    [anon_sym_ATB_COLON] = ACTIONS(305),
    [anon_sym_ATe_COLON] = ACTIONS(305),
    [anon_sym_ATF_COLON] = ACTIONS(305),
    [anon_sym_ATi_COLON] = ACTIONS(305),
    [anon_sym_ATk_COLON] = ACTIONS(305),
    [anon_sym_ATo_COLON] = ACTIONS(305),
    [anon_sym_ATr_COLON] = ACTIONS(305),
    [anon_sym_ATf_COLON] = ACTIONS(305),
    [anon_sym_ATs_COLON] = ACTIONS(305),
    [anon_sym_ATv_COLON] = ACTIONS(305),
    [anon_sym_ATx_COLON] = ACTIONS(305),
    [anon_sym_PIPE_DOT] = ACTIONS(305),
    [anon_sym_DOLLAR] = ACTIONS(307),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_SEMI] = ACTIONS(305),
    [anon_sym_GT] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(305),
    [sym_html_redirect_operator] = ACTIONS(307),
    [sym_html_append_operator] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(305),
    [aux_sym_arg_identifier_token1] = ACTIONS(307),
    [anon_sym_SQUOTE] = ACTIONS(305),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(305),
    [anon_sym_BQUOTE] = ACTIONS(305),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(305),
    [anon_sym_CR] = ACTIONS(305),
    [sym_file_descriptor] = ACTIONS(305),
    [sym__concat] = ACTIONS(305),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(301),
    [anon_sym_DQUOTE] = ACTIONS(301),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_PIPEH] = ACTIONS(301),
    [anon_sym_AT_AT_DOT] = ACTIONS(301),
    [anon_sym_AT_AT_EQ] = ACTIONS(301),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(301),
    [anon_sym_AT_AT] = ACTIONS(303),
    [anon_sym_AT_ATc_COLON] = ACTIONS(301),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(301),
    [anon_sym_AT_ATC] = ACTIONS(301),
    [anon_sym_AT_ATdbt] = ACTIONS(303),
    [anon_sym_AT_ATdbta] = ACTIONS(301),
    [anon_sym_AT_ATdbtb] = ACTIONS(301),
    [anon_sym_AT_ATdbts] = ACTIONS(301),
    [anon_sym_AT_ATt] = ACTIONS(301),
    [anon_sym_AT_ATb] = ACTIONS(301),
    [anon_sym_AT_ATi] = ACTIONS(303),
    [anon_sym_AT_ATii] = ACTIONS(301),
    [anon_sym_AT_ATiS] = ACTIONS(303),
    [anon_sym_AT_ATiSS] = ACTIONS(301),
    [anon_sym_AT_ATis] = ACTIONS(301),
    [anon_sym_AT_ATiz] = ACTIONS(301),
    [anon_sym_AT_ATf] = ACTIONS(301),
    [anon_sym_AT_ATF] = ACTIONS(301),
    [anon_sym_AT_ATom] = ACTIONS(301),
    [anon_sym_AT_ATdm] = ACTIONS(301),
    [anon_sym_AT_ATr] = ACTIONS(301),
    [anon_sym_AT_ATs_COLON] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_AT_BANG] = ACTIONS(301),
    [anon_sym_AT_LPAREN] = ACTIONS(301),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_ATa_COLON] = ACTIONS(301),
    [anon_sym_ATb_COLON] = ACTIONS(301),
    [anon_sym_ATB_COLON] = ACTIONS(301),
    [anon_sym_ATe_COLON] = ACTIONS(301),
    [anon_sym_ATF_COLON] = ACTIONS(301),
    [anon_sym_ATi_COLON] = ACTIONS(301),
    [anon_sym_ATk_COLON] = ACTIONS(301),
    [anon_sym_ATo_COLON] = ACTIONS(301),
    [anon_sym_ATr_COLON] = ACTIONS(301),
    [anon_sym_ATf_COLON] = ACTIONS(301),
    [anon_sym_ATs_COLON] = ACTIONS(301),
    [anon_sym_ATv_COLON] = ACTIONS(301),
    [anon_sym_ATx_COLON] = ACTIONS(301),
    [anon_sym_PIPE_DOT] = ACTIONS(301),
    [anon_sym_DOLLAR] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(301),
    [anon_sym_SEMI] = ACTIONS(301),
    [anon_sym_GT] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(301),
    [sym_html_redirect_operator] = ACTIONS(303),
    [sym_html_append_operator] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [aux_sym_arg_identifier_token1] = ACTIONS(303),
    [anon_sym_SQUOTE] = ACTIONS(301),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(301),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(301),
    [anon_sym_CR] = ACTIONS(301),
    [sym_file_descriptor] = ACTIONS(301),
    [sym__concat] = ACTIONS(301),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(274),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_PIPEH] = ACTIONS(274),
    [anon_sym_AT_AT_DOT] = ACTIONS(274),
    [anon_sym_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(274),
    [anon_sym_AT_AT] = ACTIONS(276),
    [anon_sym_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(274),
    [anon_sym_AT_ATC] = ACTIONS(274),
    [anon_sym_AT_ATdbt] = ACTIONS(276),
    [anon_sym_AT_ATdbta] = ACTIONS(274),
    [anon_sym_AT_ATdbtb] = ACTIONS(274),
    [anon_sym_AT_ATdbts] = ACTIONS(274),
    [anon_sym_AT_ATt] = ACTIONS(274),
    [anon_sym_AT_ATb] = ACTIONS(274),
    [anon_sym_AT_ATi] = ACTIONS(276),
    [anon_sym_AT_ATii] = ACTIONS(274),
    [anon_sym_AT_ATiS] = ACTIONS(276),
    [anon_sym_AT_ATiSS] = ACTIONS(274),
    [anon_sym_AT_ATis] = ACTIONS(274),
    [anon_sym_AT_ATiz] = ACTIONS(274),
    [anon_sym_AT_ATf] = ACTIONS(274),
    [anon_sym_AT_ATF] = ACTIONS(274),
    [anon_sym_AT_ATom] = ACTIONS(274),
    [anon_sym_AT_ATdm] = ACTIONS(274),
    [anon_sym_AT_ATr] = ACTIONS(274),
    [anon_sym_AT_ATs_COLON] = ACTIONS(274),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_AT_BANG] = ACTIONS(274),
    [anon_sym_AT_LPAREN] = ACTIONS(274),
    [anon_sym_RPAREN] = ACTIONS(274),
    [anon_sym_ATa_COLON] = ACTIONS(274),
    [anon_sym_ATb_COLON] = ACTIONS(274),
    [anon_sym_ATB_COLON] = ACTIONS(274),
    [anon_sym_ATe_COLON] = ACTIONS(274),
    [anon_sym_ATF_COLON] = ACTIONS(274),
    [anon_sym_ATi_COLON] = ACTIONS(274),
    [anon_sym_ATk_COLON] = ACTIONS(274),
    [anon_sym_ATo_COLON] = ACTIONS(274),
    [anon_sym_ATr_COLON] = ACTIONS(274),
    [anon_sym_ATf_COLON] = ACTIONS(274),
    [anon_sym_ATs_COLON] = ACTIONS(274),
    [anon_sym_ATv_COLON] = ACTIONS(274),
    [anon_sym_ATx_COLON] = ACTIONS(274),
    [anon_sym_PIPE_DOT] = ACTIONS(274),
    [anon_sym_DOLLAR] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(274),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_GT_GT] = ACTIONS(274),
    [sym_html_redirect_operator] = ACTIONS(276),
    [sym_html_append_operator] = ACTIONS(274),
    [anon_sym_COMMA] = ACTIONS(274),
    [aux_sym_arg_identifier_token1] = ACTIONS(276),
    [anon_sym_SQUOTE] = ACTIONS(274),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(274),
    [anon_sym_BQUOTE] = ACTIONS(274),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(274),
    [anon_sym_CR] = ACTIONS(274),
    [sym_file_descriptor] = ACTIONS(274),
    [sym__concat] = ACTIONS(274),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(309),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_PIPE] = ACTIONS(311),
    [anon_sym_PIPEH] = ACTIONS(309),
    [anon_sym_AT_AT_DOT] = ACTIONS(309),
    [anon_sym_AT_AT_EQ] = ACTIONS(309),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(309),
    [anon_sym_AT_AT] = ACTIONS(311),
    [anon_sym_AT_ATc_COLON] = ACTIONS(309),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(309),
    [anon_sym_AT_ATC] = ACTIONS(309),
    [anon_sym_AT_ATdbt] = ACTIONS(311),
    [anon_sym_AT_ATdbta] = ACTIONS(309),
    [anon_sym_AT_ATdbtb] = ACTIONS(309),
    [anon_sym_AT_ATdbts] = ACTIONS(309),
    [anon_sym_AT_ATt] = ACTIONS(309),
    [anon_sym_AT_ATb] = ACTIONS(309),
    [anon_sym_AT_ATi] = ACTIONS(311),
    [anon_sym_AT_ATii] = ACTIONS(309),
    [anon_sym_AT_ATiS] = ACTIONS(311),
    [anon_sym_AT_ATiSS] = ACTIONS(309),
    [anon_sym_AT_ATis] = ACTIONS(309),
    [anon_sym_AT_ATiz] = ACTIONS(309),
    [anon_sym_AT_ATf] = ACTIONS(309),
    [anon_sym_AT_ATF] = ACTIONS(309),
    [anon_sym_AT_ATom] = ACTIONS(309),
    [anon_sym_AT_ATdm] = ACTIONS(309),
    [anon_sym_AT_ATr] = ACTIONS(309),
    [anon_sym_AT_ATs_COLON] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(311),
    [anon_sym_AT_BANG] = ACTIONS(309),
    [anon_sym_AT_LPAREN] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(309),
    [anon_sym_ATa_COLON] = ACTIONS(309),
    [anon_sym_ATb_COLON] = ACTIONS(309),
    [anon_sym_ATB_COLON] = ACTIONS(309),
    [anon_sym_ATe_COLON] = ACTIONS(309),
    [anon_sym_ATF_COLON] = ACTIONS(309),
    [anon_sym_ATi_COLON] = ACTIONS(309),
    [anon_sym_ATk_COLON] = ACTIONS(309),
    [anon_sym_ATo_COLON] = ACTIONS(309),
    [anon_sym_ATr_COLON] = ACTIONS(309),
    [anon_sym_ATf_COLON] = ACTIONS(309),
    [anon_sym_ATs_COLON] = ACTIONS(309),
    [anon_sym_ATv_COLON] = ACTIONS(309),
    [anon_sym_ATx_COLON] = ACTIONS(309),
    [anon_sym_PIPE_DOT] = ACTIONS(309),
    [anon_sym_DOLLAR] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(309),
    [anon_sym_GT] = ACTIONS(311),
    [anon_sym_GT_GT] = ACTIONS(309),
    [sym_html_redirect_operator] = ACTIONS(311),
    [sym_html_append_operator] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(309),
    [aux_sym_arg_identifier_token1] = ACTIONS(311),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(309),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(309),
    [anon_sym_CR] = ACTIONS(309),
    [sym_file_descriptor] = ACTIONS(309),
    [sym__concat] = ACTIONS(309),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(313),
    [anon_sym_DQUOTE] = ACTIONS(313),
    [anon_sym_TILDE] = ACTIONS(313),
    [anon_sym_PIPE] = ACTIONS(315),
    [anon_sym_PIPEH] = ACTIONS(313),
    [anon_sym_AT_AT_DOT] = ACTIONS(313),
    [anon_sym_AT_AT_EQ] = ACTIONS(313),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(313),
    [anon_sym_AT_AT] = ACTIONS(315),
    [anon_sym_AT_ATc_COLON] = ACTIONS(313),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(313),
    [anon_sym_AT_ATC] = ACTIONS(313),
    [anon_sym_AT_ATdbt] = ACTIONS(315),
    [anon_sym_AT_ATdbta] = ACTIONS(313),
    [anon_sym_AT_ATdbtb] = ACTIONS(313),
    [anon_sym_AT_ATdbts] = ACTIONS(313),
    [anon_sym_AT_ATt] = ACTIONS(313),
    [anon_sym_AT_ATb] = ACTIONS(313),
    [anon_sym_AT_ATi] = ACTIONS(315),
    [anon_sym_AT_ATii] = ACTIONS(313),
    [anon_sym_AT_ATiS] = ACTIONS(315),
    [anon_sym_AT_ATiSS] = ACTIONS(313),
    [anon_sym_AT_ATis] = ACTIONS(313),
    [anon_sym_AT_ATiz] = ACTIONS(313),
    [anon_sym_AT_ATf] = ACTIONS(313),
    [anon_sym_AT_ATF] = ACTIONS(313),
    [anon_sym_AT_ATom] = ACTIONS(313),
    [anon_sym_AT_ATdm] = ACTIONS(313),
    [anon_sym_AT_ATr] = ACTIONS(313),
    [anon_sym_AT_ATs_COLON] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(315),
    [anon_sym_AT_BANG] = ACTIONS(313),
    [anon_sym_AT_LPAREN] = ACTIONS(313),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_ATa_COLON] = ACTIONS(313),
    [anon_sym_ATb_COLON] = ACTIONS(313),
    [anon_sym_ATB_COLON] = ACTIONS(313),
    [anon_sym_ATe_COLON] = ACTIONS(313),
    [anon_sym_ATF_COLON] = ACTIONS(313),
    [anon_sym_ATi_COLON] = ACTIONS(313),
    [anon_sym_ATk_COLON] = ACTIONS(313),
    [anon_sym_ATo_COLON] = ACTIONS(313),
    [anon_sym_ATr_COLON] = ACTIONS(313),
    [anon_sym_ATf_COLON] = ACTIONS(313),
    [anon_sym_ATs_COLON] = ACTIONS(313),
    [anon_sym_ATv_COLON] = ACTIONS(313),
    [anon_sym_ATx_COLON] = ACTIONS(313),
    [anon_sym_PIPE_DOT] = ACTIONS(313),
    [anon_sym_DOLLAR] = ACTIONS(315),
    [anon_sym_LPAREN] = ACTIONS(313),
    [anon_sym_SEMI] = ACTIONS(313),
    [anon_sym_GT] = ACTIONS(315),
    [anon_sym_GT_GT] = ACTIONS(313),
    [sym_html_redirect_operator] = ACTIONS(315),
    [sym_html_append_operator] = ACTIONS(313),
    [anon_sym_COMMA] = ACTIONS(313),
    [aux_sym_arg_identifier_token1] = ACTIONS(315),
    [anon_sym_SQUOTE] = ACTIONS(313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(313),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(313),
    [anon_sym_CR] = ACTIONS(313),
    [sym_file_descriptor] = ACTIONS(313),
    [sym__concat] = ACTIONS(313),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(268), 53,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [71] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(321), 1,
      sym__concat_pf_dot,
    STATE(88), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(319), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(317), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [146] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(109), 1,
      sym_pf_concatenation,
    ACTIONS(224), 2,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
    STATE(73), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
    ACTIONS(250), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(248), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [229] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(92), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(326), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(324), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [302] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(236), 1,
      anon_sym_DQUOTE,
    ACTIONS(240), 1,
      sym__eq_sep_key_identifier,
    ACTIONS(242), 1,
      anon_sym_SQUOTE,
    ACTIONS(244), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(158), 1,
      sym__eq_sep_key_concatenation,
    STATE(166), 1,
      sym__eq_sep_key,
    STATE(189), 1,
      sym_eq_sep_args,
    STATE(113), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
    ACTIONS(238), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(234), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [389] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(332), 1,
      sym__concat_pf_dot,
    STATE(88), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(330), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(328), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [464] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [534] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(319), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(317), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [604] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(324), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [674] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(338), 1,
      sym__concat,
    STATE(98), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(336), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(334), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [748] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [818] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 1,
      sym__concat,
    STATE(98), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(342), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(340), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [892] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(338), 1,
      sym__concat,
    STATE(96), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(349), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [966] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(353), 11,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(351), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1036] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1105] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(357), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(355), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1174] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1243] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(340), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1312] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(361), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(359), 51,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1381] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(365), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
      sym__eq_sep_key_identifier,
    ACTIONS(363), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1449] = 7,
    ACTIONS(371), 1,
      sym_grep_specifier_identifier,
    ACTIONS(374), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(377), 1,
      anon_sym_BQUOTE,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(367), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(107), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(369), 53,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1525] = 8,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(386), 1,
      sym_grep_specifier_identifier,
    ACTIONS(388), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(390), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(392), 1,
      anon_sym_BQUOTE,
    ACTIONS(382), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(107), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(384), 52,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1603] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1671] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(398), 1,
      sym__eq_sep_concat,
    STATE(110), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(396), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(394), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1742] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(405), 1,
      sym__eq_sep_concat,
    STATE(110), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(403), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(401), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1813] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(407), 1,
      sym__concat,
    STATE(112), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(276), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(274), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1884] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(405), 1,
      sym__eq_sep_concat,
    STATE(111), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(412), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(410), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1955] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(232), 1,
      sym__concat_pf_dot,
    STATE(117), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(416), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(414), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2026] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(422), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(115), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(420), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(418), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2097] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(425), 1,
      sym__concat,
    STATE(122), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(270), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(268), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2168] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(431), 1,
      sym__concat_pf_dot,
    STATE(117), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(429), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(427), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2239] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(232), 1,
      sym__concat_pf_dot,
    STATE(114), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(222), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(220), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2310] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(434), 1,
      sym__concat_pf_dot,
    STATE(119), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(319), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(317), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2381] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(268), 1,
      sym__eq_sep_concat,
    ACTIONS(441), 1,
      sym__concat,
    STATE(431), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(439), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(437), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2454] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(443), 1,
      sym__concat_pf_dot,
    STATE(119), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(330), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(328), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2525] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(425), 1,
      sym__concat,
    STATE(112), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(283), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(281), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2596] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(121), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(326), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(324), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2665] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(449), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(115), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(447), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(445), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2736] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(353), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(351), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2802] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(291), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(289), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2868] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(315), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(313), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2934] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(455), 1,
      anon_sym_COMMA,
    STATE(151), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(453), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(451), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3004] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(299), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(297), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3070] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3136] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3202] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(274), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3268] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(311), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(309), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3334] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    STATE(176), 1,
      sym_macro_call_full_content,
    ACTIONS(459), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(457), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3404] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(299), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(297), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3470] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(324), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3536] = 8,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(382), 1,
      sym_file_descriptor,
    ACTIONS(388), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(463), 1,
      sym_grep_specifier_identifier,
    ACTIONS(465), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(467), 1,
      anon_sym_BQUOTE,
    STATE(143), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(384), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [3612] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(295), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(293), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3678] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3744] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3810] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(396), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(394), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3876] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(291), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(289), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3942] = 7,
    ACTIONS(367), 1,
      sym_file_descriptor,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(469), 1,
      sym_grep_specifier_identifier,
    ACTIONS(472), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(475), 1,
      anon_sym_BQUOTE,
    STATE(143), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(369), 52,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [4016] = 3,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(301), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(303), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4082] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(287), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(285), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4148] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(315), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(313), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4214] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(480), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(478), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4280] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4346] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(301), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4412] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(311), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(309), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4478] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(455), 1,
      anon_sym_COMMA,
    STATE(154), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(484), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(482), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4548] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(490), 1,
      sym__eq_sep_concat,
    STATE(152), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(488), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(486), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4618] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(319), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(317), 50,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4684] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(497), 1,
      anon_sym_COMMA,
    STATE(154), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(495), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(493), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4754] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(504), 1,
      sym__eq_sep_concat,
    STATE(152), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(502), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(500), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4824] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(307), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(305), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4890] = 3,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(301), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(303), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4956] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(412), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(410), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5021] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(268), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5086] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(508), 1,
      anon_sym_TILDE,
    ACTIONS(510), 1,
      anon_sym_PIPE,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(516), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(518), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(520), 1,
      anon_sym_AT_AT,
    ACTIONS(522), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(524), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(562), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(564), 1,
      anon_sym_AT,
    ACTIONS(566), 1,
      anon_sym_AT_BANG,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(572), 1,
      anon_sym_ATb_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(580), 1,
      anon_sym_ATi_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(584), 1,
      anon_sym_ATo_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(598), 1,
      anon_sym_GT,
    ACTIONS(600), 1,
      anon_sym_GT_GT,
    ACTIONS(602), 1,
      sym_html_redirect_operator,
    ACTIONS(604), 1,
      sym_html_append_operator,
    ACTIONS(606), 1,
      sym_file_descriptor,
    STATE(315), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
    ACTIONS(506), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [5251] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(610), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(608), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5316] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(614), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(612), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5381] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(488), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(486), 49,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5446] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(495), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(493), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5511] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(618), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(616), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5576] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(624), 1,
      anon_sym_EQ,
    ACTIONS(622), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(620), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5643] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(382), 1,
      sym_file_descriptor,
    ACTIONS(388), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(463), 1,
      sym_grep_specifier_identifier,
    ACTIONS(465), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(143), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(384), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [5716] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(630), 1,
      anon_sym_COLON,
    ACTIONS(628), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(626), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5783] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(634), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(632), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5848] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(640), 1,
      anon_sym_COLON,
    ACTIONS(638), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(636), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5915] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(644), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(642), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5980] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(650), 1,
      anon_sym_COLON,
    ACTIONS(648), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(646), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6047] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(654), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(652), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6111] = 3,
    ACTIONS(301), 1,
      sym_file_descriptor,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(303), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [6175] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(660), 1,
      sym__concat_pf_dot,
    ACTIONS(658), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(656), 47,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [6241] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(664), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(662), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6305] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(384), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(382), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6369] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(668), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(666), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6433] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(63), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(61), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6497] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(672), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(670), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6561] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(676), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(674), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6625] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(680), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(678), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6689] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(684), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(682), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6753] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6817] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6881] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6945] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(59), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(57), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7009] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(692), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(690), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7073] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(696), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(694), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7137] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(700), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(698), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7201] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(704), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(702), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7265] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(708), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(706), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7329] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7393] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(712), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(710), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7457] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(716), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(714), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7521] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(720), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(718), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7585] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7649] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(724), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(722), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7713] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7777] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(728), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(726), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7841] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(732), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(730), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7905] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(736), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(734), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7969] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(740), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(738), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8033] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(744), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(742), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8097] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(748), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(746), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8161] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(752), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(750), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8225] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(756), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(754), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8289] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(760), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(758), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8353] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(764), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(762), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8417] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8481] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(770), 1,
      anon_sym_EQ,
    ACTIONS(768), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(766), 47,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [8547] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8611] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(688), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(686), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8675] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(774), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(772), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8739] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(778), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(776), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8803] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(782), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(780), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8867] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(786), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(784), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8931] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(790), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(788), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8995] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(790), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(788), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9059] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(794), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(792), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9123] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(798), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(796), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9187] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(802), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(800), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9251] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(806), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(804), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9315] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(810), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(808), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9379] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(814), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(812), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9443] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(818), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(816), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9507] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(822), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(820), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9571] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(826), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(824), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9635] = 3,
    ACTIONS(301), 1,
      sym_file_descriptor,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(303), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [9699] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(830), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(828), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9763] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(834), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(832), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9827] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(838), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(836), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9891] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(842), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(840), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9955] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(846), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(844), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10019] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(439), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(437), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10083] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(850), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(848), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10147] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(854), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(852), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10211] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(858), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(856), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10275] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(862), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(860), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10339] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(866), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(864), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10403] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(870), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(868), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10467] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(874), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(872), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10531] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(878), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(876), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10595] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(882), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(880), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10659] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(886), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(884), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10723] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(890), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(888), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10787] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(894), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(892), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10851] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(898), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(896), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10915] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(902), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(900), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10979] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(906), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(904), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11043] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(910), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(908), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11107] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(914), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(912), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11171] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(918), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(916), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11235] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(922), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(920), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11299] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(926), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(924), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11363] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(930), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(928), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11427] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(934), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(932), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11491] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(938), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(936), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11555] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(942), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(940), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11619] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(946), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(944), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11683] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(950), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(948), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11747] = 4,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(956), 1,
      sym_pipe_second_command,
    ACTIONS(952), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(954), 52,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [11812] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(516), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(518), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(520), 1,
      anon_sym_AT_AT,
    ACTIONS(522), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(524), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(562), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(564), 1,
      anon_sym_AT,
    ACTIONS(566), 1,
      anon_sym_AT_BANG,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(572), 1,
      anon_sym_ATb_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(580), 1,
      anon_sym_ATi_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(584), 1,
      anon_sym_ATo_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(960), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(958), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [11961] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(516), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(518), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(520), 1,
      anon_sym_AT_AT,
    ACTIONS(522), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(524), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(562), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(564), 1,
      anon_sym_AT,
    ACTIONS(566), 1,
      anon_sym_AT_BANG,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(572), 1,
      anon_sym_ATb_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(580), 1,
      anon_sym_ATi_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(584), 1,
      anon_sym_ATo_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(964), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(962), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12110] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(598), 1,
      anon_sym_GT,
    ACTIONS(600), 1,
      anon_sym_GT_GT,
    ACTIONS(602), 1,
      sym_html_redirect_operator,
    ACTIONS(604), 1,
      sym_html_append_operator,
    ACTIONS(606), 1,
      sym_file_descriptor,
    ACTIONS(966), 1,
      anon_sym_TILDE,
    ACTIONS(968), 1,
      anon_sym_PIPE,
    ACTIONS(970), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(972), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(974), 1,
      anon_sym_AT_AT,
    ACTIONS(976), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(978), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(980), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(982), 1,
      anon_sym_AT,
    ACTIONS(984), 1,
      anon_sym_AT_BANG,
    ACTIONS(986), 1,
      anon_sym_ATb_COLON,
    ACTIONS(988), 1,
      anon_sym_ATi_COLON,
    ACTIONS(990), 1,
      anon_sym_ATo_COLON,
    ACTIONS(506), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(315), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [12273] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(516), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(518), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(520), 1,
      anon_sym_AT_AT,
    ACTIONS(522), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(524), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(562), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(564), 1,
      anon_sym_AT,
    ACTIONS(566), 1,
      anon_sym_AT_BANG,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(572), 1,
      anon_sym_ATb_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(580), 1,
      anon_sym_ATi_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(584), 1,
      anon_sym_ATo_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(598), 1,
      anon_sym_GT,
    ACTIONS(600), 1,
      anon_sym_GT_GT,
    ACTIONS(602), 1,
      sym_html_redirect_operator,
    ACTIONS(604), 1,
      sym_html_append_operator,
    ACTIONS(606), 1,
      sym_file_descriptor,
    ACTIONS(992), 1,
      anon_sym_TILDE,
    ACTIONS(994), 1,
      anon_sym_PIPE,
    ACTIONS(506), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(315), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [12436] = 4,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(952), 1,
      sym_file_descriptor,
    ACTIONS(956), 1,
      sym_pipe_second_command,
    ACTIONS(954), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12499] = 4,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(952), 1,
      sym_file_descriptor,
    ACTIONS(956), 1,
      sym_pipe_second_command,
    ACTIONS(954), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [12562] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(996), 1,
      sym__concat_pf_dot,
    ACTIONS(658), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(656), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12625] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(998), 1,
      anon_sym_EQ,
    ACTIONS(768), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_AT,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(766), 44,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_PIPE_DOT,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12688] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(970), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(972), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(974), 1,
      anon_sym_AT_AT,
    ACTIONS(976), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(978), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(980), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(982), 1,
      anon_sym_AT,
    ACTIONS(984), 1,
      anon_sym_AT_BANG,
    ACTIONS(986), 1,
      anon_sym_ATb_COLON,
    ACTIONS(988), 1,
      anon_sym_ATi_COLON,
    ACTIONS(990), 1,
      anon_sym_ATo_COLON,
    ACTIONS(964), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(962), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12834] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(512), 1,
      anon_sym_PIPEH,
    ACTIONS(514), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(526), 1,
      anon_sym_AT_ATC,
    ACTIONS(528), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(530), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(532), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(534), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(536), 1,
      anon_sym_AT_ATt,
    ACTIONS(538), 1,
      anon_sym_AT_ATb,
    ACTIONS(540), 1,
      anon_sym_AT_ATi,
    ACTIONS(542), 1,
      anon_sym_AT_ATii,
    ACTIONS(544), 1,
      anon_sym_AT_ATiS,
    ACTIONS(546), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(548), 1,
      anon_sym_AT_ATis,
    ACTIONS(550), 1,
      anon_sym_AT_ATiz,
    ACTIONS(552), 1,
      anon_sym_AT_ATf,
    ACTIONS(554), 1,
      anon_sym_AT_ATF,
    ACTIONS(556), 1,
      anon_sym_AT_ATom,
    ACTIONS(558), 1,
      anon_sym_AT_ATdm,
    ACTIONS(560), 1,
      anon_sym_AT_ATr,
    ACTIONS(568), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(570), 1,
      anon_sym_ATa_COLON,
    ACTIONS(574), 1,
      anon_sym_ATB_COLON,
    ACTIONS(576), 1,
      anon_sym_ATe_COLON,
    ACTIONS(578), 1,
      anon_sym_ATF_COLON,
    ACTIONS(582), 1,
      anon_sym_ATk_COLON,
    ACTIONS(586), 1,
      anon_sym_ATr_COLON,
    ACTIONS(588), 1,
      anon_sym_ATf_COLON,
    ACTIONS(590), 1,
      anon_sym_ATs_COLON,
    ACTIONS(592), 1,
      anon_sym_ATv_COLON,
    ACTIONS(594), 1,
      anon_sym_ATx_COLON,
    ACTIONS(596), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(970), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(972), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(974), 1,
      anon_sym_AT_AT,
    ACTIONS(976), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(978), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(980), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(982), 1,
      anon_sym_AT,
    ACTIONS(984), 1,
      anon_sym_AT_BANG,
    ACTIONS(986), 1,
      anon_sym_ATb_COLON,
    ACTIONS(988), 1,
      anon_sym_ATi_COLON,
    ACTIONS(990), 1,
      anon_sym_ATo_COLON,
    ACTIONS(960), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(958), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12980] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(273), 1,
      aux_sym_commands_repeat1,
    ACTIONS(1004), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
    ACTIONS(1002), 6,
      anon_sym_0,
      anon_sym_DOT,
      aux_sym__interpret_command_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1000), 20,
      sym_cmd_identifier,
      sym__help_command,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      aux_sym_number_command_token1,
      aux_sym__interpret_command_token3,
      anon_sym_DOT_BANG,
      anon_sym_DOT_LPAREN,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [13022] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1011), 1,
      anon_sym_SEMI,
    STATE(274), 1,
      aux_sym__commands_singleline_repeat1,
    ACTIONS(1009), 6,
      anon_sym_0,
      anon_sym_DOT,
      aux_sym__interpret_command_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(1007), 19,
      sym_cmd_identifier,
      sym__help_command,
      anon_sym_DQUOTE,
      aux_sym_number_command_token1,
      aux_sym__interpret_command_token3,
      anon_sym_DOT_BANG,
      anon_sym_DOT_LPAREN,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      anon_sym_PERCENT,
      anon_sym_env,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      sym_macro_identifier,
      aux_sym__dec_number_token1,
  [13061] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1014), 1,
      anon_sym_RPAREN,
    ACTIONS(1016), 1,
      anon_sym_SEMI,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(447), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13113] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    STATE(219), 1,
      sym_macro_call_content,
    STATE(339), 1,
      sym_concatenation,
    STATE(490), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13165] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1020), 1,
      anon_sym_RPAREN,
    STATE(198), 1,
      sym_macro_call_content,
    STATE(339), 1,
      sym_concatenation,
    STATE(490), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13217] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1022), 1,
      anon_sym_DQUOTE,
    ACTIONS(1025), 1,
      anon_sym_DOLLAR,
    ACTIONS(1028), 1,
      anon_sym_LPAREN,
    ACTIONS(1031), 1,
      anon_sym_COMMA,
    ACTIONS(1034), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1037), 1,
      anon_sym_SQUOTE,
    ACTIONS(1040), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1043), 1,
      anon_sym_BQUOTE,
    STATE(339), 1,
      sym_concatenation,
    ACTIONS(177), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(278), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13264] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    ACTIONS(173), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(278), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13311] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(480), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13357] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(219), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13403] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(499), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13449] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(192), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13495] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(203), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13541] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(492), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13587] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(195), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13633] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(203), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13679] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(219), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13725] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(201), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13771] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(195), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13817] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(201), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13863] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(191), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13909] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(472), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13955] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(494), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14001] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(192), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14047] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(191), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14093] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(489), 1,
      sym_args,
    STATE(279), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14139] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(222), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14185] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(190), 1,
      sym_args,
    STATE(69), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14231] = 14,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1048), 1,
      anon_sym_DQUOTE,
    ACTIONS(1050), 1,
      anon_sym_DOLLAR,
    ACTIONS(1052), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_COMMA,
    ACTIONS(1056), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1058), 1,
      anon_sym_SQUOTE,
    ACTIONS(1060), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1062), 1,
      anon_sym_BQUOTE,
    STATE(235), 1,
      sym__eq_sep_val_concatenation,
    STATE(236), 1,
      sym__eq_sep_val,
    STATE(457), 1,
      sym_arg,
    STATE(460), 1,
      sym_concatenation,
    STATE(120), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14279] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(222), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14325] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(190), 1,
      sym_args,
    STATE(54), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14371] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(207), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14413] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(202), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14455] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(208), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14497] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(245), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14539] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(246), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14581] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(247), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14623] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1048), 1,
      anon_sym_DQUOTE,
    ACTIONS(1050), 1,
      anon_sym_DOLLAR,
    ACTIONS(1052), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_COMMA,
    ACTIONS(1056), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1058), 1,
      anon_sym_SQUOTE,
    ACTIONS(1060), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1062), 1,
      anon_sym_BQUOTE,
    STATE(159), 1,
      sym_concatenation,
    STATE(163), 1,
      sym_arg,
    STATE(116), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14665] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(205), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14707] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(181), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14749] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(194), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14791] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(196), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14833] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(204), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14875] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(339), 1,
      sym_concatenation,
    STATE(401), 1,
      sym_arg,
    STATE(319), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14917] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(200), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14959] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(87), 1,
      sym_concatenation,
    STATE(206), 1,
      sym_arg,
    STATE(74), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15001] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(283), 1,
      anon_sym_DOLLAR,
    ACTIONS(1064), 1,
      sym__concat,
    STATE(320), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(281), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15028] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 1,
      anon_sym_DOLLAR,
    ACTIONS(1064), 1,
      sym__concat,
    STATE(318), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(268), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15055] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(1066), 1,
      sym__concat,
    STATE(320), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(274), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15082] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 1,
      anon_sym_DOLLAR,
    ACTIONS(301), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15104] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(287), 1,
      anon_sym_DOLLAR,
    ACTIONS(285), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15126] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 1,
      anon_sym_DOLLAR,
    ACTIONS(301), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15148] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(204), 1,
      anon_sym_DQUOTE,
    ACTIONS(208), 1,
      anon_sym_DOLLAR,
    ACTIONS(210), 1,
      anon_sym_LPAREN,
    ACTIONS(212), 1,
      anon_sym_COMMA,
    ACTIONS(214), 1,
      anon_sym_SQUOTE,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1069), 1,
      aux_sym_arg_identifier_token1,
    STATE(399), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15184] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(274), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15206] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1048), 1,
      anon_sym_DQUOTE,
    ACTIONS(1050), 1,
      anon_sym_DOLLAR,
    ACTIONS(1052), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_COMMA,
    ACTIONS(1056), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1058), 1,
      anon_sym_SQUOTE,
    ACTIONS(1060), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1062), 1,
      anon_sym_BQUOTE,
    STATE(132), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15242] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1071), 1,
      anon_sym_DQUOTE,
    ACTIONS(1073), 1,
      anon_sym_DOLLAR,
    ACTIONS(1075), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_COMMA,
    ACTIONS(1079), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1081), 1,
      anon_sym_SQUOTE,
    ACTIONS(1083), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1085), 1,
      anon_sym_BQUOTE,
    STATE(443), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15278] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(299), 1,
      anon_sym_DOLLAR,
    ACTIONS(297), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15300] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(307), 1,
      anon_sym_DOLLAR,
    ACTIONS(305), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15322] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(295), 1,
      anon_sym_DOLLAR,
    ACTIONS(293), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15344] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(291), 1,
      anon_sym_DOLLAR,
    ACTIONS(289), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15366] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(315), 1,
      anon_sym_DOLLAR,
    ACTIONS(313), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15388] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(311), 1,
      anon_sym_DOLLAR,
    ACTIONS(309), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15410] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(141), 1,
      anon_sym_DQUOTE,
    ACTIONS(145), 1,
      anon_sym_DOLLAR,
    ACTIONS(147), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_COMMA,
    ACTIONS(151), 1,
      anon_sym_SQUOTE,
    ACTIONS(153), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(1018), 1,
      aux_sym_arg_identifier_token1,
    STATE(325), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15446] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(111), 1,
      anon_sym_DQUOTE,
    ACTIONS(115), 1,
      anon_sym_DOLLAR,
    ACTIONS(117), 1,
      anon_sym_LPAREN,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(125), 1,
      anon_sym_BQUOTE,
    ACTIONS(1046), 1,
      aux_sym_arg_identifier_token1,
    STATE(84), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15482] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(224), 1,
      sym_pf_args,
    STATE(89), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15517] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(259), 1,
      sym_pf_args,
    STATE(72), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15552] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(258), 1,
      sym_pf_args,
    STATE(72), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15587] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 1,
      anon_sym_DOLLAR,
    ACTIONS(268), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15608] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(252), 1,
      anon_sym_RPAREN,
    ACTIONS(1089), 1,
      anon_sym_DOLLAR,
    ACTIONS(1092), 1,
      anon_sym_LPAREN,
    ACTIONS(1095), 1,
      aux_sym_pf_arg_identifier_token1,
    ACTIONS(1098), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1101), 1,
      anon_sym_BQUOTE,
    STATE(400), 1,
      sym_pf_concatenation,
    STATE(340), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(366), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15643] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(258), 1,
      sym_pf_args,
    STATE(89), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15678] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(224), 1,
      sym_pf_args,
    STATE(72), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15713] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(248), 1,
      anon_sym_RPAREN,
    ACTIONS(1104), 1,
      anon_sym_DOLLAR,
    ACTIONS(1106), 1,
      anon_sym_LPAREN,
    ACTIONS(1108), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(400), 1,
      sym_pf_concatenation,
    STATE(340), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(366), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15748] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      anon_sym_DOLLAR,
    ACTIONS(1106), 1,
      anon_sym_LPAREN,
    ACTIONS(1108), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(400), 1,
      sym_pf_concatenation,
    STATE(483), 1,
      sym_pf_args,
    STATE(343), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(366), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15783] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      anon_sym_DOLLAR,
    ACTIONS(1106), 1,
      anon_sym_LPAREN,
    ACTIONS(1108), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(400), 1,
      sym_pf_concatenation,
    STATE(493), 1,
      sym_pf_args,
    STATE(343), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(366), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15818] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(259), 1,
      sym_pf_args,
    STATE(89), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(99), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15853] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(236), 1,
      anon_sym_DQUOTE,
    ACTIONS(242), 1,
      anon_sym_SQUOTE,
    ACTIONS(244), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(246), 1,
      anon_sym_BQUOTE,
    ACTIONS(1110), 1,
      sym__eq_sep_key_identifier,
    STATE(158), 1,
      sym__eq_sep_key_concatenation,
    STATE(166), 1,
      sym__eq_sep_key,
    STATE(260), 1,
      sym_eq_sep_args,
    STATE(113), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15887] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1112), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1114), 1,
      anon_sym_DOLLAR,
    ACTIONS(1116), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1118), 1,
      anon_sym_BQUOTE,
    STATE(71), 1,
      sym_pf_dot_arg,
    STATE(95), 1,
      sym_pf_dot_concatenation,
    STATE(251), 1,
      sym_pf_dot_cmd_args,
    STATE(257), 1,
      sym_pf_new_args,
    STATE(270), 1,
      sym_pf_dot_args,
    STATE(90), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15923] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1112), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1114), 1,
      anon_sym_DOLLAR,
    ACTIONS(1116), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1118), 1,
      anon_sym_BQUOTE,
    STATE(57), 1,
      sym_pf_dot_arg,
    STATE(95), 1,
      sym_pf_dot_concatenation,
    STATE(211), 1,
      sym_pf_dot_args,
    STATE(251), 1,
      sym_pf_dot_cmd_args,
    STATE(257), 1,
      sym_pf_new_args,
    STATE(90), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15959] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1120), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1122), 1,
      anon_sym_DOLLAR,
    ACTIONS(1124), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1126), 1,
      anon_sym_BQUOTE,
    STATE(118), 1,
      sym_pf_dot_arg,
    STATE(136), 1,
      sym_pf_dot_concatenation,
    STATE(211), 1,
      sym_pf_dot_args,
    STATE(251), 1,
      sym_pf_dot_cmd_args,
    STATE(123), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15992] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1120), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1122), 1,
      anon_sym_DOLLAR,
    ACTIONS(1124), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1126), 1,
      anon_sym_BQUOTE,
    STATE(118), 1,
      sym_pf_dot_arg,
    STATE(136), 1,
      sym_pf_dot_concatenation,
    STATE(251), 1,
      sym_pf_dot_cmd_args,
    STATE(270), 1,
      sym_pf_dot_args,
    STATE(123), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16025] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(224), 1,
      anon_sym_DOLLAR,
    ACTIONS(226), 1,
      anon_sym_LPAREN,
    ACTIONS(228), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1087), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(104), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [16050] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(216), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(218), 1,
      anon_sym_BQUOTE,
    ACTIONS(1104), 1,
      anon_sym_DOLLAR,
    ACTIONS(1106), 1,
      anon_sym_LPAREN,
    ACTIONS(1108), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(384), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [16075] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(236), 1,
      anon_sym_DQUOTE,
    ACTIONS(242), 1,
      anon_sym_SQUOTE,
    ACTIONS(244), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(246), 1,
      anon_sym_BQUOTE,
    ACTIONS(1128), 1,
      sym__eq_sep_key_identifier,
    STATE(141), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [16100] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1120), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1122), 1,
      anon_sym_DOLLAR,
    ACTIONS(1124), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1126), 1,
      anon_sym_BQUOTE,
    STATE(136), 1,
      sym_pf_dot_concatenation,
    STATE(147), 1,
      sym_pf_dot_arg,
    STATE(123), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16127] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 1,
      anon_sym_DOLLAR,
    ACTIONS(1130), 1,
      sym__concat,
    STATE(356), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(340), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16147] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1133), 1,
      anon_sym_DQUOTE,
    ACTIONS(1135), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1137), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16171] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1145), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1147), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(360), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16195] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1151), 1,
      anon_sym_DOLLAR,
    ACTIONS(1149), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16211] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1135), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1137), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16235] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1155), 1,
      anon_sym_DQUOTE,
    ACTIONS(1157), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1159), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(363), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16259] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1163), 1,
      anon_sym_DOLLAR,
    ACTIONS(1161), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16275] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1135), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1165), 1,
      anon_sym_DQUOTE,
    ACTIONS(1137), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16299] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1167), 1,
      anon_sym_DQUOTE,
    ACTIONS(1169), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1171), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(357), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16323] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1173), 1,
      anon_sym_DQUOTE,
    ACTIONS(1175), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1177), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(374), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16347] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 1,
      anon_sym_DOLLAR,
    ACTIONS(1179), 1,
      sym__concat,
    STATE(370), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(347), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16367] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1183), 1,
      anon_sym_DOLLAR,
    ACTIONS(1181), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16383] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1187), 1,
      anon_sym_DOLLAR,
    ACTIONS(1185), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16399] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1135), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1189), 1,
      anon_sym_DQUOTE,
    ACTIONS(1137), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16423] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 1,
      anon_sym_DOLLAR,
    ACTIONS(1179), 1,
      sym__concat,
    STATE(356), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(334), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16443] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1191), 1,
      anon_sym_DQUOTE,
    ACTIONS(1193), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1195), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(369), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16467] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1135), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1197), 1,
      anon_sym_DQUOTE,
    ACTIONS(1137), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16491] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1199), 1,
      anon_sym_DQUOTE,
    ACTIONS(1201), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1203), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16515] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1135), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1139), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1141), 1,
      anon_sym_BQUOTE,
    ACTIONS(1205), 1,
      anon_sym_DQUOTE,
    ACTIONS(1137), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16539] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1209), 1,
      anon_sym_DOLLAR,
    ACTIONS(1207), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16555] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1211), 1,
      anon_sym_DQUOTE,
    ACTIONS(1213), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1219), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1222), 1,
      anon_sym_BQUOTE,
    ACTIONS(1216), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(376), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16579] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(361), 1,
      anon_sym_DOLLAR,
    ACTIONS(359), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16594] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(283), 1,
      anon_sym_DOLLAR,
    ACTIONS(1225), 1,
      sym__concat,
    STATE(385), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(281), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16613] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1120), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1122), 1,
      anon_sym_DOLLAR,
    ACTIONS(1124), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1126), 1,
      anon_sym_BQUOTE,
    STATE(153), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16634] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1112), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1114), 1,
      anon_sym_DOLLAR,
    ACTIONS(1116), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1118), 1,
      anon_sym_BQUOTE,
    STATE(94), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16655] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(465), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(467), 1,
      anon_sym_BQUOTE,
    ACTIONS(1227), 1,
      sym_grep_specifier_identifier,
    ACTIONS(1229), 1,
      aux_sym_grep_specifier_token1,
    STATE(178), 1,
      sym_grep_specifier,
    STATE(137), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16678] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(357), 1,
      anon_sym_DOLLAR,
    ACTIONS(355), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16693] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(390), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(392), 1,
      anon_sym_BQUOTE,
    ACTIONS(1229), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1231), 1,
      sym_grep_specifier_identifier,
    STATE(178), 1,
      sym_grep_specifier,
    STATE(108), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16716] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 1,
      anon_sym_DOLLAR,
    ACTIONS(340), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16731] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(1233), 1,
      sym__concat,
    STATE(385), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(274), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16750] = 7,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(465), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(467), 1,
      anon_sym_BQUOTE,
    ACTIONS(1229), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1236), 1,
      sym_grep_specifier_identifier,
    STATE(178), 1,
      sym_grep_specifier,
    STATE(167), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16773] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 1,
      anon_sym_DOLLAR,
    ACTIONS(1225), 1,
      sym__concat,
    STATE(378), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(268), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16792] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 1,
      anon_sym_DOLLAR,
    ACTIONS(301), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16807] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(303), 1,
      anon_sym_DOLLAR,
    ACTIONS(301), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16822] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(299), 1,
      anon_sym_DOLLAR,
    ACTIONS(297), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16836] = 3,
    ACTIONS(301), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(303), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16850] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(295), 1,
      anon_sym_DOLLAR,
    ACTIONS(293), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16864] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(291), 1,
      anon_sym_DOLLAR,
    ACTIONS(289), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16878] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(315), 1,
      anon_sym_DOLLAR,
    ACTIONS(313), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16892] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(311), 1,
      anon_sym_DOLLAR,
    ACTIONS(309), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16906] = 3,
    ACTIONS(301), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(303), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16920] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(287), 1,
      anon_sym_DOLLAR,
    ACTIONS(285), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16934] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(307), 1,
      anon_sym_DOLLAR,
    ACTIONS(305), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16948] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_DOLLAR,
    ACTIONS(274), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16962] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 1,
      anon_sym_DOLLAR,
    ACTIONS(347), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16976] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1238), 6,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [16988] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1240), 1,
      ts_builtin_sym_end,
    STATE(404), 1,
      aux_sym_commands_repeat2,
    ACTIONS(1242), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17003] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1244), 1,
      ts_builtin_sym_end,
    STATE(403), 1,
      aux_sym_commands_repeat2,
    ACTIONS(1246), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17018] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1249), 1,
      ts_builtin_sym_end,
    STATE(403), 1,
      aux_sym_commands_repeat2,
    ACTIONS(1242), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17033] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 1,
      anon_sym_DOLLAR,
    ACTIONS(268), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [17046] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1240), 1,
      ts_builtin_sym_end,
    STATE(403), 1,
      aux_sym_commands_repeat2,
    ACTIONS(1242), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17061] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(91), 1,
      ts_builtin_sym_end,
    STATE(406), 1,
      aux_sym_commands_repeat2,
    ACTIONS(1242), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17076] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1251), 1,
      anon_sym_SQUOTE,
    ACTIONS(1253), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1255), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(418), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17092] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1257), 1,
      anon_sym_SQUOTE,
    ACTIONS(1259), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1261), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17108] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1263), 1,
      anon_sym_SQUOTE,
    ACTIONS(1265), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1267), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(409), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17124] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1269), 1,
      anon_sym_SQUOTE,
    ACTIONS(1271), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1273), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(416), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17140] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1275), 1,
      anon_sym_SQUOTE,
    ACTIONS(1277), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1280), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17156] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1259), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1261), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1283), 1,
      anon_sym_SQUOTE,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17172] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1259), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1261), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1285), 1,
      anon_sym_SQUOTE,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17188] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1259), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1261), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1287), 1,
      anon_sym_SQUOTE,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17204] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1259), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1261), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1289), 1,
      anon_sym_SQUOTE,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17220] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1291), 1,
      anon_sym_SQUOTE,
    ACTIONS(1293), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1295), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(413), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17236] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1259), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1261), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1297), 1,
      anon_sym_SQUOTE,
    STATE(412), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17252] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1299), 1,
      anon_sym_SQUOTE,
    ACTIONS(1301), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1303), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17268] = 5,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1305), 1,
      anon_sym_SQUOTE,
    ACTIONS(1307), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1309), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(414), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17284] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1311), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(124), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(128), 1,
      sym_tmp_eval_arg,
    STATE(173), 1,
      sym_tmp_eval_args,
  [17300] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1244), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17310] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1313), 1,
      anon_sym_SEMI,
    ACTIONS(1315), 1,
      anon_sym_BQUOTE,
    STATE(434), 1,
      aux_sym__commands_singleline_repeat2,
  [17323] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1315), 1,
      anon_sym_RPAREN,
    ACTIONS(1317), 1,
      anon_sym_SEMI,
    STATE(425), 1,
      aux_sym__commands_singleline_repeat2,
  [17336] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1317), 1,
      anon_sym_SEMI,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    STATE(427), 1,
      aux_sym__commands_singleline_repeat2,
  [17349] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1313), 1,
      anon_sym_SEMI,
    ACTIONS(1321), 1,
      anon_sym_BQUOTE,
    STATE(439), 1,
      aux_sym__commands_singleline_repeat2,
  [17362] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 1,
      anon_sym_SEMI,
    STATE(427), 1,
      aux_sym__commands_singleline_repeat2,
  [17375] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [17384] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1311), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(124), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(164), 1,
      sym_tmp_eval_arg,
  [17397] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1328), 1,
      anon_sym_RPAREN,
    ACTIONS(1330), 1,
      anon_sym_SEMI,
    STATE(430), 1,
      aux_sym_macro_content_repeat1,
  [17410] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(281), 1,
      sym__eq_sep_concat,
    ACTIONS(441), 1,
      sym__concat,
    STATE(438), 1,
      aux_sym_concatenation_repeat1,
  [17423] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1333), 1,
      anon_sym_RPAREN,
    ACTIONS(1335), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      aux_sym_macro_content_repeat1,
  [17436] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1335), 1,
      anon_sym_SEMI,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
    STATE(430), 1,
      aux_sym_macro_content_repeat1,
  [17449] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1313), 1,
      anon_sym_SEMI,
    ACTIONS(1319), 1,
      anon_sym_BQUOTE,
    STATE(436), 1,
      aux_sym__commands_singleline_repeat2,
  [17462] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1315), 1,
      anon_sym_RPAREN,
    ACTIONS(1317), 1,
      anon_sym_SEMI,
    STATE(427), 1,
      aux_sym__commands_singleline_repeat2,
  [17475] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      anon_sym_BQUOTE,
    ACTIONS(1339), 1,
      anon_sym_SEMI,
    STATE(436), 1,
      aux_sym__commands_singleline_repeat2,
  [17488] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1335), 1,
      anon_sym_SEMI,
    ACTIONS(1337), 1,
      anon_sym_RPAREN,
    STATE(440), 1,
      aux_sym_macro_content_repeat1,
  [17501] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 1,
      sym__eq_sep_concat,
    ACTIONS(1342), 1,
      sym__concat,
    STATE(438), 1,
      aux_sym_concatenation_repeat1,
  [17514] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1313), 1,
      anon_sym_SEMI,
    ACTIONS(1315), 1,
      anon_sym_BQUOTE,
    STATE(436), 1,
      aux_sym__commands_singleline_repeat2,
  [17527] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1335), 1,
      anon_sym_SEMI,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    STATE(430), 1,
      aux_sym_macro_content_repeat1,
  [17540] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1317), 1,
      anon_sym_SEMI,
    ACTIONS(1321), 1,
      anon_sym_RPAREN,
    STATE(435), 1,
      aux_sym__commands_singleline_repeat2,
  [17553] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(297), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17561] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17569] = 3,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1347), 1,
      sym__any_command,
    STATE(219), 1,
      sym_interpret_arg,
  [17579] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(301), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17587] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(301), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17595] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1349), 1,
      anon_sym_RPAREN,
    ACTIONS(1351), 1,
      anon_sym_SEMI,
  [17605] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(293), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17613] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1328), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [17621] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1353), 1,
      anon_sym_GT,
    ACTIONS(1355), 1,
      anon_sym_GT_GT,
  [17631] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1357), 1,
      aux_sym__search_command_token1,
    STATE(244), 1,
      sym__search_command,
  [17641] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1359), 1,
      aux_sym__search_command_token1,
    STATE(244), 1,
      sym__search_command,
  [17651] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(289), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17659] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(313), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17667] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(285), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17675] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(305), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17683] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(504), 1,
      sym__eq_sep_concat,
    STATE(155), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
  [17693] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(309), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17701] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1361), 1,
      anon_sym_RPAREN,
  [17708] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(268), 1,
      sym__eq_sep_concat,
  [17715] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1363), 1,
      anon_sym_BQUOTE,
  [17722] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1365), 1,
      anon_sym_RPAREN,
  [17729] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1367), 1,
      anon_sym_BQUOTE,
  [17736] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1369), 1,
      anon_sym_RPAREN,
  [17743] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1371), 1,
      anon_sym_BQUOTE,
  [17750] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1373), 1,
      anon_sym_RPAREN,
  [17757] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1375), 1,
      anon_sym_BQUOTE,
  [17764] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1377), 1,
      anon_sym_RPAREN,
  [17771] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1379), 1,
      anon_sym_BQUOTE,
  [17778] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
  [17785] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1383), 1,
      anon_sym_BQUOTE,
  [17792] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1385), 1,
      anon_sym_RPAREN,
  [17799] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1387), 1,
      anon_sym_DOT,
  [17806] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1389), 1,
      anon_sym_BQUOTE,
  [17813] = 2,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1391), 1,
      aux_sym__interpret_command_token2,
  [17820] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1393), 1,
      anon_sym_BQUOTE,
  [17827] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1395), 1,
      sym__concat,
  [17834] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1397), 1,
      anon_sym_BQUOTE,
  [17841] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1399), 1,
      anon_sym_RPAREN,
  [17848] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1401), 1,
      anon_sym_RPAREN,
  [17855] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1403), 1,
      sym__concat,
  [17862] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_RPAREN,
  [17869] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1407), 1,
      anon_sym_RPAREN,
  [17876] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1409), 1,
      anon_sym_BQUOTE,
  [17883] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1411), 1,
      anon_sym_BQUOTE,
  [17890] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1413), 1,
      sym__concat_pf_dot,
  [17897] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1415), 1,
      anon_sym_RPAREN,
  [17904] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1417), 1,
      anon_sym_RPAREN,
  [17911] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1419), 1,
      anon_sym_RPAREN,
  [17918] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1421), 1,
      anon_sym_RPAREN,
  [17925] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1423), 1,
      anon_sym_DQUOTE,
  [17932] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1425), 1,
      anon_sym_RPAREN,
  [17939] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1427), 1,
      anon_sym_RPAREN,
  [17946] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1429), 1,
      anon_sym_RPAREN,
  [17953] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1431), 1,
      ts_builtin_sym_end,
  [17960] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1433), 1,
      anon_sym_BQUOTE,
  [17967] = 2,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1435), 1,
      aux_sym_legacy_quoted_command_token1,
  [17974] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1437), 1,
      sym__concat_pf_dot,
  [17981] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
  [17988] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
  [17995] = 2,
    ACTIONS(380), 1,
      sym__comment,
    ACTIONS(1443), 1,
      aux_sym__interpret_command_token2,
  [18002] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
  [18009] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1447), 1,
      sym__concat_pf_dot,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(87)] = 0,
  [SMALL_STATE(88)] = 71,
  [SMALL_STATE(89)] = 146,
  [SMALL_STATE(90)] = 229,
  [SMALL_STATE(91)] = 302,
  [SMALL_STATE(92)] = 389,
  [SMALL_STATE(93)] = 464,
  [SMALL_STATE(94)] = 534,
  [SMALL_STATE(95)] = 604,
  [SMALL_STATE(96)] = 674,
  [SMALL_STATE(97)] = 748,
  [SMALL_STATE(98)] = 818,
  [SMALL_STATE(99)] = 892,
  [SMALL_STATE(100)] = 966,
  [SMALL_STATE(101)] = 1036,
  [SMALL_STATE(102)] = 1105,
  [SMALL_STATE(103)] = 1174,
  [SMALL_STATE(104)] = 1243,
  [SMALL_STATE(105)] = 1312,
  [SMALL_STATE(106)] = 1381,
  [SMALL_STATE(107)] = 1449,
  [SMALL_STATE(108)] = 1525,
  [SMALL_STATE(109)] = 1603,
  [SMALL_STATE(110)] = 1671,
  [SMALL_STATE(111)] = 1742,
  [SMALL_STATE(112)] = 1813,
  [SMALL_STATE(113)] = 1884,
  [SMALL_STATE(114)] = 1955,
  [SMALL_STATE(115)] = 2026,
  [SMALL_STATE(116)] = 2097,
  [SMALL_STATE(117)] = 2168,
  [SMALL_STATE(118)] = 2239,
  [SMALL_STATE(119)] = 2310,
  [SMALL_STATE(120)] = 2381,
  [SMALL_STATE(121)] = 2454,
  [SMALL_STATE(122)] = 2525,
  [SMALL_STATE(123)] = 2596,
  [SMALL_STATE(124)] = 2665,
  [SMALL_STATE(125)] = 2736,
  [SMALL_STATE(126)] = 2802,
  [SMALL_STATE(127)] = 2868,
  [SMALL_STATE(128)] = 2934,
  [SMALL_STATE(129)] = 3004,
  [SMALL_STATE(130)] = 3070,
  [SMALL_STATE(131)] = 3136,
  [SMALL_STATE(132)] = 3202,
  [SMALL_STATE(133)] = 3268,
  [SMALL_STATE(134)] = 3334,
  [SMALL_STATE(135)] = 3404,
  [SMALL_STATE(136)] = 3470,
  [SMALL_STATE(137)] = 3536,
  [SMALL_STATE(138)] = 3612,
  [SMALL_STATE(139)] = 3678,
  [SMALL_STATE(140)] = 3744,
  [SMALL_STATE(141)] = 3810,
  [SMALL_STATE(142)] = 3876,
  [SMALL_STATE(143)] = 3942,
  [SMALL_STATE(144)] = 4016,
  [SMALL_STATE(145)] = 4082,
  [SMALL_STATE(146)] = 4148,
  [SMALL_STATE(147)] = 4214,
  [SMALL_STATE(148)] = 4280,
  [SMALL_STATE(149)] = 4346,
  [SMALL_STATE(150)] = 4412,
  [SMALL_STATE(151)] = 4478,
  [SMALL_STATE(152)] = 4548,
  [SMALL_STATE(153)] = 4618,
  [SMALL_STATE(154)] = 4684,
  [SMALL_STATE(155)] = 4754,
  [SMALL_STATE(156)] = 4824,
  [SMALL_STATE(157)] = 4890,
  [SMALL_STATE(158)] = 4956,
  [SMALL_STATE(159)] = 5021,
  [SMALL_STATE(160)] = 5086,
  [SMALL_STATE(161)] = 5251,
  [SMALL_STATE(162)] = 5316,
  [SMALL_STATE(163)] = 5381,
  [SMALL_STATE(164)] = 5446,
  [SMALL_STATE(165)] = 5511,
  [SMALL_STATE(166)] = 5576,
  [SMALL_STATE(167)] = 5643,
  [SMALL_STATE(168)] = 5716,
  [SMALL_STATE(169)] = 5783,
  [SMALL_STATE(170)] = 5848,
  [SMALL_STATE(171)] = 5915,
  [SMALL_STATE(172)] = 5980,
  [SMALL_STATE(173)] = 6047,
  [SMALL_STATE(174)] = 6111,
  [SMALL_STATE(175)] = 6175,
  [SMALL_STATE(176)] = 6241,
  [SMALL_STATE(177)] = 6305,
  [SMALL_STATE(178)] = 6369,
  [SMALL_STATE(179)] = 6433,
  [SMALL_STATE(180)] = 6497,
  [SMALL_STATE(181)] = 6561,
  [SMALL_STATE(182)] = 6625,
  [SMALL_STATE(183)] = 6689,
  [SMALL_STATE(184)] = 6753,
  [SMALL_STATE(185)] = 6817,
  [SMALL_STATE(186)] = 6881,
  [SMALL_STATE(187)] = 6945,
  [SMALL_STATE(188)] = 7009,
  [SMALL_STATE(189)] = 7073,
  [SMALL_STATE(190)] = 7137,
  [SMALL_STATE(191)] = 7201,
  [SMALL_STATE(192)] = 7265,
  [SMALL_STATE(193)] = 7329,
  [SMALL_STATE(194)] = 7393,
  [SMALL_STATE(195)] = 7457,
  [SMALL_STATE(196)] = 7521,
  [SMALL_STATE(197)] = 7585,
  [SMALL_STATE(198)] = 7649,
  [SMALL_STATE(199)] = 7713,
  [SMALL_STATE(200)] = 7777,
  [SMALL_STATE(201)] = 7841,
  [SMALL_STATE(202)] = 7905,
  [SMALL_STATE(203)] = 7969,
  [SMALL_STATE(204)] = 8033,
  [SMALL_STATE(205)] = 8097,
  [SMALL_STATE(206)] = 8161,
  [SMALL_STATE(207)] = 8225,
  [SMALL_STATE(208)] = 8289,
  [SMALL_STATE(209)] = 8353,
  [SMALL_STATE(210)] = 8417,
  [SMALL_STATE(211)] = 8481,
  [SMALL_STATE(212)] = 8547,
  [SMALL_STATE(213)] = 8611,
  [SMALL_STATE(214)] = 8675,
  [SMALL_STATE(215)] = 8739,
  [SMALL_STATE(216)] = 8803,
  [SMALL_STATE(217)] = 8867,
  [SMALL_STATE(218)] = 8931,
  [SMALL_STATE(219)] = 8995,
  [SMALL_STATE(220)] = 9059,
  [SMALL_STATE(221)] = 9123,
  [SMALL_STATE(222)] = 9187,
  [SMALL_STATE(223)] = 9251,
  [SMALL_STATE(224)] = 9315,
  [SMALL_STATE(225)] = 9379,
  [SMALL_STATE(226)] = 9443,
  [SMALL_STATE(227)] = 9507,
  [SMALL_STATE(228)] = 9571,
  [SMALL_STATE(229)] = 9635,
  [SMALL_STATE(230)] = 9699,
  [SMALL_STATE(231)] = 9763,
  [SMALL_STATE(232)] = 9827,
  [SMALL_STATE(233)] = 9891,
  [SMALL_STATE(234)] = 9955,
  [SMALL_STATE(235)] = 10019,
  [SMALL_STATE(236)] = 10083,
  [SMALL_STATE(237)] = 10147,
  [SMALL_STATE(238)] = 10211,
  [SMALL_STATE(239)] = 10275,
  [SMALL_STATE(240)] = 10339,
  [SMALL_STATE(241)] = 10403,
  [SMALL_STATE(242)] = 10467,
  [SMALL_STATE(243)] = 10531,
  [SMALL_STATE(244)] = 10595,
  [SMALL_STATE(245)] = 10659,
  [SMALL_STATE(246)] = 10723,
  [SMALL_STATE(247)] = 10787,
  [SMALL_STATE(248)] = 10851,
  [SMALL_STATE(249)] = 10915,
  [SMALL_STATE(250)] = 10979,
  [SMALL_STATE(251)] = 11043,
  [SMALL_STATE(252)] = 11107,
  [SMALL_STATE(253)] = 11171,
  [SMALL_STATE(254)] = 11235,
  [SMALL_STATE(255)] = 11299,
  [SMALL_STATE(256)] = 11363,
  [SMALL_STATE(257)] = 11427,
  [SMALL_STATE(258)] = 11491,
  [SMALL_STATE(259)] = 11555,
  [SMALL_STATE(260)] = 11619,
  [SMALL_STATE(261)] = 11683,
  [SMALL_STATE(262)] = 11747,
  [SMALL_STATE(263)] = 11812,
  [SMALL_STATE(264)] = 11961,
  [SMALL_STATE(265)] = 12110,
  [SMALL_STATE(266)] = 12273,
  [SMALL_STATE(267)] = 12436,
  [SMALL_STATE(268)] = 12499,
  [SMALL_STATE(269)] = 12562,
  [SMALL_STATE(270)] = 12625,
  [SMALL_STATE(271)] = 12688,
  [SMALL_STATE(272)] = 12834,
  [SMALL_STATE(273)] = 12980,
  [SMALL_STATE(274)] = 13022,
  [SMALL_STATE(275)] = 13061,
  [SMALL_STATE(276)] = 13113,
  [SMALL_STATE(277)] = 13165,
  [SMALL_STATE(278)] = 13217,
  [SMALL_STATE(279)] = 13264,
  [SMALL_STATE(280)] = 13311,
  [SMALL_STATE(281)] = 13357,
  [SMALL_STATE(282)] = 13403,
  [SMALL_STATE(283)] = 13449,
  [SMALL_STATE(284)] = 13495,
  [SMALL_STATE(285)] = 13541,
  [SMALL_STATE(286)] = 13587,
  [SMALL_STATE(287)] = 13633,
  [SMALL_STATE(288)] = 13679,
  [SMALL_STATE(289)] = 13725,
  [SMALL_STATE(290)] = 13771,
  [SMALL_STATE(291)] = 13817,
  [SMALL_STATE(292)] = 13863,
  [SMALL_STATE(293)] = 13909,
  [SMALL_STATE(294)] = 13955,
  [SMALL_STATE(295)] = 14001,
  [SMALL_STATE(296)] = 14047,
  [SMALL_STATE(297)] = 14093,
  [SMALL_STATE(298)] = 14139,
  [SMALL_STATE(299)] = 14185,
  [SMALL_STATE(300)] = 14231,
  [SMALL_STATE(301)] = 14279,
  [SMALL_STATE(302)] = 14325,
  [SMALL_STATE(303)] = 14371,
  [SMALL_STATE(304)] = 14413,
  [SMALL_STATE(305)] = 14455,
  [SMALL_STATE(306)] = 14497,
  [SMALL_STATE(307)] = 14539,
  [SMALL_STATE(308)] = 14581,
  [SMALL_STATE(309)] = 14623,
  [SMALL_STATE(310)] = 14665,
  [SMALL_STATE(311)] = 14707,
  [SMALL_STATE(312)] = 14749,
  [SMALL_STATE(313)] = 14791,
  [SMALL_STATE(314)] = 14833,
  [SMALL_STATE(315)] = 14875,
  [SMALL_STATE(316)] = 14917,
  [SMALL_STATE(317)] = 14959,
  [SMALL_STATE(318)] = 15001,
  [SMALL_STATE(319)] = 15028,
  [SMALL_STATE(320)] = 15055,
  [SMALL_STATE(321)] = 15082,
  [SMALL_STATE(322)] = 15104,
  [SMALL_STATE(323)] = 15126,
  [SMALL_STATE(324)] = 15148,
  [SMALL_STATE(325)] = 15184,
  [SMALL_STATE(326)] = 15206,
  [SMALL_STATE(327)] = 15242,
  [SMALL_STATE(328)] = 15278,
  [SMALL_STATE(329)] = 15300,
  [SMALL_STATE(330)] = 15322,
  [SMALL_STATE(331)] = 15344,
  [SMALL_STATE(332)] = 15366,
  [SMALL_STATE(333)] = 15388,
  [SMALL_STATE(334)] = 15410,
  [SMALL_STATE(335)] = 15446,
  [SMALL_STATE(336)] = 15482,
  [SMALL_STATE(337)] = 15517,
  [SMALL_STATE(338)] = 15552,
  [SMALL_STATE(339)] = 15587,
  [SMALL_STATE(340)] = 15608,
  [SMALL_STATE(341)] = 15643,
  [SMALL_STATE(342)] = 15678,
  [SMALL_STATE(343)] = 15713,
  [SMALL_STATE(344)] = 15748,
  [SMALL_STATE(345)] = 15783,
  [SMALL_STATE(346)] = 15818,
  [SMALL_STATE(347)] = 15853,
  [SMALL_STATE(348)] = 15887,
  [SMALL_STATE(349)] = 15923,
  [SMALL_STATE(350)] = 15959,
  [SMALL_STATE(351)] = 15992,
  [SMALL_STATE(352)] = 16025,
  [SMALL_STATE(353)] = 16050,
  [SMALL_STATE(354)] = 16075,
  [SMALL_STATE(355)] = 16100,
  [SMALL_STATE(356)] = 16127,
  [SMALL_STATE(357)] = 16147,
  [SMALL_STATE(358)] = 16171,
  [SMALL_STATE(359)] = 16195,
  [SMALL_STATE(360)] = 16211,
  [SMALL_STATE(361)] = 16235,
  [SMALL_STATE(362)] = 16259,
  [SMALL_STATE(363)] = 16275,
  [SMALL_STATE(364)] = 16299,
  [SMALL_STATE(365)] = 16323,
  [SMALL_STATE(366)] = 16347,
  [SMALL_STATE(367)] = 16367,
  [SMALL_STATE(368)] = 16383,
  [SMALL_STATE(369)] = 16399,
  [SMALL_STATE(370)] = 16423,
  [SMALL_STATE(371)] = 16443,
  [SMALL_STATE(372)] = 16467,
  [SMALL_STATE(373)] = 16491,
  [SMALL_STATE(374)] = 16515,
  [SMALL_STATE(375)] = 16539,
  [SMALL_STATE(376)] = 16555,
  [SMALL_STATE(377)] = 16579,
  [SMALL_STATE(378)] = 16594,
  [SMALL_STATE(379)] = 16613,
  [SMALL_STATE(380)] = 16634,
  [SMALL_STATE(381)] = 16655,
  [SMALL_STATE(382)] = 16678,
  [SMALL_STATE(383)] = 16693,
  [SMALL_STATE(384)] = 16716,
  [SMALL_STATE(385)] = 16731,
  [SMALL_STATE(386)] = 16750,
  [SMALL_STATE(387)] = 16773,
  [SMALL_STATE(388)] = 16792,
  [SMALL_STATE(389)] = 16807,
  [SMALL_STATE(390)] = 16822,
  [SMALL_STATE(391)] = 16836,
  [SMALL_STATE(392)] = 16850,
  [SMALL_STATE(393)] = 16864,
  [SMALL_STATE(394)] = 16878,
  [SMALL_STATE(395)] = 16892,
  [SMALL_STATE(396)] = 16906,
  [SMALL_STATE(397)] = 16920,
  [SMALL_STATE(398)] = 16934,
  [SMALL_STATE(399)] = 16948,
  [SMALL_STATE(400)] = 16962,
  [SMALL_STATE(401)] = 16976,
  [SMALL_STATE(402)] = 16988,
  [SMALL_STATE(403)] = 17003,
  [SMALL_STATE(404)] = 17018,
  [SMALL_STATE(405)] = 17033,
  [SMALL_STATE(406)] = 17046,
  [SMALL_STATE(407)] = 17061,
  [SMALL_STATE(408)] = 17076,
  [SMALL_STATE(409)] = 17092,
  [SMALL_STATE(410)] = 17108,
  [SMALL_STATE(411)] = 17124,
  [SMALL_STATE(412)] = 17140,
  [SMALL_STATE(413)] = 17156,
  [SMALL_STATE(414)] = 17172,
  [SMALL_STATE(415)] = 17188,
  [SMALL_STATE(416)] = 17204,
  [SMALL_STATE(417)] = 17220,
  [SMALL_STATE(418)] = 17236,
  [SMALL_STATE(419)] = 17252,
  [SMALL_STATE(420)] = 17268,
  [SMALL_STATE(421)] = 17284,
  [SMALL_STATE(422)] = 17300,
  [SMALL_STATE(423)] = 17310,
  [SMALL_STATE(424)] = 17323,
  [SMALL_STATE(425)] = 17336,
  [SMALL_STATE(426)] = 17349,
  [SMALL_STATE(427)] = 17362,
  [SMALL_STATE(428)] = 17375,
  [SMALL_STATE(429)] = 17384,
  [SMALL_STATE(430)] = 17397,
  [SMALL_STATE(431)] = 17410,
  [SMALL_STATE(432)] = 17423,
  [SMALL_STATE(433)] = 17436,
  [SMALL_STATE(434)] = 17449,
  [SMALL_STATE(435)] = 17462,
  [SMALL_STATE(436)] = 17475,
  [SMALL_STATE(437)] = 17488,
  [SMALL_STATE(438)] = 17501,
  [SMALL_STATE(439)] = 17514,
  [SMALL_STATE(440)] = 17527,
  [SMALL_STATE(441)] = 17540,
  [SMALL_STATE(442)] = 17553,
  [SMALL_STATE(443)] = 17561,
  [SMALL_STATE(444)] = 17569,
  [SMALL_STATE(445)] = 17579,
  [SMALL_STATE(446)] = 17587,
  [SMALL_STATE(447)] = 17595,
  [SMALL_STATE(448)] = 17605,
  [SMALL_STATE(449)] = 17613,
  [SMALL_STATE(450)] = 17621,
  [SMALL_STATE(451)] = 17631,
  [SMALL_STATE(452)] = 17641,
  [SMALL_STATE(453)] = 17651,
  [SMALL_STATE(454)] = 17659,
  [SMALL_STATE(455)] = 17667,
  [SMALL_STATE(456)] = 17675,
  [SMALL_STATE(457)] = 17683,
  [SMALL_STATE(458)] = 17693,
  [SMALL_STATE(459)] = 17701,
  [SMALL_STATE(460)] = 17708,
  [SMALL_STATE(461)] = 17715,
  [SMALL_STATE(462)] = 17722,
  [SMALL_STATE(463)] = 17729,
  [SMALL_STATE(464)] = 17736,
  [SMALL_STATE(465)] = 17743,
  [SMALL_STATE(466)] = 17750,
  [SMALL_STATE(467)] = 17757,
  [SMALL_STATE(468)] = 17764,
  [SMALL_STATE(469)] = 17771,
  [SMALL_STATE(470)] = 17778,
  [SMALL_STATE(471)] = 17785,
  [SMALL_STATE(472)] = 17792,
  [SMALL_STATE(473)] = 17799,
  [SMALL_STATE(474)] = 17806,
  [SMALL_STATE(475)] = 17813,
  [SMALL_STATE(476)] = 17820,
  [SMALL_STATE(477)] = 17827,
  [SMALL_STATE(478)] = 17834,
  [SMALL_STATE(479)] = 17841,
  [SMALL_STATE(480)] = 17848,
  [SMALL_STATE(481)] = 17855,
  [SMALL_STATE(482)] = 17862,
  [SMALL_STATE(483)] = 17869,
  [SMALL_STATE(484)] = 17876,
  [SMALL_STATE(485)] = 17883,
  [SMALL_STATE(486)] = 17890,
  [SMALL_STATE(487)] = 17897,
  [SMALL_STATE(488)] = 17904,
  [SMALL_STATE(489)] = 17911,
  [SMALL_STATE(490)] = 17918,
  [SMALL_STATE(491)] = 17925,
  [SMALL_STATE(492)] = 17932,
  [SMALL_STATE(493)] = 17939,
  [SMALL_STATE(494)] = 17946,
  [SMALL_STATE(495)] = 17953,
  [SMALL_STATE(496)] = 17960,
  [SMALL_STATE(497)] = 17967,
  [SMALL_STATE(498)] = 17974,
  [SMALL_STATE(499)] = 17981,
  [SMALL_STATE(500)] = 17988,
  [SMALL_STATE(501)] = 17995,
  [SMALL_STATE(502)] = 18002,
  [SMALL_STATE(503)] = 18009,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_commands, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [57] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_command, 1),
  [59] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_command, 1),
  [61] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_command_identifier, 1),
  [63] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_last_command_identifier, 1),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_commands, 1),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_commands_repeat2, 1),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__commands_singleline_repeat2, 1),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dec_number, 1),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dec_number, 1),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_command, 1, .production_id = 1),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_command, 1, .production_id = 1),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_help_command, 1, .production_id = 1),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_help_command, 1, .production_id = 1),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_command, 2),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_command, 2),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_command, 2),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_command, 2),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_command, 1, .production_id = 1),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_command, 1, .production_id = 1),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_command, 1, .production_id = 1),
  [159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_command, 1, .production_id = 1),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_command, 2, .production_id = 2),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_command, 2, .production_id = 2),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_command, 1, .production_id = 1),
  [167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_command, 1, .production_id = 1),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_command, 1, .production_id = 2),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_command, 1, .production_id = 2),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_args, 1),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_args, 1),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(361),
  [182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(82),
  [187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(282),
  [190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(77),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(420),
  [196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(26),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(24),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 1, .production_id = 1),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 1, .production_id = 1),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 1),
  [222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 1),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_command, 1, .production_id = 1),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_command, 1, .production_id = 1),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_args, 1),
  [250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_args, 1),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(102),
  [259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(345),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(20),
  [265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(21),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg, 1),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg, 1),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(335),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, .production_id = 5),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, .production_id = 5),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 3),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 3),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_with_paren, 3, .production_id = 16),
  [295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_with_paren, 3, .production_id = 16),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 3),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 3),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_substitution_arg, 3),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_substitution_arg, 3),
  [305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_identifier, 1),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_identifier, 1),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 2),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 2),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 2),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 2),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(380),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_arg, 1),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_arg, 1),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_concatenation, 2),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_concatenation, 2),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_concatenation, 2),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_concatenation, 2),
  [338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(352),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg, 1),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg, 1),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg_identifier, 1),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg_identifier, 1),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 17),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 17),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_command_identifier, 1),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_command_identifier, 1),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(107),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(28),
  [377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(9),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 1),
  [384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 1),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2), SHIFT_REPEAT(354),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(326),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key, 1),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key, 1),
  [414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 2),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 2),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2), SHIFT_REPEAT(115),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2), SHIFT_REPEAT(473),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(379),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val, 1),
  [439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val, 1),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_arg, 1),
  [447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_arg, 1),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 1),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 1),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_args, 1),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_args, 1),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(143),
  [472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(15),
  [475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(13),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 2),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 2),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2), SHIFT_REPEAT(309),
  [493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2), SHIFT_REPEAT(429),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__command, 1),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 6, .production_id = 13),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 6, .production_id = 13),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 5, .production_id = 13),
  [614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 5, .production_id = 13),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 4, .production_id = 13),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 4, .production_id = 13),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 1),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 1),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_command, 2),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_command, 2),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 3, .production_id = 13),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 3, .production_id = 13),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_command, 2),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_command, 2),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 2, .production_id = 13),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_content, 2, .production_id = 13),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_command, 2),
  [648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_command, 2),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_command, 3),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_command, 3),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_command, 1, .production_id = 1),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_command, 1, .production_id = 1),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_args, 2),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_args, 2),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_command, 3, .production_id = 14),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_command, 3, .production_id = 14),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_command, 3),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe_command, 3),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_file_lines_command, 3),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_file_lines_command, 3),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_command, 3),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_command, 3),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_command, 3),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_command, 3),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_command, 1, .production_id = 3),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_command, 1, .production_id = 3),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_command, 2, .production_id = 9),
  [692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_command, 2, .production_id = 9),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_command, 2, .production_id = 6),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_command, 2, .production_id = 6),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_step_command, 3),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_step_command, 3),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_seek_command, 3),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_seek_command, 3),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_blksz_command, 3),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_blksz_command, 3),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_arch_command, 3),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_arch_command, 3),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_bits_command, 3),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_bits_command, 3),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_nthi_command, 3),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_nthi_command, 3),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_full_content, 2),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_full_content, 2),
  [726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fs_command, 3),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fs_command, 3),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reli_command, 3),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reli_command, 3),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_kuery_command, 3),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_kuery_command, 3),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fd_command, 3),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fd_command, 3),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reg_command, 3),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reg_command, 3),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_file_command, 3),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_file_command, 3),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_string_command, 3),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_string_command, 3),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_value_command, 3),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_value_command, 3),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_hex_command, 3),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_hex_command, 3),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_command, 2, .production_id = 8),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_command, 2, .production_id = 8),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_command, 1, .production_id = 4),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_command, 1, .production_id = 4),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__last_command, 1, .production_id = 1),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__last_command, 1, .production_id = 1),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_command, 2, .production_id = 6),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_command, 2, .production_id = 6),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_command_question, 2, .production_id = 6),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_command_question, 2, .production_id = 6),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_command, 2, .production_id = 7),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_command, 2, .production_id = 7),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpret_arg, 1),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpret_arg, 1),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_content, 1),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_content, 1),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_command, 2, .production_id = 6),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_command, 2, .production_id = 6),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 2, .production_id = 6),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 2, .production_id = 6),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_cmd, 2, .production_id = 6),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_cmd, 2, .production_id = 6),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_register_command, 2),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_register_command, 2),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_args, 2),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_args, 2),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbgmap_command, 2),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbgmap_command, 2),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_iomap_command, 2),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_iomap_command, 2),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_string_command, 2),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_string_command, 2),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_symbol_command, 2),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_symbol_command, 2),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_segments_command, 2),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_segments_command, 2),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_sections_command, 2),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_sections_command, 2),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_import_command, 2),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_import_command, 2),
  [848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 3),
  [850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 3),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_command, 2, .production_id = 6),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_command, 2, .production_id = 6),
  [856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_legacy_quoted_command, 3, .production_id = 10),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_legacy_quoted_command, 3, .production_id = 10),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_instrs_command, 2),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_instrs_command, 2),
  [864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bbs_command, 2),
  [866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_bbs_command, 2),
  [868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 2),
  [870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 2),
  [872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_threads_command, 2),
  [874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_threads_command, 2),
  [876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbts_command, 2),
  [878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbts_command, 2),
  [880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_hit_command, 4, .production_id = 18),
  [882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_hit_command, 4, .production_id = 18),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_command, 4),
  [886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_command, 4),
  [888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_command, 4),
  [890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_command, 4),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_command, 4),
  [894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_command, 4),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fromto_command, 4),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fromto_command, 4),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbtb_command, 2),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbtb_command, 2),
  [904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbta_command, 2),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbta_command, 2),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 12),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 12),
  [912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_enable_command, 2, .production_id = 1),
  [914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_enable_command, 2, .production_id = 1),
  [916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_arged_command, 2, .production_id = 6),
  [918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__math_arged_command, 2, .production_id = 6),
  [920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_command, 3, .production_id = 11),
  [922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_command, 3, .production_id = 11),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_command, 2, .production_id = 6),
  [926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_command, 2, .production_id = 6),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_command, 2, .production_id = 6),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_command, 2, .production_id = 6),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 12),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 12),
  [936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__Cf_args, 2),
  [938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__Cf_args, 2),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 19),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 19),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_arged_command, 2, .production_id = 6),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_arged_command, 2, .production_id = 6),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call_content, 2),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call_content, 2),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_disable_command, 2, .production_id = 1),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_disable_command, 2, .production_id = 1),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_command, 3),
  [960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_command, 3),
  [962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_offsetssizes_command, 3),
  [964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_offsetssizes_command, 3),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_commands_repeat1, 2),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_commands_repeat1, 2),
  [1004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_commands_repeat1, 2), SHIFT_REPEAT(273),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__commands_singleline_repeat1, 2),
  [1009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__commands_singleline_repeat1, 2),
  [1011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__commands_singleline_repeat1, 2), SHIFT_REPEAT(274),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(364),
  [1025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(329),
  [1028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(297),
  [1031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(322),
  [1034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(329),
  [1037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(410),
  [1040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(8),
  [1043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(25),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(334),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(382),
  [1092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(344),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(382),
  [1098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(27),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(22),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(353),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 1),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 1),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_search_identifier, 1),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_search_identifier, 1),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 2),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 2),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2),
  [1213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(376),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(376),
  [1219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(17),
  [1222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(18),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(324),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirect_command, 3, .production_id = 15),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_commands, 2),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_commands_repeat2, 2),
  [1246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_commands_repeat2, 2), SHIFT_REPEAT(7),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_commands, 3),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2),
  [1277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(412),
  [1280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(412),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commands_singleline, 2),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commands_singleline, 3),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__commands_singleline, 1),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__commands_singleline_repeat2, 2),
  [1325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__commands_singleline_repeat2, 2), SHIFT_REPEAT(34),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_content_repeat1, 2),
  [1330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_content_repeat1, 2), SHIFT_REPEAT(36),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__commands_singleline_repeat2, 2), SHIFT_REPEAT(32),
  [1342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(327),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1431] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rzcmd_external_scanner_create(void);
void tree_sitter_rzcmd_external_scanner_destroy(void *);
bool tree_sitter_rzcmd_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rzcmd_external_scanner_serialize(void *, char *);
void tree_sitter_rzcmd_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_rzcmd(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_rzcmd_external_scanner_create,
      tree_sitter_rzcmd_external_scanner_destroy,
      tree_sitter_rzcmd_external_scanner_scan,
      tree_sitter_rzcmd_external_scanner_serialize,
      tree_sitter_rzcmd_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
